

--[[-
		Micro mission:	The pickup

		Creates a money pickup with a radar blip and route
		Mission is passed when pickup is collected

--]]



-- 'Settings'
mission_name = "The Pickup"
mission_reward = 200000
pickup_amount = 100
money_location = { x = -526.43951416016, y = 1483.302734375}

-- Vars
state = 0
player_ped = nil
player_idx = nil
money_blip = nil
money_pickup = nil

-- Helper functions
function get_player()
	local bla = GET_PLAYER_ID().i
 	local pi = CONVERT_INT_TO_PLAYERINDEX(bla)
	return pi.p;
end

function get_player_ped()
 	local ped = {}
 	GET_PLAYER_CHAR(player_idx, ped)
 	return ped.p
end

function get_ground_z(x, y, z)
 	local tmpz = 0
 	local zref = {}
	SETTIMERA(0)
	while (tmpz == 0 and TIMERA().u < 5000) do
 		GET_GROUND_Z_FOR_3D_COORD(x, y, z, zref)
 		tmpz = zref.f
 		Wait(0)
 	end
	if (tmpz == 0) then
		Log("cannot get z")
		return 0.1
	end
	return tmpz
end

 -- mission functions

function start_mission()
	local pr = {}
 	local br = {}
 	money_pickup.z = get_ground_z(money_pickup.x, money_pickup.y, 1000.1)
	player_idx = get_player()
 	player_ped = get_player_ped()
 	CREATE_MONEY_PICKUP(money_location.x, money_location.y, money_pickup.z, pickup_amount, true, pr)
 	money_pickup = pr.p
 	ADD_BLIP_FOR_PICKUP(money_pickup, br)
 	money_blip = br.p
	SET_ROUTE(money_blip, 1)
end

function mission_cleanup()
	if (DOES_BLIP_EXIST(money_blip).b) then
		SET_ROUTE(money_blip, 0)
		REMOVE_BLIP(money_blip)
	end
	if (DOES_PICKUP_EXIST(money_pickup).b) then
		REMOVE_PICKUP(money_pickup)
	end

end

function mission_success()
 	local done = false
 	Log("mission success")
 	SETTIMERA(0)

 	-- keep trying for 20 secs
 	while ((not done) and (TIMERA().u < 20000)) do
 		if (CAN_START_MISSION_PASSED_TUNE().b) then
 			TRIGGER_MISSION_COMPLETE_AUDIO(53)
			ADD_SCORE(player_idx, mission_reward)
 			done = true
 		end
 		Wait(50)
 	end
 	if (not done) then
 		Log("Cannot pass mission")
 	end
end

function tick()
 	if (HAS_PLAYER_COLLECTED_PICKUP(player_idx, money_pickup).b) then
 		mission_success()
 		Log("Mission '" .. mission_name .. "' successfully completed")
		return true;
 	end
	return false;
end

function main()
 	Log("Starting mission: " .. mission_name)
 	PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING", mission_name, 3000, 1)
 	start_mission()
 	while (IsThreadAlive()) do
 		if (GetKey(VK_F10)) then
			mission_cleanup()
 			return
 		end

		if tick() then
			mission_cleanup()
			return
		end

 		Wait(100)
 	end
end

main()

