/*****************************************************************************\

  Copyright (C) 2009, Aru <oneforaru at gmail dot com>

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Please see ScriptHook-License.txt for information on how this source/header
  file is licensed as part of the ScriptHook SDK.

\*****************************************************************************/

#pragma once

namespace Scripting
{
    enum NativeHashes
    {
        NATIVE_GET_SORTED_NETWORK_RESTART_NODE = 0x2b59a,
        NATIVE_ADD_TICKER_TO_PREVIOUS_BRIEF_WITH_UNDERSCORE = 0x12a4cf,
        NATIVE_EXTINGUISH_CHAR_FIRE = 0x1f5da5,
        NATIVE_COS = 0x238fe9,
        NATIVE_ADD_PED_TO_CINEMATOGRAPHY_AI = 0x49ac10,
        NATIVE_DISPLAY_CASH = 0x49df83,
        NATIVE_SET_CHAR_CANT_BE_DRAGGED_OUT = 0x594267,
        NATIVE_GET_CAR_PITCH = 0x82722e,
        NATIVE_CHANGE_TERRITORY_BLIP_SCALE = 0xba6723,
        NATIVE_SET_FOLLOW_VEHICLE_CAM_OFFSET = 0xbeedb4,
        NATIVE_SWITCH_PED_TO_RAGDOLL_WITH_FALL = 0xc566b0,
        NATIVE_SET_SWIM_SPEED = 0xce7c16,
        NATIVE_SET_EVENT_PRECEDENCE = 0xd1632a,
        NATIVE_ADD_FOLLOW_NAVMESH_TO_PHONE_TASK = 0xd7303f,
        NATIVE_ADD_STRING_TO_NEWS_SCROLLBAR = 0xddfd22,
        NATIVE_GET_OVERRIDE_NO_SPRINTING_ON_PHONE_IN_MULTIPLAYER = 0xf154e3,
        NATIVE_ADD_TO_HTML_SCRIPT_OBJECT = 0x1015507,
        NATIVE_SET_NO_RESPRAYS = 0x116ebdf,
        NATIVE_SET_CAR_STAY_IN_SLOW_LANE = 0x1172f2b,
        NATIVE_WAITUNWARPED = 0x1185f9b,
        NATIVE_STORE_CAR_CHAR_IS_IN_NO_SAVE = 0x139d04a,
        NATIVE_EXTINGUISH_CAR_FIRE = 0x1795416,
        NATIVE_SET_CHAR_DROWNS_IN_SINKING_VEHICLE = 0x17ad3c3,
        NATIVE_IS_USING_CONTROLLER = 0x19064ed,
        NATIVE_TASK_GO_TO_OBJECT = 0x1bacd08,
        NATIVE_GET_NUMBER_LINES_WITH_LITERAL_STRINGS = 0x1cbfdff,
        NATIVE_PLAYER_WANTS_TO_JOIN_NETWORK_GAME = 0x1f5c0cd,
        NATIVE_REMOVE_UPSIDEDOWN_CAR_CHECK = 0x20a61f7,
        NATIVE_UNLOCK_GENERIC_NEWS_STORY = 0x21ef78c,
        NATIVE_POINT_FIXED_CAM_AT_OBJ = 0x26a23ad,
        NATIVE_IS_CAR_MODEL = 0x2a4ae3b,
        NATIVE_GET_PLAYER_MAX_ARMOUR = 0x2a50657,
        NATIVE_SET_OBJECT_INITIAL_ROTATION_VELOCITY = 0x2ba3c7e,
        NATIVE_GET_CAR_DEFORMATION_AT_POS = 0x2bea0f5,
        NATIVE_SET_MOBILE_RING_TYPE = 0x2c4e1d2,
        NATIVE_SWITCH_PED_TO_ANIMATED = 0x2fa5c99,
        NATIVE_NETWORK_SHOW_PLAYER_FEEDBACK_UI = 0x3380fc1,
        NATIVE_SET_HELI_BLADES_FULL_SPEED = 0x33a9408,
        NATIVE_GET_MAXIMUM_NUMBER_OF_PASSENGERS = 0x3478e46,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_NUM_PARKED_CARS = 0x3550e05,
        NATIVE_TASK_JUMP = 0x356e3ce,
        NATIVE_DRAW_SPRITE_PHOTO = 0x3578f6e,
        NATIVE_ADD_WIDGET_TOGGLE = 0x3a1e420,
        NATIVE_IS_CHAR_IN_MODEL = 0x4036010,
        NATIVE_LOAD_SETTINGS = 0x40bbccf,
        NATIVE_GET_SORTED_NETWORK_RESTART_NODE_USING_GROUP_LIST = 0x40d4faa,
        NATIVE_IS_VEHICLE_EXTRA_TURNED_ON = 0x42098b5,
        NATIVE_SEARCH_CRITERIA_REJECT_PEDS_WITH_FLAG_TRUE = 0x44ec539,
        NATIVE_NETWORK_STORE_GAME_CONFIG = 0x4504805,
        NATIVE_SECUROM_SPOT_CHECK1 = 0x45c6f56,
        NATIVE_IS_SNIPER_BULLET_IN_AREA = 0x483715c,
        NATIVE_GET_STRING_WIDTH_WITH_STRING = 0x48a2e6c,
        NATIVE_SET_CHAR_COORDINATES = 0x49727e0,
        NATIVE_IS_OBJECT_IN_ANGLED_AREA_2D = 0x49b0477,
        NATIVE_IS_COP_PED_IN_AREA_3D_NO_SAVE = 0x4c705a6,
        NATIVE_DISPLAY_TEXT_WITH_TWO_LITERAL_STRINGS = 0x4da9df6,
        NATIVE_SET_PLAYER_CONTROL_FOR_NETWORK = 0x4e33a0a,
        NATIVE_REQUEST_INTERIOR_MODELS = 0x514857a,
        NATIVE_GET_CURRENT_WEATHER_FULL = 0x56a57b0,
        NATIVE_START_MOBILE_PHONE_CALLING = 0x58921a9,
        NATIVE_PLAY_SOUND_FROM_POSITION = 0x5bc72d7,
        NATIVE_HAS_CAR_BEEN_DAMAGED_BY_WEAPON = 0x5c65189,
        NATIVE_SET_CHAR_ANIM_CURRENT_TIME = 0x5ce61f0,
        NATIVE_GET_CAR_UPRIGHT_VALUE = 0x5d50f57,
        NATIVE_IS_SCRIPT_FIRE_EXTINGUISHED = 0x5efdb7c,
        NATIVE_SWITCH_ARROW_ABOVE_BLIPPED_PICKUPS = 0x5f94b87,
        NATIVE_TASK_MOBILE_CONVERSATION = 0x60da456,
        NATIVE_GET_CHAR_MELEE_ACTION_FLAG0 = 0x6254a30,
        NATIVE_SET_CINEMATIC_BUTTON_ENABLED = 0x63c4508,
        NATIVE_SET_CAM_ACTIVE = 0x64659c2,
        NATIVE_SET_PETROL_TANK_WEAKPOINT = 0x64f7ac3,
        NATIVE_FIX_CAR_TYRE = 0x65d8cf4,
        NATIVE_FORCE_FULL_VOICE = 0x68485d6,
        NATIVE_CLEAR_THIS_PRINT = 0x6878327,
        NATIVE_SET_CAR_TRACTION = 0x692e37a,
        NATIVE_IS_PLAYER_IN_INFO_ZONE = 0x6a03fa4,
        NATIVE_SET_OBJECT_HEALTH = 0x6ace668,
        NATIVE_GET_CAR_ROLL = 0x6b074f4,
        NATIVE_POINT_CAM_AT_VEHICLE = 0x6de50bf,
        NATIVE_SET_CUTSCENE_EXTRA_ROOM_POS = 0x6eb9a03,
        NATIVE_NETWORK_JOIN_GAME = 0x6f47f40,
        NATIVE_IS_REPLAY_SYSTEM_ACTIVE = 0x700a933,
        NATIVE_FORCE_PED_PINNED_DOWN = 0x7130aaa,
        NATIVE_GET_FLOAT_STAT = 0x731759e,
        NATIVE_SUPPRESS_FADE_IN_AFTER_DEATH_ARREST = 0x7441ae5,
        NATIVE_SET_CHAR_DROWNS_IN_WATER = 0x7622f98,
        NATIVE_SET_DRAW_PLAYER_COMPONENT = 0x76f4216,
        NATIVE_REMOVE_COVER_POINT = 0x776888b,
        NATIVE_SET_CAR_RANDOM_ROUTE_SEED = 0x7815895,
        NATIVE_SET_CHAR_MELEE_ACTION_FLAG1 = 0x7a6dbb7,
        NATIVE_SET_ARMOUR_PICKUP_NETWORK_REGEN_TIME = 0x7ca5a73,
        NATIVE_SET_OBJECT_PROOFS = 0x7ea4940,
        NATIVE_IS_CHAR_PLAYING_ANIM = 0x7f23d94,
        NATIVE_CAM_SEQUENCE_START = 0x7f6ef6d,
        NATIVE_IS_MONEY_PICKUP_AT_COORDS = 0x7ff9cea,
        NATIVE_IS_ATTACHED_PLAYER_HEADING_ACHIEVED = 0x804ee1b,
        NATIVE_SET_PLAYERS_DROP_MONEY_IN_NETWORK_GAME = 0x806204b,
        NATIVE_BREAK_CAR_DOOR = 0x85a6405,
        NATIVE_PRINTVECTOR = 0x85f31fb,
        NATIVE_IS_CHAR_INJURED = 0x8a5bad7,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEMP3 = 0x8b1f924,
        NATIVE_HAS_FRAGMENT_ROOT_OF_CLOSEST_OBJECT_OF_TYPE_BEEN_DAMAGED = 0x8df011c,
        NATIVE_SWITCH_GARBAGE_TRUCKS = 0x8f35ea5,
        NATIVE_SET_GROUP_FORMATION = 0x8fac739,
        NATIVE_SET_PED_STOP_CLONING = 0x90340a6,
        NATIVE_GET_GROUP_CHAR_DUCKS_WHEN_AIMED_AT = 0x90e9103,
        NATIVE_GET_ROOT_CAM = 0x9399528,
        NATIVE_NETWORK_START_SESSION = 0x93fb4c8,
        NATIVE_GET_NUMBER_OF_INJURED_PEDS_IN_RANGE = 0x95916c5,
        NATIVE_IS_CAM_SHAKING = 0x961fd9b,
        NATIVE_GET_TEXTURE_RESOLUTION = 0x96daa4d,
        NATIVE_SET_AMBIENT_PLANES_SPEED_MULTIPLIER = 0x997576a,
        NATIVE_SET_CHAR_MOVE_ANIM_SPEED_MULTIPLIER = 0x9a48126,
        NATIVE_SET_MOBILE_PHONE_SCALE = 0x9bcf1be,
        NATIVE_ATTACH_PED_TO_SHIMMY_EDGE = 0x9e6b0c0,
        NATIVE_GET_CAM_FAR_CLIP = 0x9f119b8,
        NATIVE_TASK_ACHIEVE_HEADING = 0xa0e9b42,
        NATIVE_DISABLE_GPS = 0xa16e426,
        NATIVE_IS_VEH_WINDOW_INTACT = 0xa184afa,
        NATIVE_GET_STRING_FROM_STRING = 0xa2fec42,
        NATIVE_GET_PAD_STATE = 0xa88c664,
        NATIVE_FORCE_CHAR_TO_DROP_WEAPON = 0xaa791b3,
        NATIVE_GET_WEB_PAGE_LINK_HREF = 0xab4e18f,
        NATIVE_ATTACH_OBJECT_TO_CAR_PHYSICALLY = 0xabca3dd,
        NATIVE_GET_MAX_AMMO = 0xb294796,
        NATIVE_IS_PC_USING_JOYPAD = 0xb40053a,
        NATIVE_PLAY_AUDIO_EVENT_FROM_VEHICLE = 0xb7dc5c8,
        NATIVE_HAS_STREAMED_TXD_LOADED = 0xb955aaa,
        NATIVE_CREATE_RANDOM_CAR_FOR_CAR_PARK = 0xba883b6,
        NATIVE_LOCATE_CHAR_ON_FOOT_CHAR_2D = 0xbbba114,
        NATIVE_HAS_PICKUP_BEEN_COLLECTED = 0xbe5cced,
        NATIVE_GIVE_PED_HELMET_WITH_OPTS = 0xbec2729,
        NATIVE_UNPAUSE_GAME = 0xbf2cd82,
        NATIVE_GENERATE_RANDOM_INT = 0xc03b090,
        NATIVE_LOCATE_CHAR_ANY_MEANS_CAR_3D = 0xc048594,
        NATIVE_GET_CURRENT_CHAR_WEAPON = 0xc058ff9,
        NATIVE_ACTIVATE_SAVE_MENU = 0xc0b7bc8,
        NATIVE_LOAD_WEB_PAGE = 0xc1058c6,
        NATIVE_SET_MSG_FOR_LOADING_SCREEN = 0xc128376,
        NATIVE_TASK_HELI_MISSION = 0xc143e97,
        NATIVE_SET_GLOBAL_RENDER_FLAGS = 0xc24725c,
        NATIVE_CREATE_CHAR_AS_PASSENGER = 0xc3394ea,
        NATIVE_PLAY_AUDIO_EVENT_FROM_OBJECT = 0xc5db6a5,
        NATIVE_ADD_STUCK_CAR_CHECK = 0xc5dcae4,
        NATIVE_SET_GARAGE_LEAVE_CAMERA_ALONE = 0xcc40109,
        NATIVE_SET_GUNSHOT_SENSE_RANGE_FOR_RIOT2 = 0xccf8f0b,
        NATIVE_ANCHOR_BOAT = 0xcd3e50b,
        NATIVE_SET_RETURN_TO_FILTER_MENU = 0xcd98cc2,
        NATIVE_NETWORK_CLEAR_INVITE_ARRIVAL = 0xce1cb74,
        NATIVE_SET_BLIP_MARKER_LONG_DISTANCE = 0xd0c1675,
        NATIVE_SET_CAM_FAR_CLIP = 0xd23e381,
        NATIVE_POP_CAR_BOOT = 0xd2e684a,
        NATIVE_SET_GROUP_MEMBER = 0xd3dda88,
        NATIVE_DELETE_CAR = 0xd4680b4,
        NATIVE_REQUEST_CONTROL_OF_NETWORK_ID = 0xd4c442a,
        NATIVE_USING_STANDARD_CONTROLS = 0xd60d5fe,
        NATIVE_SET_ALWAYS_DISPLAY_WEAPON_PICKUP_MESSAGE = 0xd8c9d8a,
        NATIVE_SET_TIME_ONE_DAY_BACK = 0xdb2a037,
        NATIVE_GET_BLIP_INFO_ID_PED_INDEX = 0xdd57007,
        NATIVE_EXTEND_PATROL_ROUTE = 0xdde15ac,
        NATIVE_IS_CHAR_IN_ANY_PLANE = 0xe089aa2,
        NATIVE_MARK_OBJECT_AS_NO_LONGER_NEEDED = 0xe1532d0,
        NATIVE_SET_CHAR_IN_CUTSCENE = 0xe3659e6,
        NATIVE_HAS_NETWORK_PLAYER_LEFT_GAME = 0xe4b4841,
        NATIVE_ADD_BLIP_FOR_OBJECT = 0xe5372ec,
        NATIVE_UNOBFUSCATE_INT = 0xe74eeac,
        NATIVE_TASK_CAR_DRIVE_TO_COORD_NOT_AGAINST_TRAFFIC = 0xead4c78,
        NATIVE_CHANGE_PICKUP_BLIP_SPRITE = 0xeadb4ae,
        NATIVE_GET_CURRENT_EPISODE = 0xece0b08,
        NATIVE_ENABLE_FANCY_WATER = 0xee22f41,
        NATIVE_GRAB_ENTITY_ON_ROPE_FOR_OBJECT = 0xf290126,
        NATIVE_DOES_WEB_PAGE_EXIST = 0xf52fd85,
        NATIVE_NETWORK_IS_NETWORK_AVAILABLE = 0xf56413e,
        NATIVE_REMOVE_CHAR_DEFENSIVE_AREA = 0xf82a06e,
        NATIVE_SET_WANTED_MULTIPLIER = 0xf964d27,
        NATIVE_GET_NEXT_CLOSEST_CAR_NODE_WITH_HEADING_ON_ISLAND = 0xfaa7abd,
        NATIVE_CLEAR_OBJECT_LAST_DAMAGE_ENTITY = 0xfab3aa7,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_PERCENTAGE_COPS = 0xfd2db50,
        NATIVE_NETWORK_GET_UNACCEPTED_INVITE_EPISODE = 0xff5356e,
        NATIVE_IS_VEHICLE_ON_ALL_WHEELS = 0x10089f8e,
        NATIVE_HAS_CHAR_ANIM_FINISHED = 0x100bc2c0,
        NATIVE_GET_CUTSCENE_SECTION_PLAYING = 0x1026f0d6,
        NATIVE_DONT_REMOVE_CHAR = 0x102eead5,
        NATIVE_GET_ASCII_JUST_PRESSED = 0x10535b5e,
        NATIVE_GET_FREE_CAM = 0x1060fec3,
        NATIVE_ATTACH_PED_TO_OBJECT = 0x107fdc53,
        NATIVE_IS_MODEL_IN_CDIMAGE = 0x1094782f,
        NATIVE_IS_AMBIENT_SPEECH_DISABLED = 0x109d1f89,
        NATIVE_ADD_EXPLOSION = 0x10af5258,
        NATIVE_IS_CHAR_FACING_CHAR = 0x10c14e5b,
        NATIVE_DESTROY_ALL_CAMS = 0x10c151ce,
        NATIVE_SKIP_RADIO_FORWARD = 0x10d36630,
        NATIVE_NETWORK_SET_TEXT_CHAT_RECIPIENTS = 0x10d67c87,
        NATIVE_SET_CHAR_NEVER_TARGETTED = 0x10de46ec,
        NATIVE_TASK_ENTER_CAR_AS_DRIVER = 0x10efbbea,
        NATIVE_GET_NUM_CAR_COLOURS = 0x10f08bd4,
        NATIVE_IS_THIS_MODEL_A_BOAT = 0x10f6085c,
        NATIVE_DONT_SUPPRESS_ANY_CAR_MODELS = 0x10f90fc5,
        NATIVE_VEHICLE_CAN_BE_TARGETTED_BY_HS_MISSILE = 0x112d69ad,
        NATIVE_IS_GARAGE_OPEN = 0x112eb372,
        NATIVE_MAKE_PLAYER_GANG_REAPPEAR = 0x11589fee,
        NATIVE_BLOCK_COWERING_IN_COVER = 0x1193491d,
        NATIVE_REMOVE_PROJTEX_FROM_OBJECT = 0x119a0327,
        NATIVE_NETWORK_ALL_PARTY_MEMBERS_PRESENT = 0x11a857e0,
        NATIVE_LOAD_COMBAT_DECISION_MAKER = 0x11ae4ea7,
        NATIVE_NETWORK_DISPLAY_HOST_GAMER_CARD = 0x11b7dbe1,
        NATIVE_CLEAR_SHAKE_PLAYERPAD_WHEN_CONTROLLER_DISABLED = 0x11cab69a,
        NATIVE_SET_PED_PATH_MAY_DROP_FROM_HEIGHT = 0x11d93da1,
        NATIVE_IS_BLIP_SHORT_RANGE = 0x1226765a,
        NATIVE_GET_ENGINE_HEALTH = 0x1236bace,
        NATIVE_REMOVE_IPL_DISCREETLY = 0x125b1802,
        NATIVE_GET_POSITION_OF_ANALOGUE_STICKS = 0x12713a99,
        NATIVE_IS_OBJECT_REASSIGNMENT_IN_PROGRESS = 0x127ee29c,
        NATIVE_GET_DEAD_CHAR_COORDINATES = 0x1298f033,
        NATIVE_IS_CHAR_SITTING_IN_CAR = 0x12a0c9c2,
        NATIVE_ADD_NAVMESH_REQUIRED_REGION = 0x12b086ea,
        NATIVE_SET_STAT_FRONTEND_NEVER_VISIBLE = 0x12c176f4,
        NATIVE_SET_CHAR_ONLY_DAMAGED_BY_RELATIONSHIP_GROUP = 0x12cfd4f9,
        NATIVE_PLANE_STARTS_IN_AIR = 0x12e0ca3e,
        NATIVE_HIGH_FALL_SCREAM = 0x12f4a254,
        NATIVE_CLEAR_CHAR_DECISION_MAKER_EVENT_RESPONSE = 0x130801b5,
        NATIVE_SET_PLAYERS_CAN_BE_IN_SEPARATE_CARS = 0x1318fbaf,
        NATIVE_GET_PED_GROUP_INDEX = 0x134e0785,
        NATIVE_HAS_ACHIEVEMENT_BEEN_PASSED = 0x136a5be9,
        NATIVE_SET_HELP_MESSAGE_BOX_SIZE = 0x138d7bb9,
        NATIVE_IS_GAME_KEYBOARD_NAV_DOWN_PRESSED = 0x139e0d04,
        NATIVE_LOCATE_CAR_3D = 0x13b80e94,
        NATIVE_SET_PLAYER_CAN_USE_COVER = 0x13cafafa,
        NATIVE_SET_NETWORK_JOIN_FAIL = 0x13d7dea2,
        NATIVE_GET_NTH_CLOSEST_CAR_NODE_FAVOUR_DIRECTION = 0x13daf536,
        NATIVE_SEND_NM_MESSAGE = 0x13debc94,
        NATIVE_GET_CHAR_MELEE_ACTION_FLAG1 = 0x13ec65be,
        NATIVE_SAVE_INT_TO_DEBUG_FILE = 0x13f0037d,
        NATIVE_IS_PLAYER_DEAD = 0x140ca5a8,
        NATIVE_NETWORK_SET_SCRIPT_LOBBY_STATE = 0x142b7132,
        NATIVE_IS_CHAR_IN_ANY_POLICE_VEHICLE = 0x143d8253,
        NATIVE_SET_VEHICLE_IS_CONSIDERED_BY_PLAYER = 0x14413319,
        NATIVE_SQRT = 0x145c7701,
        NATIVE_IS_CAM_SEQUENCE_COMPLETE = 0x14609619,
        NATIVE_HANDLE_AUDIO_ANIM_EVENT = 0x14a01d6e,
        NATIVE_CLEAR_CHAR_SECONDARY_TASK = 0x14a1c15c,
        NATIVE_SET_TEXT_BACKGROUND = 0x14adad25,
        NATIVE_EVOLVE_PTFX = 0x14baaf08,
        NATIVE_RENDER_LOADING_CLOCK = 0x14c99ca6,
        NATIVE_REVIVE_INJURED_PED = 0x14d3e6e3,
        NATIVE_GET_RADAR_VIEWPORT_ID = 0x14f3866a,
        NATIVE_HAS_PLAYER_DAMAGED_AT_LEAST_ONE_PED = 0x14f52453,
        NATIVE_GET_NEXT_CLOSEST_CAR_NODE_FAVOUR_DIRECTION = 0x152449e8,
        NATIVE_ADD_PICKUP_TO_INTERIOR_ROOM_BY_KEY = 0x15623096,
        NATIVE_SET_ONSCREEN_COUNTER_FLASH_WHEN_FIRST_DISPLAYED = 0x1563b30e,
        NATIVE_SET_CHAR_ALL_ANIMS_SPEED = 0x159681a4,
        NATIVE_ABORT_ALL_GARAGE_ACTIVITY = 0x159bdc1e,
        NATIVE_ADD_PED_QUEUE = 0x15a759ea,
        NATIVE_SET_MESSAGES_WAITING = 0x15a9c493,
        NATIVE_SET_CHAR_MELEE_ACTION_FLAG2 = 0x15f0784a,
        NATIVE_IS_CAR_STOPPED = 0x15f1c152,
        NATIVE_DETACH_OBJECT_NO_COLLIDE = 0x16010c8e,
        NATIVE_SET_THIS_MACHINE_RUNNING_SERVER_SCRIPT = 0x1626c5c3,
        NATIVE_SET_PLAYER_ICON_COLOUR = 0x1630b64c,
        NATIVE_DISPLAY_GRIME_THIS_FRAME = 0x1667b74b,
        NATIVE_ADD_BLIP_FOR_PICKUP = 0x16693c3a,
        NATIVE_ADD_NEEDED_AT_POSN = 0x16ab8b91,
        NATIVE_NETWORK_CHANGE_EXTENDED_GAME_CONFIG = 0x16aebe61,
        NATIVE_SET_CHAR_SHOOT_RATE = 0x16bc65ac,
        NATIVE_GET_CHAR_ANIM_EVENT_TIME = 0x16c5a66c,
        NATIVE_GET_RANDOM_CAR_NODE = 0x16f68b88,
        NATIVE_RESET_NUM_OF_MODELS_KILLED_BY_PLAYER = 0x1708e0b9,
        NATIVE_START_KILL_FRENZY = 0x1719d732,
        NATIVE_IS_CAR_STOPPED_IN_AREA_2D = 0x17550bb2,
        NATIVE_ALLOW_NETWORK_POPULATION_GROUP_CYCLING = 0x175822c2,
        NATIVE_REGISTER_ODDJOB_MISSION_PASSED = 0x17737728,
        NATIVE_SET_UP_TRIP_SKIP = 0x17783876,
        NATIVE_GET_MOBILE_PHONE_ROTATION = 0x17a29f23,
        NATIVE_TASK_PAUSE = 0x17a64668,
        NATIVE_CAM_RESTORE_JUMPCUT = 0x17caf68a,
        NATIVE_TASK_CHAR_SLIDE_TO_COORD_HDG_RATE = 0x17ce92b9,
        NATIVE_SET_INSTANT_WIDESCREEN_BORDERS = 0x17d497d3,
        NATIVE_GET_PHYSICAL_SCREEN_RESOLUTION = 0x17e8245b,
        NATIVE_TURN_OFF_RADIOHUD_IN_LOBBY = 0x17edcc99,
        NATIVE_LOOK_AT_NEARBY_ENTITY_WITH_SPECIAL_ATTRIBUTE = 0x180e6d72,
        NATIVE_PLACE_OBJECT_RELATIVE_TO_CAR = 0x181f7278,
        NATIVE_NETWORK_SET_HEALTH_RETICULE_OPTION = 0x18319aa8,
        NATIVE_SET_CAR_NOT_DAMAGED_BY_RELATIONSHIP_GROUP = 0x18345e96,
        NATIVE_REMOVE_CHAR_ELEGANTLY = 0x18604c77,
        NATIVE_GIVE_PED_HELMET = 0x1862a461,
        NATIVE_IS_CHAR_ARMED = 0x1883d91e,
        NATIVE_GET_LENGTH_OF_STRING_WITH_THIS_TEXT_LABEL_INS_NUM = 0x1888aa8c,
        NATIVE_IS_CAM_PROPAGATING = 0x188c0d16,
        NATIVE_SET_ALL_MOTION_CONTROL_PREFERENCES_ON_OFF = 0x18c0048f,
        NATIVE_CLONE_CAM = 0x18ca08b3,
        NATIVE_DISPLAY_HELP_TEXT_THIS_FRAME = 0x18e3360a,
        NATIVE_COUNT_PICKUPS_OF_TYPE = 0x19220ce2,
        NATIVE_IS_CHAR_TRYING_TO_ENTER_A_LOCKED_CAR = 0x1932b71e,
        NATIVE_GET_CLOSEST_CAR_NODE_FAVOUR_DIRECTION = 0x1949a4ba,
        NATIVE_IS_CHAR_IN_AIR = 0x19570e25,
        NATIVE_IS_AMBIENT_SPEECH_PLAYING = 0x1972e8aa,
        NATIVE_SET_DEAD_PEDS_DROP_WEAPONS = 0x197472b9,
        NATIVE_GET_CLOSEST_CHAR = 0x19ead428,
        NATIVE_DESTROY_MOBILE_PHONE = 0x1a65037b,
        NATIVE_NETWORK_GET_PLAYER_ID_OF_NEXT_TEXT_CHAT = 0x1a699bda,
        NATIVE_SET_WIDESCREEN_BORDERS = 0x1a75dc9a,
        NATIVE_ADD_WIDGET_SLIDER = 0x1a76e4b9,
        NATIVE_CLOSE_SEQUENCE_TASK = 0x1a7cebd0,
        NATIVE_GET_INT_STAT = 0x1a800197,
        NATIVE_IS_IN_SPECTATOR_MODE = 0x1a8853b0,
        NATIVE_OBFUSCATE_STRING = 0x1ab53f10,
        NATIVE_PLAY_AUDIO_EVENT_FROM_PED = 0x1ab792da,
        NATIVE_NETWORK_GET_TEAM_OPTION = 0x1ac95db8,
        NATIVE_PED_QUEUE_CONSIDER_PEDS_WITH_FLAG_FALSE = 0x1b01f931,
        NATIVE_DECREMENT_INT_STAT = 0x1b0482d3,
        NATIVE_CREATE_HTML_VIEWPORT = 0x1b1e5bbc,
        NATIVE_SET_TEXT_DRAW_BEFORE_FADE = 0x1b2ba35e,
        NATIVE_SET_FOLLOW_PED_PITCH_LIMIT_UP = 0x1b2f04df,
        NATIVE_DRAW_CHECKPOINT = 0x1b58b5c7,
        NATIVE_SET_CAR_IN_CUTSCENE = 0x1b749234,
        NATIVE_CONVERT_THEN_ADD_STRING_TO_HTML_SCRIPT_OBJECT = 0x1b9cf010,
        NATIVE_SET_UP_TRIP_SKIP_AFTER_MISSION = 0x1ba5454f,
        NATIVE_SET_OBJECT_QUATERNION = 0x1bac5dc1,
        NATIVE_SAVE_STRING_TO_DEBUG_FILE = 0x1bc43e17,
        NATIVE_IS_CHAR_IN_ANGLED_AREA_2D = 0x1bc6f044,
        NATIVE_SET_INTERP_FROM_SCRIPT_TO_GAME = 0x1be309dd,
        NATIVE_GET_OBJECT_HEADING = 0x1c02d2f8,
        NATIVE_IS_NETWORK_GAME_RUNNING = 0x1c1cf453,
        NATIVE_REGISTER_MULTIPLAYER_GAME_WIN = 0x1c2ebc92,
        NATIVE_SET_HEADING_FOR_ATTACHED_PLAYER = 0x1c306d1f,
        NATIVE_GET_IS_HIDEF = 0x1c340359,
        NATIVE_GET_PLAYER_RADIO_STATION_INDEX = 0x1c4946ac,
        NATIVE_SET_CAR_STRONG = 0x1c729a0c,
        NATIVE_SET_ADVANCED_BOOL_IN_DECISION_MAKER = 0x1c867a16,
        NATIVE_GET_GAME_VIEWPORT_ID = 0x1c9dfa9f,
        NATIVE_CALCULATE_TRAVEL_DISTANCE_BETWEEN_NODES = 0x1ca92436,
        NATIVE_GET_PLAYER_ID = 0x1cc648ea,
        NATIVE_NEW_SCRIPTED_CONVERSATION = 0x1cea7fce,
        NATIVE_CREATE_NM_MESSAGE = 0x1cfbfd4b,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEMP5 = 0x1d2ca221,
        NATIVE_CLEAR_PLAYER_HAS_DAMAGED_AT_LEAST_ONE_PED = 0x1d31cbbd,
        NATIVE_TRAIN_LEAVE_STATION = 0x1d5eb14f,
        NATIVE_PRINT_WITH_2_NUMBERS = 0x1d5f8e7a,
        NATIVE_PLAY_SOUND_FROM_PED = 0x1d6d6ac3,
        NATIVE_IS_NETWORK_SESSION = 0x1d8fef54,
        NATIVE_SET_CHAR_RELATIONSHIP_GROUP = 0x1ddd858e,
        NATIVE_ADD_BLIP_FOR_CHAR = 0x1e203d63,
        NATIVE_DAMAGE_CAR = 0x1e62c15b,
        NATIVE_SET_UP_TRIP_SKIP_TO_BE_FINISHED_BY_SCRIPT = 0x1e7a6ecb,
        NATIVE_GET_STREAM_PLAYTIME = 0x1ead0b13,
        NATIVE_DOES_SCRIPT_FIRE_EXIST = 0x1ec9f867,
        NATIVE_GET_CHAR_WILL_COWER_INSTEAD_OF_FLEEING = 0x1ee1eb44,
        NATIVE_DOES_CAM_EXIST = 0x1ef89dc0,
        NATIVE_GET_ONLINE_LAN = 0x1f0045a3,
        NATIVE_REMOVE_RC_BUGGY = 0x1f088bc3,
        NATIVE_LOAD_CHAR_DECISION_MAKER = 0x1f1c4284,
        NATIVE_ALLOW_GAME_TO_PAUSE_FOR_STREAMING = 0x1f2890fb,
        NATIVE_DISPLAY_TEXT_WITH_LITERAL_SUBSTRING = 0x1f4e1006,
        NATIVE_SET_MONEY_CARRIED_BY_ALL_NEW_PEDS = 0x1f6b807e,
        NATIVE_GET_SAFE_POSITION_FOR_CHAR = 0x1f897270,
        NATIVE_VMAG = 0x1fcf1ecd,
        NATIVE_SET_CHAR_MAX_TIME_IN_WATER = 0x1fcff460,
        NATIVE_CELL_CAM_IS_CHAR_VISIBLE = 0x1fd07f61,
        NATIVE_DRAW_SPRITE = 0x1fec16b0,
        NATIVE_GET_CURRENT_POLICE_CAR_MODEL = 0x1ff93378,
        NATIVE_ATTACH_CAR_TO_OBJECT = 0x1ffed3eb,
        NATIVE_FIND_NETWORK_RESTART_POINT = 0x202484d0,
        NATIVE_SET_FOLLOW_VEHICLE_CAM_SUBMODE = 0x2028ef13,
        NATIVE_IS_CAR_STUCK = 0x204d61fb,
        NATIVE_GET_CURRENT_POPULATION_ZONE_TYPE = 0x20605492,
        NATIVE_FIND_STREET_NAME_AT_POSITION = 0x206cba0f,
        NATIVE_BLEND_FROM_NM_WITH_ANIM = 0x20840c07,
        NATIVE_REMOVE_PED_HELMET = 0x2086b1f0,
        NATIVE_SET_MOBILE_PHONE_ROTATION = 0x209c28cf,
        NATIVE_SAVE_SETTINGS = 0x20b47e1e,
        NATIVE_SET_DEFAULT_TARGET_SCORING_FUNCTION = 0x20fd313a,
        NATIVE_START_CUTSCENE = 0x210106f6,
        NATIVE_GET_VEHICLE_PLAYER_WOULD_ENTER = 0x211754bb,
        NATIVE_HAS_POOL_OBJECT_COLLIDED_WITH_CUSHION = 0x211d5d72,
        NATIVE_PLAYER_IS_INTERACTING_WITH_GARAGE = 0x2136fa65,
        NATIVE_SET_SPRITE_HDR_MULTIPLIER = 0x21459032,
        NATIVE_TASK_WARP_CHAR_INTO_CAR_AS_PASSENGER = 0x214e551b,
        NATIVE_PRINT_HELP_WITH_NUMBER = 0x215a5fcc,
        NATIVE_CLEAR_PRINTS = 0x216cb1c5,
        NATIVE_ENABLE_DEFERRED_LIGHTING = 0x217781b1,
        NATIVE_INIT_FRONTEND_HELPER_TEXT = 0x218388c0,
        NATIVE_NETWORK_GET_HOST_AVERAGE_RANK = 0x218479e3,
        NATIVE_SET_CHAR_WEAPON_SKILL = 0x21ad7e36,
        NATIVE_GET_MODEL_NAME_OF_CAR_FOR_DEBUG_ONLY = 0x21d1e23c,
        NATIVE_SET_MOVIE_VOLUME = 0x21d93adf,
        NATIVE_SET_RANDOM_CAR_DENSITY_MULTIPLIER = 0x21ff10d5,
        NATIVE_GET_REMOTE_CONTROLLED_CAR = 0x22287506,
        NATIVE_SET_CAR_LIVERY = 0x22320c93,
        NATIVE_TASK_SMART_FLEE_POINT = 0x223eafc4,
        NATIVE_TASK_USE_MOBILE_PHONE = 0x225a38c8,
        NATIVE_IS_CHAR_TOUCHING_VEHICLE = 0x226a7914,
        NATIVE_SET_CHAR_RELATIONSHIP = 0x2274066d,
        NATIVE_SET_CAR_CAN_BE_VISIBLY_DAMAGED = 0x22c60f92,
        NATIVE_GET_WIDTH_OF_SUBSTRING_GIVEN_TEXT_LABEL = 0x22d0ddfb,
        NATIVE_SET_CHAR_WILL_REMAIN_ON_BOAT_AFTER_MISSION_ENDS = 0x22e6bd35,
        NATIVE_NETWORK_IS_PLAYER_TYPING = 0x22ec4c73,
        NATIVE_ENABLE_SCRIPT_CONTROLLED_MICROPHONE = 0x22fbfccf,
        NATIVE_SET_PED_DONT_USE_VEHICLE_SPECIFIC_ANIMS = 0x23108373,
        NATIVE_USE_MASK = 0x2310ca9a,
        NATIVE_SET_CREATE_RANDOM_COPS = 0x23441648,
        NATIVE_GET_NEXT_STATION_FOR_TRAIN = 0x234b1475,
        NATIVE_CELL_CAM_ACTIVATE = 0x234c1ae9,
        NATIVE_IS_CAR_TOUCHING_CAR = 0x236fc815,
        NATIVE_IS_GAME_KEYBOARD_NAV_RIGHT_PRESSED = 0x2377ad0f,
        NATIVE_SET_OBJECT_AS_STEALABLE = 0x23a96397,
        NATIVE_GET_NEEDED_PLAYER_CASH_FOR_LEVEL = 0x23aef5f8,
        NATIVE_HAS_CHAR_BEEN_PHOTOGRAPHED = 0x23b55d72,
        NATIVE_PLAYSTATS_MISSION_CANCELLED = 0x23bf8031,
        NATIVE_IS_SPHERE_VISIBLE_TO_ANOTHER_MACHINE = 0x23c5274e,
        NATIVE_REQUEST_AMBIENT_AUDIO_BANK = 0x23c88bc7,
        NATIVE_REGISTER_MISSION_PASSED = 0x23e3421d,
        NATIVE_GET_STAT_FRONTEND_VISIBILITY = 0x23ee2965,
        NATIVE_DISPLAY_TEXT_WITH_3_NUMBERS = 0x23eff6da,
        NATIVE_DOES_OBJECT_OF_TYPE_EXIST_AT_COORDS = 0x23ff2ba4,
        NATIVE_ENABLE_CHASE_AUDIO = 0x23ff9e36,
        NATIVE_IS_XBOX360_VERSION = 0x24005cc8,
        NATIVE_SET_ROPE_HEIGHT_FOR_OBJECT = 0x2413ad67,
        NATIVE_SET_HEALTH_PICKUP_NETWORK_REGEN_TIME = 0x2423bc30,
        NATIVE_RESTORE_SCRIPT_VALUES_FOR_NETWORK_GAME = 0x242ae86b,
        NATIVE_LIMIT_TWO_PLAYER_DISTANCE = 0x24440134,
        NATIVE_TERMINATE_THIS_SCRIPT = 0x245b6ab6,
        NATIVE_ARE_ANY_CHARS_NEAR_CHAR = 0x246d0c7b,
        NATIVE_SET_PLAYER_COLOUR = 0x24750296,
        NATIVE_DISPLAY_TEXT_WITH_LITERAL_STRING = 0x247f4d85,
        NATIVE_DELETE_CAR_GENERATOR = 0x24b25f34,
        NATIVE_GET_TIME_SINCE_LAST_DEATH = 0x24bc5ac0,
        NATIVE_SET_CHAR_WANTED_BY_POLICE = 0x24da33d1,
        NATIVE_ATAN2 = 0x2508ac81,
        NATIVE_SET_HAS_BEEN_OWNED_FOR_CAR_GENERATOR = 0x2519f733,
        NATIVE_SET_TAXI_GARAGE_RADIO_STATE = 0x251c7586,
        NATIVE_SET_CHAR_GRAVITY = 0x252de038,
        NATIVE_GET_TRAIN_CARRIAGE = 0x2544e7a6,
        NATIVE_CREATE_CHAR = 0x25646b4e,
        NATIVE_IS_IN_MP_TUTORIAL = 0x257078b2,
        NATIVE_PLAYER_HAS_FLASHING_STARS_ABOUT_TO_DROP = 0x25798938,
        NATIVE_GET_NTH_INTEGER_IN_STRING = 0x258dd91d,
        NATIVE_SET_GANG_CAR = 0x25cb76f3,
        NATIVE_GET_RANDOM_CAR_OF_TYPE_IN_AREA_NO_SAVE = 0x25d067e9,
        NATIVE_MARK_CAR_AS_CONVOY_CAR = 0x25d717ff,
        NATIVE_NETWORK_SET_LOCAL_PLAYER_IS_TYPING = 0x25f07b0f,
        NATIVE_GET_PLAYER_RANK_LEVEL_DURING_MP = 0x26064043,
        NATIVE_GET_WATER_HEIGHT_NO_WAVES = 0x262017f8,
        NATIVE_REMOVE_CARS_FROM_GENERATORS_IN_AREA = 0x262ad94a,
        NATIVE_SET_CHAR_ONLY_DAMAGED_BY_PLAYER = 0x263644ea,
        NATIVE_SET_OBJECT_RECORDS_COLLISIONS = 0x26461274,
        NATIVE_CREATE_USER_3D_MARKER = 0x265d2cba,
        NATIVE_CLEAR_NAMED_CUTSCENE = 0x268cc696,
        NATIVE_SET_PED_COMPONENTS_TO_NETWORK_PLAYERSETTINGS_MODEL = 0x270ffc9b,
        NATIVE_IS_PED_RETREATING = 0x27240bfe,
        NATIVE_RESET_STUCK_TIMER = 0x2735f5f8,
        NATIVE_SET_SPRITES_DRAW_BEFORE_FADE = 0x275de46e,
        NATIVE_FORCE_HIGH_LOD = 0x276952fd,
        NATIVE_ALLOW_GANG_RELATIONSHIPS_TO_BE_CHANGED_BY_NEXT_COMMAND = 0x278a187d,
        NATIVE_SET_CHAR_CURRENT_WEAPON_VISIBLE = 0x2794e7dd,
        NATIVE_GET_BLIP_INFO_ID_OBJECT_INDEX = 0x27ab7110,
        NATIVE_REMOVE_ANIMS = 0x27b551aa,
        NATIVE_SETTIMERB = 0x27c1b7c6,
        NATIVE_GET_START_FROM_FILTER_MENU = 0x27e85514,
        NATIVE_SET_GFWL_IS_RETURNING_TO_SINGLE_PLAYER = 0x27ebaafd,
        NATIVE_ADD_OBJECT_TO_INTERIOR_ROOM_BY_NAME = 0x27f07bd9,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_NUM_PEDS = 0x27f79698,
        NATIVE_START_NEW_WIDGET_COMBO = 0x284a3c93,
        NATIVE_LOCK_LAZLOW_STATION = 0x28597141,
        NATIVE_TAKE_CAR_OUT_OF_PARKED_CARS_BUDGET = 0x28678356,
        NATIVE_FREEZE_RADIO_STATION = 0x286bf543,
        NATIVE_RELEASE_SCRIPT_CONTROLLED_MICROPHONE = 0x287403a1,
        NATIVE_GET_CONTENTS_OF_TEXT_WIDGET = 0x28be9702,
        NATIVE_CHANGE_PLAYER_MODEL = 0x29254bee,
        NATIVE_GET_TOTAL_DURATION_OF_CAR_RECORDING = 0x29685201,
        NATIVE_GET_CINEMATIC_CAM = 0x29716dcc,
        NATIVE_GET_BLIP_ALPHA = 0x297af6c8,
        NATIVE_GET_CAM_MOTION_BLUR = 0x2981ef2f,
        NATIVE_SCRIPT_IS_MOVING_MOBILE_PHONE_OFFSCREEN = 0x29828690,
        NATIVE_MAKE_PLAYER_GANG_DISAPPEAR = 0x29a23edb,
        NATIVE_GET_CHAR_MELEE_ACTION_FLAG2 = 0x29aa1139,
        NATIVE_SET_PLAYER_AS_DAMAGED_PLAYER = 0x29c30a3e,
        NATIVE_CAN_THE_STAT_HAVE_STRING = 0x29da1afb,
        NATIVE_GET_SCREEN_RESOLUTION = 0x29f3572f,
        NATIVE_GET_CHAR_IN_CAR_PASSENGER_SEAT = 0x2a0c5ee7,
        NATIVE_SET_CLEAR_MANIFOLDS = 0x2a445f46,
        NATIVE_SET_RADAR_ZOOM = 0x2a50d1a6,
        NATIVE_GET_PED_PATH_MAY_USE_LADDERS = 0x2a5d4c57,
        NATIVE_GET_OBJECT_VELOCITY = 0x2a8801cb,
        NATIVE_TURN_ON_RADIOHUD_IN_LOBBY = 0x2aa03b47,
        NATIVE_ADD_SIMPLE_BLIP_FOR_PICKUP = 0x2aad35a0,
        NATIVE_NETWORK_SHOW_MET_PLAYER_PROFILE_UI = 0x2ab80821,
        NATIVE_IS_CHAR_IN_AREA_3D = 0x2ae68b0f,
        NATIVE_IS_OBJECT_ON_SCREEN = 0x2ae883eb,
        NATIVE_DISABLE_PLAYER_SPRINT = 0x2b00e197,
        NATIVE_DOES_WIDGET_GROUP_EXIST = 0x2b1d2af9,
        NATIVE_SET_VEHICLE_DIRT_LEVEL = 0x2b39128b,
        NATIVE_GET_LATEST_CONSOLE_COMMAND = 0x2b547fe6,
        NATIVE_ALLOW_REACTION_ANIMS = 0x2b551dca,
        NATIVE_GET_CHAR_ANIM_TOTAL_TIME = 0x2b6ef5c9,
        NATIVE_IS_ANY_SPEECH_PLAYING = 0x2b74a6d6,
        NATIVE_ADD_LINE_TO_SCRIPTED_CONVERSATION = 0x2b75e3e2,
        NATIVE_TASK_DRIVE_BY = 0x2b84d1c4,
        NATIVE_APPLY_WANTED_LEVEL_CHANGE_NOW = 0x2bcb3b77,
        NATIVE_HAS_PLAYER_COLLECTED_PICKUP = 0x2bcba429,
        NATIVE_DISPLAY_FRONTEND_MAP_BLIPS = 0x2c01ba1e,
        NATIVE_PLAY_STREAM_FRONTEND = 0x2c2a16bc,
        NATIVE_SET_NETWORK_VEHICLE_RESPOT_TIMER = 0x2c30912d,
        NATIVE_PRINT_NOW = 0x2c60bf8c,
        NATIVE_IS_SCRIPTED_SPEECH_PLAYING = 0x2c653904,
        NATIVE_CAM_SET_DOLLY_ZOOM_LOCK = 0x2c8abc01,
        NATIVE_NETWORK_PLAYER_HAS_KEYBOARD = 0x2c90236b,
        NATIVE_GET_ASPECT_RATIO = 0x2ca8f641,
        NATIVE_IS_RELATIONSHIP_SET = 0x2cb0956a,
        NATIVE_LOAD_SCENE_FOR_ROOM_BY_KEY = 0x2ce2eef9,
        NATIVE_IS_WORLD_POINT_WITHIN_BRAIN_ACTIVATION_RANGE = 0x2cf305a0,
        NATIVE_ACTIVATE_FRONTEND = 0x2cf69916,
        NATIVE_SET_MISSION_RESPECT_TOTAL = 0x2d1aeee6,
        NATIVE_CHANGE_CHAR_SIT_IDLE_ANIM = 0x2d56a131,
        NATIVE_SET_ONLINE_LAN = 0x2d79f99c,
        NATIVE_MAKE_PLAYER_FIRE_PROOF = 0x2d9cdfc5,
        NATIVE_ALLOW_EMERGENCY_SERVICES = 0x2dc66ee2,
        NATIVE_EXTINGUISH_OBJECT_FIRE = 0x2e1a8e8a,
        NATIVE_REMOVE_STUCK_CAR_CHECK = 0x2e2a7bf1,
        NATIVE_GET_WEAPONTYPE_SLOT = 0x2e3759af,
        NATIVE_LOCATE_CHAR_IN_CAR_CHAR_3D = 0x2e3b5675,
        NATIVE_PLAY_SOUND_FRONTEND = 0x2e458f74,
        NATIVE_TASK_EVERYONE_LEAVE_CAR = 0x2e669464,
        NATIVE_SET_STREAMING_REQUEST_LIST_TIME = 0x2e95cdfe,
        NATIVE_IS_SPECIFIC_CAM_INTERPOLATING = 0x2e9c3c82,
        NATIVE_HAS_CAR_BEEN_DROPPED_OFF = 0x2e9f07ff,
        NATIVE_COPY_ANIMATIONS = 0x2ed971a5,
        NATIVE_PRELOAD_STREAM_WITH_START_OFFSET = 0x2ef50480,
        NATIVE_SET_COLLIDE_WITH_PEDS = 0x2f086a44,
        NATIVE_ADD_UPSIDEDOWN_CAR_CHECK = 0x2f189998,
        NATIVE_SET_GROUP_LEADER = 0x2f3c5e08,
        NATIVE_COUNT_SCRIPT_CAMS = 0x2f3d792b,
        NATIVE_ROTATE_OBJECT = 0x2f4d8d44,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEMP4 = 0x2f61468a,
        NATIVE_SET_SELECTED_MENU_ITEM = 0x2f6d7b4e,
        NATIVE_CREATE_OBJECT = 0x2f7aa05c,
        NATIVE_SET_TEXT_LINE_HEIGHT_MULT = 0x2f947549,
        NATIVE_TASK_GUARD_CURRENT_POSITION = 0x2fb099e9,
        NATIVE_SET_IN_MP_TUTORIAL = 0x2fd05431,
        NATIVE_PRINT_WITH_5_NUMBERS = 0x2fd1adab,
        NATIVE_GET_NUMBER_OF_FIRES_IN_AREA = 0x301350fb,
        NATIVE_IS_VEHICLE_ON_PLAYER_MACHINE = 0x301e53fd,
        NATIVE_GET_GROUP_MEMBER = 0x301ec367,
        NATIVE_ADD_PED_TO_MISSION_DELETION_LIST = 0x302e8ac8,
        NATIVE_READ_KILL_FRENZY_STATUS = 0x303e8696,
        NATIVE_DRAW_DEBUG_SPHERE = 0x304d0eef,
        NATIVE_GET_SOUND_LEVEL_AT_COORDS = 0x30648db1,
        NATIVE_IS_VEH_STUCK = 0x308c5861,
        NATIVE_SET_ROOM_FOR_DUMMY_CHAR_BY_KEY = 0x3091dd81,
        NATIVE_TRIGGER_PTFX_ON_OBJ_BONE = 0x30dacb16,
        NATIVE_ACTIVATE_REPLAY_MENU = 0x30e32f9c,
        NATIVE_START_PTFX_ON_OBJ_BONE = 0x3101366b,
        NATIVE_PRINT_STRING_IN_STRING = 0x31026991,
        NATIVE_ADD_GROUP_TO_NETWORK_RESTART_NODE_GROUP_LIST = 0x3105dc1f,
        NATIVE_SET_SNIPER_ZOOM_FACTOR = 0x311c58af,
        NATIVE_IS_LOOK_INVERTED = 0x313434b2,
        NATIVE_DEBUG_OFF = 0x31481a35,
        NATIVE_SHIFT_LEFT = 0x314cc6cd,
        NATIVE_CAN_CHAR_SEE_DEAD_CHAR = 0x314d38e0,
        NATIVE_ADD_STUCK_CAR_CHECK_WITH_WARP = 0x3163e9fc,
        NATIVE_SET_PED_HEEDS_THE_EVERYONE_IGNORE_PLAYER_FLAG = 0x31a06af4,
        NATIVE_GET_STRING_WIDTH_WITH_TEXT_AND_INT = 0x31f5d8fc,
        NATIVE_NETWORK_GET_HOST_SERVER_NAME = 0x31fb4d34,
        NATIVE_SET_BITS_IN_RANGE = 0x32094719,
        NATIVE_SWITCH_OBJECT_BRAINS = 0x3224777e,
        NATIVE_SET_STAT_FRONTEND_VISIBLE_AFTER_INCREMENTED = 0x32318a5d,
        NATIVE_ROUND = 0x323b0e24,
        NATIVE_GET_CAR_FORWARD_Y = 0x323c7833,
        NATIVE_SET_CAM_INHERIT_ROLL_OBJECT = 0x32453696,
        NATIVE_SET_CAM_SPLINE_SPEED_CONSTANT = 0x3282837c,
        NATIVE_SET_ALL_PICKUPS_OF_TYPE_COLLECTABLE_BY_CAR = 0x32845e38,
        NATIVE_REMOVE_CAR_WINDOW = 0x32a2db74,
        NATIVE_TASK_COMBAT_HATED_TARGETS_AROUND_CHAR_TIMED = 0x32c5d51f,
        NATIVE_FLOOR = 0x32e9be04,
        NATIVE_SET_CAR_COORDINATES_NO_OFFSET = 0x32f47d19,
        NATIVE_SET_CHAR_MELEE_ACTION_FLAG0 = 0x32fa325d,
        NATIVE_IS_CHAR_FATALLY_INJURED = 0x3305879e,
        NATIVE_TIMERB = 0x330a9c0c,
        NATIVE_TRIGGER_PTFX_ON_OBJ = 0x3325ab9c,
        NATIVE_UNPAUSE_PLAYBACK_RECORDED_CAR = 0x332f05e4,
        NATIVE_APPLY_FORCE_TO_CAR = 0x3343a65b,
        NATIVE_SET_LOCAL_PLAYER_PAIN_VOICE = 0x33bd1a80,
        NATIVE_SET_FAKE_WANTED_CIRCLE = 0x33dc533f,
        NATIVE_GET_TEXTURE_FROM_STREAMED_TXD = 0x33e6ba2d,
        NATIVE_GET_WEB_PAGE_LINK_AT_POSN = 0x33eb42d0,
        NATIVE_MARK_MISSION_TRAIN_AS_NO_LONGER_NEEDED = 0x33f5c289,
        NATIVE_TASK_FLUSH_ROUTE = 0x34219154,
        NATIVE_NETWORK_GET_NUMBER_OF_GAMES = 0x3429afe6,
        NATIVE_IS_GARAGE_CLOSED = 0x3434e762,
        NATIVE_APPLY_FORCE_TO_PED = 0x343abb0e,
        NATIVE_SET_MINIGAME_IN_PROGRESS = 0x348b9046,
        NATIVE_NETWORK_GET_UNACCEPTED_INVITER_NAME = 0x34a7e847,
        NATIVE_GET_GAME_CAM_CHILD = 0x34bbd476,
        NATIVE_ARE_ALL_NAVMESH_REGIONS_LOADED = 0x34c4e789,
        NATIVE_TELEPORT_NETWORK_PLAYER = 0x34e5c7e3,
        NATIVE_CLEAR_ALL_CHAR_PROPS = 0x34e7718e,
        NATIVE_IS_PED_PINNED_DOWN = 0x34f55bf4,
        NATIVE_GET_CHAR_LAST_DAMAGE_BONE = 0x35113ccc,
        NATIVE_CREATE_RANDOM_FEMALE_CHAR = 0x35247a8f,
        NATIVE_SHIFT_RIGHT = 0x352633ca,
        NATIVE_ADD_COVER_BLOCKING_AREA = 0x3536946f,
        NATIVE_START_PED_MOBILE_RINGING = 0x354520b6,
        NATIVE_PLAYSTATS_CHEAT = 0x35732c62,
        NATIVE_SETTIMERA = 0x35785333,
        NATIVE_SET_LOBBY_MUTE_OVERRIDE = 0x35ba6682,
        NATIVE_TASK_CLIMB_LADDER = 0x35bb4ee0,
        NATIVE_SET_PLAYER_CONTROL_FOR_TEXT_CHAT = 0x35c99b17,
        NATIVE_SAVE_NEWLINE_TO_DEBUG_FILE = 0x36383b18,
        NATIVE_GET_CAMERA_FROM_NETWORK_ID = 0x36438285,
        NATIVE_CHANGE_PICKUP_BLIP_SCALE = 0x366c5aa5,
        NATIVE_SET_HELI_STABILISER = 0x366f1e5a,
        NATIVE_REGISTER_FLOAT_STAT = 0x36776aa2,
        NATIVE_CREATE_MONEY_PICKUP = 0x36a3d8fa,
        NATIVE_IS_RECORDING_GOING_ON_FOR_CAR = 0x36ad831e,
        NATIVE_CHECK_NM_FEEDBACK = 0x36bda8cb,
        NATIVE_SET_AREA_NAME = 0x36e34ae2,
        NATIVE_IS_AUTO_SAVE_IN_PROGRESS = 0x36f75399,
        NATIVE_ENABLE_FRONTEND_RADIO = 0x370c9ee0,
        NATIVE_SET_CHAR_AMMO = 0x370e18d4,
        NATIVE_SET_OBJECT_RENDER_SCORCHED = 0x372a9a9b,
        NATIVE_GET_CAR_SPEED_VECTOR = 0x373119b2,
        NATIVE_LOCATE_CHAR_IN_CAR_OBJECT_2D = 0x3731ab0b,
        NATIVE_ADD_STRING_TO_HTML_SCRIPT_OBJECT = 0x3734f820,
        NATIVE_SET_CHAR_MONEY = 0x37504eab,
        NATIVE_PREVIEW_RINGTONE = 0x37a8383f,
        NATIVE_ATTACH_PED_TO_OBJECT_PHYSICALLY = 0x37f17899,
        NATIVE_NETWORK_SET_TEAM_ONLY_CHAT = 0x3813019a,
        NATIVE_SEARCH_CRITERIA_CONSIDER_PEDS_WITH_FLAG_FALSE = 0x38151144,
        NATIVE_GET_CHAR_HEIGHT_ABOVE_GROUND = 0x3852a468,
        NATIVE_PLAYER_IS_PISSED_OFF = 0x38641279,
        NATIVE_SET_HINT_MOVE_IN_DIST = 0x38769cf3,
        NATIVE_SET_PLAYER_FAST_RELOAD = 0x38a0d835,
        NATIVE_SET_STATE_OF_CLOSEST_DOOR_OF_TYPE = 0x38c951a4,
        NATIVE_SET_VEHICLE_EXPLODES_ON_HIGH_EXPLOSION_DAMAGE = 0x38cc692b,
        NATIVE_RESERVE_NETWORK_MISSION_OBJECTS = 0x391df4f3,
        NATIVE_REQUEST_COLLISION_FOR_MODEL = 0x3930c042,
        NATIVE_UPDATE_NETWORK_RELATIVE_SCORE = 0x3937b8ab,
        NATIVE_START_PLAYBACK_RECORDED_CAR_USING_AI = 0x3940d2c8,
        NATIVE_TASK_LEAVE_CAR_IMMEDIATELY = 0x395b4d6b,
        NATIVE_TOGGLE_CHAR_DUCKING = 0x3963ee08,
        NATIVE_TASK_DUCK = 0x396a40e9,
        NATIVE_REMOVE_CLOSE_MIC_PED = 0x3976c9b6,
        NATIVE_FLUSH_PATROL_ROUTE = 0x39770904,
        NATIVE_SET_CURRENT_MOVIE = 0x397782d8,
        NATIVE_PRINTFLOAT2 = 0x3983593a,
        NATIVE_STOP_PLAYBACK_RECORDED_CAR = 0x39aa502c,
        NATIVE_GET_FILTER_MENU_ON = 0x39b5bdbd,
        NATIVE_REGISTER_SAVE_HOUSE = 0x39c1849a,
        NATIVE_NETWORK_GET_NUM_PARTY_MEMBERS = 0x39d26713,
        NATIVE_STREAM_CUTSCENE = 0x39d7bc0c,
        NATIVE_CAN_PLAYER_START_MISSION = 0x39e3cb3f,
        NATIVE_GET_OBJECT_ANIM_CURRENT_TIME = 0x39f0d010,
        NATIVE_ACTIVATE_VECTOR_MAP = 0x3a1a1d1f,
        NATIVE_SET_VEH_ALARM_DURATION = 0x3a4297cf,
        NATIVE_GET_CAM_STATE = 0x3a6b3754,
        NATIVE_STRING_DIFFERENCE = 0x3a8d4a05,
        NATIVE_FLUSH_SCENARIO_BLOCKING_AREAS = 0x3a9fe799,
        NATIVE_PLAYSTATS_MISSION_STARTED = 0x3aab699c,
        NATIVE_CHANGE_BLIP_COLOUR = 0x3aae0512,
        NATIVE_OPEN_GARAGE = 0x3abbd489,
        NATIVE_SET_CHAR_WILL_COWER_INSTEAD_OF_FLEEING = 0x3adb74b6,
        NATIVE_DONT_SUPPRESS_ANY_PED_MODELS = 0x3ae27bc9,
        NATIVE_NETWORK_FIND_GAME_PENDING = 0x3ae44227,
        NATIVE_GET_FURTHEST_NETWORK_RESTART_NODE = 0x3af92000,
        NATIVE_IS_PED_JACKING = 0x3b321816,
        NATIVE_LOCATE_CHAR_IN_CAR_2D = 0x3b36c8ca,
        NATIVE_IS_THIS_MODEL_A_PLANE = 0x3b3907bb,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_RETREATING_BEHAVIOUR = 0x3b476166,
        NATIVE_HAS_OBJECT_BEEN_DAMAGED = 0x3b4fb8fd,
        NATIVE_GIVE_PED_PICKUP_OBJECT = 0x3b653867,
        NATIVE_GET_NTH_GROUP_MEMBER = 0x3b70c0de,
        NATIVE_REQUEST_IPL = 0x3b70d1db,
        NATIVE_SET_STAT_FRONTEND_VISIBILITY = 0x3b741133,
        NATIVE_GET_CURRENT_STATION_FOR_TRAIN = 0x3b7dccaa,
        NATIVE_DISABLE_DEBUG_CAM_AND_PLAYER_WARPING = 0x3b9ae96d,
        NATIVE_SET_CHAR_COORDINATES_DONT_WARP_GANG = 0x3bc940e2,
        NATIVE_FORCE_NOISE_OFF = 0x3bce3dde,
        NATIVE_VDIST = 0x3c08ecb7,
        NATIVE_DOES_PLAYER_HAVE_CONTROL_OF_NETWORK_ID = 0x3c4b2083,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_LOW_HEALTH = 0x3ca0ca06,
        NATIVE_SET_ANIM_GROUP_FOR_CHAR = 0x3cbaa102,
        NATIVE_SET_DRIVE_TASK_CRUISE_SPEED = 0x3cec07b1,
        NATIVE_GET_TIME_SINCE_PLAYER_HIT_OBJECT = 0x3cfda2ae,
        NATIVE_TASK_SEEK_COVER_TO_COVER_POINT = 0x3d026b29,
        NATIVE_HAS_CONTROL_OF_NETWORK_ID = 0x3d0b0270,
        NATIVE_INIT_DEBUG_WIDGETS = 0x3d0c3eca,
        NATIVE_TASK_PLAY_ANIM_ON_CLONE = 0x3d3c0980,
        NATIVE_SET_TELESCOPE_CAM_ANGLE_LIMITS = 0x3d3ec473,
        NATIVE_LOCATE_CHAR_IN_CAR_CAR_2D = 0x3d622186,
        NATIVE_DISABLE_PLAYER_LOCKON = 0x3d69e524,
        NATIVE_RESERVE_NETWORK_MISSION_VEHICLES_FOR_HOST = 0x3d7b2a5e,
        NATIVE_SET_GPS_TEST_IN_3D_FLAG = 0x3d8c7ad3,
        NATIVE_IS_PARTY_MODE = 0x3df52521,
        NATIVE_SET_ACTIVATE_OBJECT_PHYSICS_AS_SOON_AS_IT_IS_UNFROZEN = 0x3e263ae1,
        NATIVE_SET_CAM_SPLINE_DURATION = 0x3e91fc8a,
        NATIVE_RESERVE_NETWORK_MISSION_PEDS_FOR_HOST = 0x3ea1d498,
        NATIVE_SET_DITCH_POLICE_MODELS = 0x3ea7fce4,
        NATIVE_NETWORK_GET_RENDEZVOUS_HOST_PLAYER_ID = 0x3ecea8b7,
        NATIVE_START_NEW_SCRIPT = 0x3f166d0e,
        NATIVE_SET_TEXT_EDGE = 0x3f1a5dab,
        NATIVE_GET_HELP_MESSAGE_BOX_SIZE = 0x3f552d6c,
        NATIVE_GET_CAM_NEAR_DOF = 0x3f627534,
        NATIVE_RESET_ARMOUR_PICKUP_NETWORK_REGEN_TIME = 0x3f6365bc,
        NATIVE_SET_NEEDS_TO_BE_HOTWIRED = 0x3fa9605b,
        NATIVE_IS_CHAR_SHOOTING = 0x3fab229b,
        NATIVE_IS_GAME_KEYBOARD_KEY_JUST_PRESSED = 0x3feebf9c,
        NATIVE_REMOVE_ALL_PICKUPS_OF_TYPE = 0x40062c53,
        NATIVE_SET_HINT_FOV = 0x402262d1,
        NATIVE_NETWORK_END_SESSION_PENDING = 0x40490bcc,
        NATIVE_END_PED_QUEUE_MEMBERSHIP_LIST = 0x4054e15f,
        NATIVE_GET_PLAYER_NAME = 0x406b4b20,
        NATIVE_CREATE_RANDOM_CHAR_AS_DRIVER = 0x409383bf,
        NATIVE_GET_CAR_FORWARD_X = 0x40c09537,
        NATIVE_IS_MEMORY_CARD_IN_USE = 0x40ce4dfd,
        NATIVE_PRINT_STRING_WITH_LITERAL_STRING_NOW = 0x40d7612d,
        NATIVE_GET_OBJECT_ANIM_TOTAL_TIME = 0x40d7c3a2,
        NATIVE_CREATE_MENU = 0x410f989f,
        NATIVE_RETUNE_RADIO_DOWN = 0x411455f7,
        NATIVE_MARK_ROAD_NODE_AS_DONT_WANDER = 0x4147f413,
        NATIVE_GET_OBJECT_PED_IS_HOLDING = 0x41730ea4,
        NATIVE_SET_ROOM_FOR_CAR_BY_NAME = 0x41763d6e,
        NATIVE_HAS_COLLISION_FOR_MODEL_LOADED = 0x41a094f8,
        NATIVE_GET_KEY_FOR_CHAR_IN_ROOM = 0x41c87342,
        NATIVE_IS_PLAYER_ONLINE_NP = 0x41fad3e2,
        NATIVE_BLOCK_CHAR_HEAD_IK = 0x420e9796,
        NATIVE_SET_PICKUPS_FIX_CARS = 0x420f9044,
        NATIVE_NETWORK_GET_NUM_OPEN_PUBLIC_SLOTS = 0x421e3e12,
        NATIVE_TASK_GO_TO_COORD_WHILE_SHOOTING = 0x424fed42,
        NATIVE_TASK_PLAY_ANIM_SECONDARY_UPPER_BODY = 0x425f7b42,
        NATIVE_SET_PLAYER_CONTROL_ADVANCED = 0x4261bf11,
        NATIVE_ACTIVATE_HELI_SPEED_CHEAT = 0x426971ea,
        NATIVE_FORCE_GENERATE_PARKED_CARS_TOO_CLOSE_TO_OTHERS = 0x42697dc8,
        NATIVE_IS_CAR_PASSENGER_SEAT_FREE = 0x42758ad2,
        NATIVE_CREATE_EMERGENCY_SERVICES_CAR_RETURN_DRIVER = 0x42825c00,
        NATIVE_TASK_GET_OFF_BOAT = 0x4293601f,
        NATIVE_SET_NETWORK_ID_STOP_CLONING = 0x42b1f401,
        NATIVE_REGISTER_FASTEST_TIME = 0x42be3ba9,
        NATIVE_NETWORK_GET_LAN_SESSION = 0x42dbf8d8,
        NATIVE_DRAW_SPRITE_WITH_UV = 0x430d87c7,
        NATIVE_TASK_EXTEND_ROUTE = 0x43271f69,
        NATIVE_NETWORK_SET_LAN_SESSION = 0x432bc94d,
        NATIVE_ENABLE_DEBUG_CAM = 0x4330116c,
        NATIVE_SET_OBJECT_DRAW_LAST = 0x4339d5e9,
        NATIVE_THIS_SCRIPT_IS_SAFE_FOR_NETWORK_GAME = 0x439071c4,
        NATIVE_EXPLODE_CAR = 0x4399d3e5,
        NATIVE_GET_FILTER_SAVE_SETTING = 0x43c12a2c,
        NATIVE_CAM_SEQUENCE_OPEN = 0x43d12c89,
        NATIVE_EXTINGUISH_FIRE_AT_POINT = 0x43e117ca,
        NATIVE_SET_TRAIN_STOPS_FOR_STATIONS = 0x43e5f109,
        NATIVE_GET_GROUP_FORMATION = 0x442c9c70,
        NATIVE_GET_TIME_TIL_NEXT_STATION = 0x443bd51f,
        NATIVE_CLEAR_AREA_OF_CHARS = 0x44520b7f,
        NATIVE_RESET_CONSOLE_COMMAND = 0x44775987,
        NATIVE_GET_PED_PATH_MAY_DROP_FROM_HEIGHT = 0x447b9c20,
        NATIVE_IS_CONTROL_JUST_PRESSED = 0x4487f579,
        NATIVE_SET_ALTERNATIVE_HEAD_FOR_PED_QUEUE = 0x448ff08c,
        NATIVE_IS_PED_LOOKING_AT_OBJECT = 0x449d449e,
        NATIVE_GET_OBJECT_MASS = 0x449f0820,
        NATIVE_TASK_LOOK_AT_OBJECT = 0x44c5d95b,
        NATIVE_IS_JAPANESE_VERSION = 0x44caf242,
        NATIVE_LISTEN_TO_PLAYER_GROUP_COMMANDS = 0x44d69ec1,
        NATIVE_GET_WEAPONTYPE_MODEL = 0x44e1c269,
        NATIVE_DISPLAY_TEXT_WITH_TWO_SUBSTRINGS_GIVEN_HASH_KEYS = 0x44ff0292,
        NATIVE_NETWORK_PLAYER_HAS_HEADSET = 0x451fb6b6,
        NATIVE_SMASH_CAR_WINDOW = 0x4543dbb7,
        NATIVE_TASK_LOOK_AT_VEHICLE = 0x45651376,
        NATIVE_GET_CHAR_MODEL = 0x456b3e3a,
        NATIVE_IS_PLAYER_TARGETTING_ANYTHING = 0x456db50d,
        NATIVE_SET_CHAR_SIGNAL_AFTER_KILL = 0x45770a6f,
        NATIVE_GET_CAR_BLOCKING_CAR = 0x457d1ede,
        NATIVE_ALLOW_PLAYER_TO_CARRY_NON_MISSION_OBJECTS = 0x457ecd86,
        NATIVE_GET_MAX_WANTED_LEVEL = 0x457f1e44,
        NATIVE_SET_FILTER_SAVE_SETTING = 0x45834ae0,
        NATIVE_SET_CAM_INTERP_STYLE_DETAILED = 0x458ceec6,
        NATIVE_IS_AUTO_AIMING_ON = 0x45a645f0,
        NATIVE_SET_CAM_SPLINE_CUSTOM_SPEED_GRAPH = 0x45afb865,
        NATIVE_SET_TEXT_RIGHT_JUSTIFY = 0x45b60520,
        NATIVE_FORCE_RADIO_TRACK = 0x45b90992,
        NATIVE_TIMERA = 0x45c8c188,
        NATIVE_DOES_OBJECT_HAVE_PHYSICS = 0x45d1813f,
        NATIVE_DISPLAY_ONSCREEN_TIMER_WITH_STRING = 0x45d44f47,
        NATIVE_IS_OBJECT_UPRIGHT = 0x45d7281e,
        NATIVE_TASK_SHAKE_FIST = 0x45df892a,
        NATIVE_SET_PED_PATH_MAY_USE_LADDERS = 0x45f69ac1,
        NATIVE_SET_VIEWPORT_MIRRORED = 0x465c1ebb,
        NATIVE_SWITCH_AMBIENT_PLANES = 0x46630621,
        NATIVE_CAN_START_MISSION_PASSED_TUNE = 0x46788161,
        NATIVE_GET_INTERIOR_FROM_DUMMY_CHAR = 0x468e8c58,
        NATIVE_UNLOAD_TEXT_FONT = 0x469a98c9,
        NATIVE_ENABLE_GPS_IN_VEHICLE = 0x46a845ac,
        NATIVE_GET_CONSOLE_COMMAND = 0x46c80b5b,
        NATIVE_DISPLAY_TEXT_WITH_STRING_AND_INT = 0x46d808cd,
        NATIVE_SET_CAM_NEAR_CLIP = 0x46db13b1,
        NATIVE_NETWORK_JOIN_GAME_SUCCEEDED = 0x46e9e85e,
        NATIVE_SET_MENU_ITEM_WITH_NUMBER = 0x470d1150,
        NATIVE_CREATE_TEMPORARY_RADAR_BLIPS_FOR_PICKUPS_IN_AREA = 0x470f20a8,
        NATIVE_HAS_CHAR_BEEN_DAMAGED_BY_CAR = 0x471a674e,
        NATIVE_SET_DEFAULT_GLOBAL_INSTANCE_PRIORITY = 0x47280f2d,
        NATIVE_GET_CHAR_MOVE_ANIM_SPEED_MULTIPLIER = 0x47a9ccc3,
        NATIVE_CREATE_PICKUP_WITH_AMMO = 0x47c32331,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_SIGHT_RANGE = 0x47c6b4ec,
        NATIVE_SET_NETWORK_ID_CAN_MIGRATE = 0x47c8e5ff,
        NATIVE_PRINT_WITH_3_NUMBERS = 0x47d16d4f,
        NATIVE_CLEAR_SEQUENCE_TASK = 0x47ed03ce,
        NATIVE_SET_ROOM_FOR_VIEWPORT_BY_KEY = 0x480764d9,
        NATIVE_GET_EXTRA_CAR_COLOURS = 0x4839c869,
        NATIVE_DESTROY_THREAD = 0x484829ea,
        NATIVE_SET_OBJECT_ANIM_SPEED = 0x485459f9,
        NATIVE_IS_IN_CAR_FIRE_BUTTON_PRESSED = 0x48576c9c,
        NATIVE_LOCATE_OBJECT_3D = 0x4865a2b9,
        NATIVE_MODIFY_CHAR_MOVE_STATE = 0x4874642a,
        NATIVE_TASK_CAR_TEMP_ACTION = 0x488df9bf,
        NATIVE_DISPLAY_AREA_NAME = 0x489fdd41,
        NATIVE_REMOVE_GROUP = 0x48d72b88,
        NATIVE_GET_MOUSE_WHEEL = 0x48e57e00,
        NATIVE_SET_PED_PATH_WILL_AVOID_DYNAMIC_OBJECTS = 0x48e5a279,
        NATIVE_SET_CHAR_COMPONENT_VARIATION = 0x4937ebf1,
        NATIVE_SKIP_TO_END_AND_STOP_PLAYBACK_RECORDED_CAR = 0x49452268,
        NATIVE_SET_PETROL_TANK_HEALTH = 0x49662e8a,
        NATIVE_SWITCH_CAR_SIREN = 0x4977387b,
        NATIVE_GET_KEY_FOR_VIEWPORT_IN_ROOM = 0x4994f71c,
        NATIVE_IS_OBJECT_STATIC = 0x49a1dd0e,
        NATIVE_FORCE_TIME_OF_DAY = 0x49b6ed13,
        NATIVE_IS_CAR_IN_AREA_2D = 0x49cb1827,
        NATIVE_IS_CHAR_SITTING_IDLE = 0x49cbfa86,
        NATIVE_SET_HAS_BEEN_OWNED_BY_PLAYER = 0x49cd58f6,
        NATIVE_TRIGGER_VEH_ALARM = 0x49eac5b5,
        NATIVE_SET_ALL_RANDOM_PEDS_FLEE = 0x49eae968,
        NATIVE_START_NEW_SCRIPT_WITH_ARGS = 0x4a2100e4,
        NATIVE_TASK_DRIVE_POINT_ROUTE = 0x4a2f3753,
        NATIVE_SET_BLIP_THROTTLE_RANDOMLY = 0x4a4a01d5,
        NATIVE_IS_PLAYER_CLIMBING = 0x4a9e9ae0,
        NATIVE_GET_CURRENT_ZONE_SCUMMINESS = 0x4aa2217d,
        NATIVE_STOP_PED_WEAPON_FIRING_WHEN_DROPPED = 0x4ac3421e,
        NATIVE_TASK_GO_TO_CHAR = 0x4ad6b534,
        NATIVE_TAKE_REMOTE_CONTROL_OF_CAR = 0x4ad74bce,
        NATIVE_CLEAR_SCRIPTED_CONVERSION_CENTRE = 0x4adadb05,
        NATIVE_USE_DETONATOR = 0x4b1a3b59,
        NATIVE_SET_CHAR_AS_MISSION_CHAR = 0x4b2f3ce0,
        NATIVE_PLAY_AUDIO_EVENT = 0x4b31ce89,
        NATIVE_WASH_VEHICLE_TEXTURES = 0x4b3a26aa,
        NATIVE_OVERRIDE_FREEZE_FLAGS = 0x4b3df87e,
        NATIVE_SET_CAM_INTERP_STYLE_CORE = 0x4b40c67c,
        NATIVE_GET_STATE_OF_CLOSEST_DOOR_OF_TYPE = 0x4b44a83d,
        NATIVE_GET_CAR_ANIM_CURRENT_TIME = 0x4b47eb16,
        NATIVE_GET_LEVEL_DESIGN_COORDS_FOR_OBJECT = 0x4b4c911a,
        NATIVE_GET_RANDOM_CAR_FRONT_BUMPER_IN_SPHERE_NO_SAVE = 0x4b4cb576,
        NATIVE_IS_CAM_ACTIVE = 0x4b58f177,
        NATIVE_GET_VIEWPORT_POSITION_OF_COORD = 0x4bf2a1d7,
        NATIVE_IS_CAR_PLAYING_ANIM = 0x4bf743cd,
        NATIVE_GET_NUMBER_OF_PLAYERS = 0x4c1b8867,
        NATIVE_GET_RID_OF_PLAYER_PROSTITUTE = 0x4c2b53c0,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_CAN_CHANGE_TARGET = 0x4c4e4afd,
        NATIVE_GET_CAR_COLOURS = 0x4c637c64,
        NATIVE_SMASH_GLASS_ON_OBJECT = 0x4cb06a9f,
        NATIVE_IS_CAR_UPSIDEDOWN = 0x4ccf1871,
        NATIVE_SET_CHAR_COORDINATES_NO_OFFSET = 0x4ceb5fc3,
        NATIVE_RENDER_RADIOHUD_SPRITE_IN_MOBILE_PHONE = 0x4cf198ac,
        NATIVE_CLEAR_ROOM_FOR_OBJECT = 0x4cf50aeb,
        NATIVE_PED_QUEUE_CONSIDER_PEDS_WITH_FLAG_TRUE = 0x4d2f2888,
        NATIVE_UNFREEZE_RADIO_STATION = 0x4d46202c,
        NATIVE_IS_PC_VERSION = 0x4d5d9ee3,
        NATIVE_SET_ROT_ORDER = 0x4d8915cb,
        NATIVE_TASK_PERFORM_SEQUENCE = 0x4d9fbd11,
        NATIVE_CANCEL_CURRENTLY_PLAYING_AMBIENT_SPEECH = 0x4dbd473b,
        NATIVE_IS_CHAR_USING_MAP_ATTRACTOR = 0x4dc5a039,
        NATIVE_DRAW_SPHERE = 0x4dd1cb3a,
        NATIVE_USE_PLAYER_COLOUR_INSTEAD_OF_TEAM_COLOUR = 0x4dd46dae,
        NATIVE_WHAT_WILL_PLAYER_PICKUP = 0x4ddf9704,
        NATIVE_SET_CAR_COLOUR_COMBINATION = 0x4df55dca,
        NATIVE_FINISH_WIDGET_COMBO = 0x4e048a5a,
        NATIVE_GET_TIME_OF_DAY = 0x4e1de7a5,
        NATIVE_ARE_WIDESCREEN_BORDERS_ACTIVE = 0x4e26746c,
        NATIVE_LOCATE_CHAR_IN_CAR_CAR_3D = 0x4e3a44ae,
        NATIVE_COPY_CHAR_DECISION_MAKER = 0x4e3c95ac,
        NATIVE_DO_SCREEN_FADE_IN_UNHACKED = 0x4e7eab13,
        NATIVE_SET_SCRIPT_MIC_LOOK_AT = 0x4e90d291,
        NATIVE_MISSION_AUDIO_BANK_NO_LONGER_NEEDED = 0x4e92cc7a,
        NATIVE_SET_NEXT_DESIRED_MOVE_STATE = 0x4e937d57,
        NATIVE_DELETE_MENU = 0x4ea57e92,
        NATIVE_IS_MOBILE_PHONE_CALL_ONGOING = 0x4ed1400a,
        NATIVE_ATTACH_CAR_TO_OBJECT_PHYSICALLY = 0x4ed95ebb,
        NATIVE_LOCATE_CAR_2D = 0x4edc0cbf,
        NATIVE_CODE_WANTS_MOBILE_PHONE_REMOVED = 0x4eea45ea,
        NATIVE_SET_BIT = 0x4efe7e6b,
        NATIVE_NETWORK_SHOW_PLAYER_PROFILE_UI = 0x4f05a4be,
        NATIVE_ALLOW_ONE_TIME_ONLY_COMMANDS_TO_RUN = 0x4f23e174,
        NATIVE_FIND_TRAIN_DIRECTION = 0x4f2855b6,
        NATIVE_IS_SCREEN_FADED_IN = 0x4f37276d,
        NATIVE_PLAY_MOVIE = 0x4f39ed7a,
        NATIVE_ADD_HOSPITAL_RESTART = 0x4f3e3104,
        NATIVE_PRINT_WITH_2_NUMBERS_NOW = 0x4f62be65,
        NATIVE_GET_NETWORK_ID_FROM_PED = 0x4fa366e8,
        NATIVE_ADD_NEW_FRONTEND_CONVERSATION_SPEAKER = 0x4fad0d8f,
        NATIVE_GET_MOTION_SENSOR_VALUES = 0x4fed6c6e,
        NATIVE_SET_CHAR_MAX_HEALTH = 0x4ffaa9e8,
        NATIVE_DOES_PED_EXIST_WITH_NETWORK_ID = 0x4ffe7d83,
        NATIVE_SET_DEBUG_TEXT_VISIBLE = 0x50017383,
        NATIVE_SET_CHAR_DRUGGED_UP = 0x500ff2ab,
        NATIVE_GET_BLIP_INFO_ID_TYPE = 0x501d7b4e,
        NATIVE_PRINT_WITH_4_NUMBERS = 0x50358b9a,
        NATIVE_TIMESTEP = 0x50597ee2,
        NATIVE_RESERVE_NETWORK_MISSION_VEHICLES = 0x5062875e,
        NATIVE_HAS_OBJECT_FRAGMENT_ROOT_BEEN_DAMAGED = 0x506cc5f2,
        NATIVE_SET_CAM_ATTACH_OFFSET = 0x50725484,
        NATIVE_CLEAR_SCRIPT_ARRAY_FROM_SCRATCHPAD = 0x50770e90,
        NATIVE_REGISTER_TARGET = 0x50a95442,
        NATIVE_EXPLODE_CAR_IN_CUTSCENE_SHAKE_AND_BIT = 0x50d00039,
        NATIVE_IS_CONTROL_PRESSED = 0x517a4384,
        NATIVE_CLEAR_ADDITIONAL_TEXT = 0x518141e0,
        NATIVE_ALLOW_LOCKON_TO_FRIENDLY_PLAYERS = 0x51a7743f,
        NATIVE_START_PTFX_ON_PED_BONE = 0x51a7fb1b,
        NATIVE_TERMINATE_ALL_SCRIPTS_FOR_NETWORK_GAME = 0x51c902bd,
        NATIVE_SET_MAX_FIRE_GENERATIONS = 0x51d33d19,
        NATIVE_IS_COP_VEHICLE_IN_AREA_3D_NO_SAVE = 0x521aa517,
        NATIVE_SET_WEB_PAGE_SCROLL = 0x52549d0b,
        NATIVE_TASK_SMART_FLEE_CHAR = 0x5263a71d,
        NATIVE_DRAW_WINDOW = 0x5272cdc4,
        NATIVE_DISPLAY_TEXT_WITH_SUBSTRING_GIVEN_HASH_KEY = 0x527bf075,
        NATIVE_DISPLAY_RADAR = 0x52816bd4,
        NATIVE_START_CUSTOM_MOBILE_PHONE_RINGING = 0x52921ced,
        NATIVE_SUPPRESS_PED_MODEL = 0x52b0f091,
        NATIVE_HAS_OBJECT_BEEN_DAMAGED_BY_WEAPON = 0x52b3ffda,
        NATIVE_FORCE_WIND = 0x52f3afb9,
        NATIVE_GIVE_WEAPON_TO_CHAR = 0x5302dbc4,
        NATIVE_START_PLAYBACK_RECORDED_CAR = 0x5344a626,
        NATIVE_SET_NM_MESSAGE_VEC3 = 0x535f6dce,
        NATIVE_IS_MINIGAME_IN_PROGRESS = 0x53a95e13,
        NATIVE_LOAD_TXD = 0x53ac9059,
        NATIVE_STOP_PTFX = 0x53c54911,
        NATIVE_PRINT = 0x53c5f206,
        NATIVE_REGISTER_HATED_TARGETS_IN_AREA = 0x53cefaa1,
        NATIVE_ATTACH_OBJECT_TO_CAR = 0x53d67745,
        NATIVE_STORE_SCRIPT_VALUES_FOR_NETWORK_GAME = 0x53df52ba,
        NATIVE_CREATE_EMERGENCY_SERVICES_CAR_THEN_WALK = 0x53e5166c,
        NATIVE_GET_CUTSCENE_TIME = 0x53f5b5ab,
        NATIVE_SOUND_CAR_HORN = 0x54043d4e,
        NATIVE_NETWORK_GET_GAME_MODE = 0x542f6097,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_NAVIGATION_STYLE = 0x546e012c,
        NATIVE_NETWORK_SET_SESSION_INVITABLE = 0x548e9f99,
        NATIVE_DECREMENT_FLOAT_STAT = 0x5496e4d7,
        NATIVE_RESERVE_NETWORK_MISSION_PEDS = 0x54998c37,
        NATIVE_SET_CREDITS_TO_RENDER_BEFORE_FADE = 0x54c131c2,
        NATIVE_DO_AUTO_SAVE = 0x54c44b1a,
        NATIVE_CAM_SEQUENCE_GET_PROGRESS = 0x54f3a015,
        NATIVE_END_CHAR_SEARCH_CRITERIA = 0x54f5474f,
        NATIVE_GET_DAMAGE_TO_PED_BODY_PART = 0x54feb2b4,
        NATIVE_IS_INTERIOR_SCENE = 0x55226c13,
        NATIVE_SET_CHAR_DROPS_WEAPONS_WHEN_DEAD = 0x5550af04,
        NATIVE_IS_CHAR_MODEL = 0x5573709a,
        NATIVE_CREATE_CAR_GENERATOR_WITH_PLATE = 0x5582ff4b,
        NATIVE_UNOBFUSCATE_STRING = 0x558558df,
        NATIVE_IS_CHAR_IN_ANY_HELI = 0x55977ae5,
        NATIVE_SET_PLAYER_IS_IN_STADIUM = 0x559b48d5,
        NATIVE_SET_CAM_POINT_OFFSET_IS_RELATIVE = 0x55a80544,
        NATIVE_ALTER_WANTED_LEVEL = 0x55b888e7,
        NATIVE_SET_VEH_HAS_STRONG_AXLES = 0x560998a5,
        NATIVE_CLEAR_CUTSCENE = 0x562655bf,
        NATIVE_SET_EXTRA_HOSPITAL_RESTART_POINT = 0x56624446,
        NATIVE_NETWORK_GET_HEALTH_RETICULE_OPTION = 0x566d01e6,
        NATIVE_IS_PED_ATTACHED_TO_ANY_CAR = 0x566e69d1,
        NATIVE_GET_CLOSEST_ROAD = 0x567b0e11,
        NATIVE_CAN_PED_SHIMMY_IN_DIRECTION = 0x568fb0b9,
        NATIVE_STORE_DAMAGE_TRACKER_FOR_NETWORK_PLAYER = 0x56cbc08c,
        NATIVE_SET_TRAIN_AUDIO_ROLLOFF = 0x56f2f2e9,
        NATIVE_CHANGE_PICKUP_BLIP_COLOUR = 0x571b40a4,
        NATIVE_SET_MISSION_FLAG = 0x57592d52,
        NATIVE_HAS_CHAR_SPOTTED_CHAR_IN_FRONT = 0x57723144,
        NATIVE_SET_CAMERA_BEGIN_CAM_COMMANDS_REQUIRED = 0x5789f8e1,
        NATIVE_DEBUG_ON = 0x57987f1d,
        NATIVE_GET_MINUTES_TO_TIME_OF_DAY = 0x57cdc0ff,
        NATIVE_SET_CHAR_READY_TO_BE_STUNNED = 0x57d04bf3,
        NATIVE_DO_WEAPON_STUFF_AT_START_OF_2P_GAME = 0x57f48e09,
        NATIVE_GET_SERVER_ID = 0x57f9073c,
        NATIVE_CREATE_OBJECT_NO_OFFSET = 0x58040420,
        NATIVE_DRAW_CURVED_WINDOW_TEXT = 0x58059eb2,
        NATIVE_DOES_CAR_HAVE_ROOF = 0x5847f769,
        NATIVE_SET_DEAD_CHAR_COORDINATES = 0x584a72c5,
        NATIVE_CREATE_PLAYER = 0x584ba966,
        NATIVE_SET_CAM_FAR_DOF = 0x58515e8e,
        NATIVE_IS_CAR_LOW_RIDER = 0x58560132,
        NATIVE_SEND_CLIENT_BROADCAST_VARIABLES_NOW = 0x5857b1dc,
        NATIVE_CHANGE_PLAYBACK_TO_USE_AI = 0x58cb1ad5,
        NATIVE_NETWORK_SHOW_FRIEND_PROFILE_UI = 0x58d0361f,
        NATIVE_STRING_TO_INT = 0x590a8160,
        NATIVE_NETWORK_IS_RENDEZVOUS_HOST = 0x59502186,
        NATIVE_TASK_SIT_DOWN_ON_OBJECT = 0x595e56b4,
        NATIVE_IS_DAMAGE_TRACKER_ACTIVE_ON_NETWORK_ID = 0x597063ba,
        NATIVE_SET_PED_NON_REMOVAL_AREA = 0x599d82e7,
        NATIVE_REMOVE_SPHERE = 0x59c34f9b,
        NATIVE_ATTACH_CAR_TO_CAR = 0x59d32723,
        NATIVE_DISPLAY_NTH_ONSCREEN_COUNTER_WITH_STRING = 0x59f38676,
        NATIVE_TASK_COMBAT_TIMED = 0x59f7540c,
        NATIVE_IS_PEDS_VEHICLE_HOT = 0x5a0fb593,
        NATIVE_GET_AMMO_IN_CHAR_WEAPON = 0x5a31e7d8,
        NATIVE_SET_LOAD_COLLISION_FOR_OBJECT_FLAG = 0x5a5e2ddd,
        NATIVE_STOP_MOBILE_PHONE_RINGING = 0x5a6b9a9d,
        NATIVE_ACTIVATE_CHEAT = 0x5aa0d18e,
        NATIVE_RESTORE_SCRIPT_ARRAY_FROM_SCRATCHPAD = 0x5ab30fe1,
        NATIVE_TASK_PLAY_ANIM = 0x5ab552c6,
        NATIVE_MUTE_GAMEWORLD_AUDIO = 0x5aced7e2,
        NATIVE_FIX_CAR = 0x5ade88c7,
        NATIVE_TASK_CAR_MISSION_PED_TARGET_NOT_AGAINST_TRAFFIC = 0x5ae680e3,
        NATIVE_SET_TEXT_LINE_DISPLAY = 0x5ae8af79,
        NATIVE_ALLOCATE_SCRIPT_TO_RANDOM_PED = 0x5aeedf6d,
        NATIVE_REMOVE_PTFX_FROM_VEHICLE = 0x5af920a1,
        NATIVE_STOP_PED_DOING_FALL_OFF_TESTS_WHEN_SHOT = 0x5b01902a,
        NATIVE_GET_OBJECT_ROTATION_VELOCITY = 0x5b075c62,
        NATIVE_SET_CAR_LANE_SHIFT = 0x5b34491c,
        NATIVE_CLEAR_NETWORK_RESTART_NODE_GROUP_LIST = 0x5b4d98c0,
        NATIVE_INCREASE_PLAYER_MAX_ARMOUR = 0x5b60b6c7,
        NATIVE_START_MOBILE_PHONE_CALL = 0x5b7106af,
        NATIVE_REMOVE_SCRIPT_MIC = 0x5b8bb49a,
        NATIVE_CREATE_MOBILE_PHONE = 0x5bbc5e23,
        NATIVE_SET_CHAR_HEALTH = 0x5bc562bf,
        NATIVE_SET_FREE_RESPRAYS = 0x5bcec23c,
        NATIVE_HAVE_REQUESTED_PATH_NODES_BEEN_LOADED = 0x5bcedbce,
        NATIVE_GET_LEFT_PLAYER_CASH_TO_REACH_LEVEL = 0x5bd77188,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_TEAMWORK = 0x5be8e7ff,
        NATIVE_TASK_DRIVE_POINT_ROUTE_ADVANCED = 0x5be99735,
        NATIVE_PRINT_STRING_WITH_LITERAL_STRING = 0x5bfd20cb,
        NATIVE_IS_SNIPER_INVERTED = 0x5c3bf51b,
        NATIVE_SET_CHAR_BLEEDING = 0x5c498407,
        NATIVE_TASK_SMART_FLEE_POINT_PREFERRING_PAVEMENTS = 0x5c58d1aa,
        NATIVE_NETWORK_SET_SERVER_NAME = 0x5c5ee458,
        NATIVE_SET_BLIP_AS_SHORT_RANGE = 0x5c67725e,
        NATIVE_SET_HIDE_WEAPON_ICON = 0x5ceb0996,
        NATIVE_TASK_PLAY_ANIM_SECONDARY_IN_CAR = 0x5d0b869b,
        NATIVE_DIM_BLIP = 0x5d367a1b,
        NATIVE_SET_VEHICLE_ALPHA = 0x5d4a2bc2,
        NATIVE_HAS_SCRIPT_LOADED = 0x5d67f751,
        NATIVE_SET_CHAR_GESTURE_GROUP = 0x5d9136c3,
        NATIVE_SWITCH_PED_ROADS_BACK_TO_ORIGINAL = 0x5d926762,
        NATIVE_IS_PLAYER_IN_SHORTCUT_TAXI = 0x5da24fc0,
        NATIVE_START_GPS_RACE_TRACK = 0x5dbe3e58,
        NATIVE_HAS_CUTSCENE_FINISHED = 0x5ded14b4,
        NATIVE_CREATE_PICKUP = 0x5e14df68,
        NATIVE_IS_SCORE_GREATER = 0x5e183f8e,
        NATIVE_GET_SORTED_NETWORK_RESTART_NODE_OF_GROUP = 0x5e313647,
        NATIVE_SET_MULTIPLAYER_BRIEF = 0x5e370e21,
        NATIVE_DRAW_CURVED_WINDOW_NOTEXT = 0x5e626c72,
        NATIVE_GET_MENU_POSITION = 0x5ebcb9ac,
        NATIVE_SET_CHAR_ACCURACY = 0x5edbf9ed,
        NATIVE_NETWORK_START_SESSION_PENDING = 0x5edf1995,
        NATIVE_STOP_CUTSCENE = 0x5ee84dc7,
        NATIVE_ATTACH_PED_TO_CAR_PHYSICALLY = 0x5f2019c3,
        NATIVE_DO_SCREEN_FADE_OUT_UNHACKED = 0x5f4c7e83,
        NATIVE_SET_PED_HELMET_TEXTURE_INDEX = 0x5f6c3328,
        NATIVE_GET_HOST_ID = 0x5f70f5a3,
        NATIVE_START_FIRING_AMNESTY = 0x5f8a22a6,
        NATIVE_DOES_DECISION_MAKER_EXIST = 0x5f912485,
        NATIVE_GET_NTH_CLOSEST_CAR_NODE_WITH_HEADING_ON_ISLAND = 0x5f960544,
        NATIVE_CAN_PHONE_BE_SEEN_ON_SCREEN = 0x5f978584,
        NATIVE_POINT_FIXED_CAM_AT_VEHICLE = 0x5fdfd1e2,
        NATIVE_GET_MOUSE_SENSITIVITY = 0x5fe80264,
        NATIVE_TASK_SHOOT_AT_COORD = 0x601c22e3,
        NATIVE_SET_TEXT_CENTRE_WRAPX = 0x6035c07c,
        NATIVE_SET_VARIABLE_ON_SOUND = 0x606ee5fa,
        NATIVE_GET_MODEL_NAME_FOR_DEBUG = 0x6076b648,
        NATIVE_GET_NUM_CONSOLE_COMMAND_TOKENS = 0x608f5bc6,
        NATIVE_TASK_LEAVE_CAR_IN_DIRECTION = 0x60c23f62,
        NATIVE_SET_ENGINE_HEALTH = 0x60ccb3d1,
        NATIVE_IS_THIS_MODEL_A_CAR = 0x60e4c22f,
        NATIVE_TASK_CLEAR_LOOK_AT = 0x60eb4054,
        NATIVE_PRINT_STRING_IN_STRING_NOW = 0x610bda9e,
        NATIVE_DELETE_HTML_SCRIPT_OBJECT = 0x6113254c,
        NATIVE_SEARCH_CRITERIA_CONSIDER_PEDS_WITH_FLAG_TRUE = 0x611870d2,
        NATIVE_SET_VISIBILITY_OF_NEARBY_ENTITY_WITH_SPECIAL_ATTRIBUTE = 0x611a6bc2,
        NATIVE_CAN_REGISTER_MISSION_PED = 0x611f091e,
        NATIVE_GET_OFFSET_FROM_CAR_GIVEN_WORLD_COORDS = 0x613d9b90,
        NATIVE_GET_PLAYER_TO_PLACE_BOMB_IN_CAR = 0x61582290,
        NATIVE_PRINT_MISSION_DESCRIPTION = 0x61668a58,
        NATIVE_IS_SYSTEM_UI_SHOWING = 0x616b9910,
        NATIVE_IS_PLAYER_CONTROL_ON = 0x618857f2,
        NATIVE_GET_SAFE_PICKUP_COORDS = 0x618b5f67,
        NATIVE_IS_PLAYER_SCRIPT_CONTROL_ON = 0x61b00a84,
        NATIVE_TASK_TOGGLE_DUCK = 0x61cfbcbf,
        NATIVE_DESTROY_ALL_SCRIPT_VIEWPORTS = 0x61e70b8d,
        NATIVE_IS_PLAYER_TARGETTING_OBJECT = 0x622796d5,
        NATIVE_PRINT_BIG_Q = 0x623ba090,
        NATIVE_FORCE_INTERIOR_LIGHTING_FOR_PLAYER = 0x62407179,
        NATIVE_REMOVE_PLAYER_HELMET = 0x6255f3b4,
        NATIVE_IS_CHAR_IN_MELEE_COMBAT = 0x6258d814,
        NATIVE_IS_OBJECT_IN_AREA_2D = 0x626e0feb,
        NATIVE_PLAYSTATS_INT = 0x6270dfa6,
        NATIVE_GET_TIME_SINCE_LAST_ARREST = 0x62824ef4,
        NATIVE_PRINT_WITH_3_NUMBERS_NOW = 0x62895d42,
        NATIVE_ADD_BLIP_FOR_CONTACT = 0x6295b365,
        NATIVE_GET_HEIGHT_OF_VEHICLE = 0x62990cd4,
        NATIVE_HAS_MODEL_LOADED = 0x62bfdb37,
        NATIVE_GET_STATION_NAME = 0x62d15de6,
        NATIVE_SET_ROCKET_LAUNCHER_FREEBIE_IN_HELI = 0x62f3e0f3,
        NATIVE_PRINT_HELP_FOREVER_WITH_STRING_NO_SOUND = 0x63049363,
        NATIVE_CAM_SET_INTERP_STATE_DST = 0x630b4f0b,
        NATIVE_TRIGGER_PTFX_ON_VEH = 0x6337d904,
        NATIVE_SWITCH_ROADS_ON = 0x634305f6,
        NATIVE_NETWORK_HAS_STRICT_NAT = 0x635c9b5e,
        NATIVE_GET_BLIP_INFO_ID_CAR_INDEX = 0x635d6806,
        NATIVE_PRINTINT = 0x63651f03,
        NATIVE_PLAYSTATS_INT_INT = 0x636dcaec,
        NATIVE_PRINT_BIG = 0x637016c9,
        NATIVE_SET_LOAD_COLLISION_FOR_CHAR_FLAG = 0x63847a71,
        NATIVE_SLIDE_OBJECT = 0x63bfa7a0,
        NATIVE_ADD_BLIP_FOR_GANG_TERRITORY = 0x63ebc4fa,
        NATIVE_GET_HUD_COLOUR = 0x63f66a0b,
        NATIVE_FREEZE_CHAR_POSITION = 0x6410a13f,
        NATIVE_CLEAR_RELATIONSHIP = 0x642a9fed,
        NATIVE_CLOSE_MIC_PED = 0x64407cdc,
        NATIVE_SET_CHAR_DEFENSIVE_AREA_ATTACHED_TO_CAR = 0x644b0afb,
        NATIVE_SET_CHAR_IS_TARGET_PRIORITY = 0x6486ffea,
        NATIVE_GET_MODEL_PED_IS_HOLDING = 0x648f01b4,
        NATIVE_REMOVE_PICKUP = 0x64a7a0e0,
        NATIVE_SET_VEHICLE_CAN_BE_TARGETTED = 0x64b70b1d,
        NATIVE_GET_FIRST_BLIP_INFO_ID = 0x64c0273d,
        NATIVE_DOES_GAME_CODE_WANT_TO_LEAVE_NETWORK_SESSION = 0x64d300d9,
        NATIVE_BEGIN_CAM_COMMANDS = 0x6513042f,
        NATIVE_LOCATE_CHAR_IN_CAR_3D = 0x653b9b9f,
        NATIVE_GET_NUMBER_OF_FIRES_IN_RANGE = 0x654d93b7,
        NATIVE_DEACTIVATE_FRONTEND = 0x6590dd9a,
        NATIVE_GET_SORTED_NETWORK_RESTART_NODE_EXCLUDING_GROUP = 0x659a6507,
        NATIVE_SET_CHAR_BULLETPROOF_VEST = 0x65c99baf,
        NATIVE_GET_CAR_SIREN_HEALTH = 0x6614790d,
        NATIVE_IS_CAR_IN_WATER = 0x663b8371,
        NATIVE_SHOW_UPDATE_STATS = 0x663c3b15,
        NATIVE_SET_CHAR_SPHERE_DEFENSIVE_AREA = 0x66481957,
        NATIVE_FORCE_WEATHER = 0x664cda8d,
        NATIVE_SET_MAX_WANTED_LEVEL = 0x665a06f5,
        NATIVE_GET_PAD_PITCH_ROLL = 0x666ee1cb,
        NATIVE_UNREGISTER_SCRIPT_WITH_AUDIO = 0x66728efe,
        NATIVE_PRINT_HELP_WITH_STRING = 0x66735dd7,
        NATIVE_SET_CHAR_INVINCIBLE = 0x6677fa86,
        NATIVE_GET_CAM_POS = 0x66b9a87e,
        NATIVE_DO_SCREEN_FADE_IN = 0x66c1bdee,
        NATIVE_GET_OFFSET_FROM_OBJECT_IN_WORLD_COORDS = 0x66df1bf5,
        NATIVE_CLEAR_WANTED_LEVEL = 0x66e84958,
        NATIVE_SET_UP_TRIP_SKIP_FOR_VEHICLE_FINISHED_BY_SCRIPT = 0x66ed700c,
        NATIVE_IS_CAR_UPRIGHT = 0x6705b8b8,
        NATIVE_TO_FLOAT = 0x67116627,
        NATIVE_SET_MESSAGE_FORMATTING = 0x6718c384,
        NATIVE_HAVE_ANIMS_LOADED = 0x6720d74c,
        NATIVE_TASK_CAR_DRIVE_WANDER = 0x67371eb6,
        NATIVE_NETWORK_SET_TALKER_PROXIMITY = 0x67555c66,
        NATIVE_HAS_RESPRAY_HAPPENED = 0x6755eaed,
        NATIVE_NETWORK_IS_SESSION_ADVERTISE = 0x6781f5d0,
        NATIVE_ADD_WIDGET_FLOAT_SLIDER = 0x67865135,
        NATIVE_START_MOBILE_PHONE_RINGING = 0x67b39c65,
        NATIVE_FREEZE_ONSCREEN_TIMER = 0x67b636c6,
        NATIVE_SET_RAILTRACK_RESISTANCE_MULT = 0x67b74001,
        NATIVE_RELEASE_TWO_PLAYER_DISTANCE = 0x67df6fba,
        NATIVE_LIMIT_ANGLE = 0x67f03fbd,
        NATIVE_SET_PLAYBACK_SPEED = 0x684e26e4,
        NATIVE_HAS_CHAR_GOT_WEAPON = 0x6852825a,
        NATIVE_EXPLODE_CHAR_HEAD = 0x6862b5ae,
        NATIVE_SET_TAXI_LIGHTS = 0x68639d85,
        NATIVE_NETWORK_CHECK_INVITE_ARRIVAL = 0x686548fd,
        NATIVE_RESERVE_NETWORK_MISSION_OBJECTS_FOR_HOST = 0x688376e9,
        NATIVE_NETWORK_IS_OPERATION_PENDING = 0x6895f923,
        NATIVE_NETWORK_JOIN_SUMMONS = 0x68c293f4,
        NATIVE_SET_NETWORK_ID_EXISTS_ON_ALL_MACHINES = 0x68d486b2,
        NATIVE_POINT_CAM_AT_CAM = 0x68f1e398,
        NATIVE_SET_RICH_PRESENCE_TEMPLATESP2 = 0x68fdf488,
        NATIVE_SHUTDOWN_AND_LAUNCH_NETWORK_GAME = 0x691694d2,
        NATIVE_IS_CHAR_WAITING_FOR_WORLD_COLLISION = 0x6919bec0,
        NATIVE_DISPLAY_TEXT_WITH_2_NUMBERS = 0x6931fb7c,
        NATIVE_TOGGLE_TOPLEVEL_SPRITE = 0x6938a42d,
        NATIVE_PLAY_CAR_ANIM = 0x693eef6a,
        NATIVE_IS_NETWORK_PLAYER_ACTIVE = 0x695996a7,
        NATIVE_GET_MAX_AMMO_IN_CLIP = 0x6961e2a4,
        NATIVE_FORCE_NO_CAM_PAUSE = 0x69b4091b,
        NATIVE_GET_RANDOM_CAR_BACK_BUMPER_IN_SPHERE = 0x69bbc7c9,
        NATIVE_IS_CAR_STOPPED_AT_TRAFFIC_LIGHTS = 0x69be8c73,
        NATIVE_TASK_CAR_MISSION = 0x69dc9a92,
        NATIVE_DETACH_OBJECT = 0x6a1df29f,
        NATIVE_DRAW_LIGHT_WITH_RANGE = 0x6a396e9a,
        NATIVE_REMOVE_CHAR_FROM_GROUP = 0x6a44a7d4,
        NATIVE_PLAY_SOUND_FROM_OBJECT = 0x6a515a49,
        NATIVE_CONVERT_METRES_TO_FEET = 0x6a61eaf5,
        NATIVE_PRINT_HELP = 0x6a762b4e,
        NATIVE_IS_MESSAGE_BEING_DISPLAYED = 0x6a77fe8d,
        NATIVE_SET_CAM_INTERP_DETAIL_ROT_STYLE_ANGLES = 0x6acb30dc,
        NATIVE_SET_ROMANS_MOOD = 0x6adfbd5d,
        NATIVE_GET_SOUND_ID = 0x6ae0ad56,
        NATIVE_GET_CHAR_ANIM_CURRENT_TIME = 0x6ae57d9b,
        NATIVE_ACTIVATE_INTERIOR = 0x6b09b780,
        NATIVE_REMOVE_ALL_INACTIVE_GROUPS_FROM_CLEANUP_LIST = 0x6b0d3dcc,
        NATIVE_LOCATE_CHAR_ANY_MEANS_CAR_2D = 0x6b19c505,
        NATIVE_SET_CHAR_STAY_IN_CAR_WHEN_JACKED = 0x6b1f6703,
        NATIVE_REMOVE_SCRIPT_FIRE = 0x6b21fe26,
        NATIVE_PANIC_SCREAM = 0x6b3e4943,
        NATIVE_GET_SCRIPT_CAM = 0x6b7aae78,
        NATIVE_GET_PLAYER_CHAR = 0x6b86410e,
        NATIVE_PRINT_WITH_NUMBER_BIG = 0x6b9973ba,
        NATIVE_NETWORK_SET_FRIENDLY_FIRE_OPTION = 0x6baf95fa,
        NATIVE_GET_CLOSEST_STRAIGHT_ROAD = 0x6bcda69f,
        NATIVE_GET_BUFFERED_ASCII = 0x6bd5e066,
        NATIVE_SET_VEH_HAZARDLIGHTS = 0x6bdc9296,
        NATIVE_IS_CAR_STUCK_ON_ROOF = 0x6be03428,
        NATIVE_SET_SPECIFIC_PASSENGER_INDEX_TO_USE_IN_GROUPS = 0x6be47b20,
        NATIVE_HELI_AUDIO_SHOULD_SKIP_STARTUP = 0x6c0890fc,
        NATIVE_TASK_PICKUP_AND_CARRY_OBJECT = 0x6c47a7d6,
        NATIVE_IS_PLAYER_PERFORMING_WHEELIE = 0x6c82dfcf,
        NATIVE_GET_NUM_CAR_LIVERIES = 0x6c868323,
        NATIVE_SET_PHYS_CCD_HANDLES_ROTATION = 0x6c99221c,
        NATIVE_RESTART_SCRIPTED_CONVERSATION = 0x6cb24b56,
        NATIVE_SET_TARGET_CAR_FOR_MISSION_GARAGE = 0x6cd18670,
        NATIVE_CALCULATE_FURTHEST_NETWORK_RESTART_NODES = 0x6cef1a6a,
        NATIVE_CREATE_CAR_GENERATOR = 0x6cf7388d,
        NATIVE_GET_FRAGMENT_DAMAGE_HEALTH_OF_CLOSEST_OBJECT_OF_TYPE = 0x6d049fcc,
        NATIVE_CAM_SET_CINEMATIC = 0x6d08b75c,
        NATIVE_SET_CHAR_SUFFERS_CRITICAL_HITS = 0x6d0edbc8,
        NATIVE_SET_VIEWPORT_SHAPE = 0x6d239311,
        NATIVE_IS_VIEWPORT_ACTIVE = 0x6d40b30c,
        NATIVE_SET_CHAR_GET_OUT_UPSIDE_DOWN_CAR = 0x6d60e68d,
        NATIVE_GET_CAR_COORDINATES = 0x6d72044f,
        NATIVE_IS_IN_LAN_MODE = 0x6d76c5c9,
        NATIVE_INIT_CUTSCENE = 0x6d91e94a,
        NATIVE_REMOVE_ALL_NETWORK_RESTART_POINTS = 0x6dc1d245,
        NATIVE_GET_TEXTURE = 0x6dc9c895,
        NATIVE_AMBIENT_AUDIO_BANK_NO_LONGER_NEEDED = 0x6dcc98e9,
        NATIVE_HAS_DEATHARREST_EXECUTED = 0x6dcd115a,
        NATIVE_SET_PLAYER_NEVER_GETS_TIRED = 0x6dd90c30,
        NATIVE_HAS_CLOSEST_OBJECT_OF_TYPE_BEEN_DAMAGED_BY_CHAR = 0x6de6cd3e,
        NATIVE_SET_FADE_IN_AFTER_LOAD = 0x6e00eb0b,
        NATIVE_SET_ZONE_SCUMMINESS = 0x6e35cf9a,
        NATIVE_IS_MOBILE_PHONE_RADIO_ACTIVE = 0x6e502a5b,
        NATIVE_GET_VEHICLE_TYPE_OF_MODEL = 0x6e53485d,
        NATIVE_DONT_DISPLAY_LOADING_ON_FADE_THIS_FRAME = 0x6e545286,
        NATIVE_RETUNE_RADIO_TO_STATION_NAME = 0x6e7e4d33,
        NATIVE_CONNECT_LODS = 0x6e805d0d,
        NATIVE_SET_CHAR_WILL_LEAVE_CAR_IN_COMBAT = 0x6ea3ab85,
        NATIVE_OBFUSCATE_INT_ARRAY = 0x6ea9b0ae,
        NATIVE_TASK_GO_STRAIGHT_TO_COORD_RELATIVE_TO_CAR = 0x6ec876c2,
        NATIVE_DOES_TEXT_LABEL_EXIST = 0x6ecae560,
        NATIVE_DRAW_COLOURED_CYLINDER = 0x6ecba9ed,
        NATIVE_IS_ANY_PICKUP_AT_COORDS = 0x6ede3a6f,
        NATIVE_IS_CHAR_DUCKING = 0x6ee9a4b7,
        NATIVE_CHECK_STUCK_TIMER = 0x6eee10da,
        NATIVE_GET_PLAYER_RGB_COLOUR = 0x6ef43bbb,
        NATIVE_ALLOW_STUNT_JUMPS_TO_TRIGGER = 0x6f14a1b3,
        NATIVE_SET_RADAR_AS_INTERIOR_THIS_FRAME = 0x6f2626e1,
        NATIVE_GET_PAD_ORIENTATION = 0x6f2aa345,
        NATIVE_PAUSE_GAME = 0x6f32a4e2,
        NATIVE_LOCATE_CHAR_ON_FOOT_3D = 0x6f4e6448,
        NATIVE_SET_TEXT_WRAP = 0x6f60ab54,
        NATIVE_SET_PLAYER_MOOD_PISSED_OFF = 0x6f60e94e,
        NATIVE_DESTROY_VIEWPORT = 0x6f65e799,
        NATIVE_CLEAR_PED_NON_CREATION_AREA = 0x6f7043a3,
        NATIVE_ANCHOR_OBJECT = 0x6f76063f,
        NATIVE_TASK_STAND_STILL = 0x6f80965d,
        NATIVE_SET_CAM_INTERP_CUSTOM_SPEED_GRAPH = 0x6fa4434e,
        NATIVE_SET_ROOM_FOR_CAR_BY_KEY = 0x6fa5bd56,
        NATIVE_IS_EMERGENCY_SERVICES_VEHICLE = 0x6faf6f0c,
        NATIVE_IS_STREAMING_THIS_ADDITIONAL_TEXT = 0x6ff430bc,
        NATIVE_PLAYER_HAS_CHAR = 0x6ff7a2d3,
        NATIVE_OVERRIDE_NEXT_RESTART = 0x6ffd6e2f,
        NATIVE_GET_NETWORK_ID_FROM_VEHICLE = 0x700c3dda,
        NATIVE_NETWORK_HOST_RENDEZVOUS = 0x70224857,
        NATIVE_SET_VISIBILITY_OF_CLOSEST_OBJECT_OF_TYPE = 0x702faeeb,
        NATIVE_CLEAR_UP_TRIP_SKIP = 0x70568a4f,
        NATIVE_NETWORK_JOIN_GAME_PENDING = 0x7057787f,
        NATIVE_IS_PLACE_CAR_BOMB_ACTIVE = 0x7057b1c6,
        NATIVE_GET_VEHICLE_MODEL_FROM_INDEX = 0x70691b3c,
        NATIVE_SET_PLANE_THROTTLE = 0x706bbd86,
        NATIVE_IS_PED_LOOKING_AT_CAR = 0x708e1881,
        NATIVE_GET_OBJECT_MODEL = 0x70becf6a,
        NATIVE_IS_PLAYBACK_GOING_ON_FOR_CAR = 0x70c8d82c,
        NATIVE_REMOVE_CAR_RECORDING = 0x70f1b77e,
        NATIVE_LOCATE_CHAR_ON_FOOT_CHAR_3D = 0x70ff77e6,
        NATIVE_SET_PED_WITH_BRAIN_CAN_BE_CONVERTED_TO_DUMMY_PED = 0x71060a53,
        NATIVE_BLOCK_PEEKING_IN_COVER = 0x710c4e1a,
        NATIVE_GET_PLAYER_COLOUR = 0x710c76f6,
        NATIVE_IS_CAM_INTERPOLATING = 0x7159cb5d,
        NATIVE_START_STREAMING_REQUEST_LIST = 0x71998338,
        NATIVE_ACTIVATE_NETWORK_SETTINGS_MENU = 0x719c50aa,
        NATIVE_SET_PLAYER_CAN_BE_HASSLED_BY_GANGS = 0x71b305bb,
        NATIVE_SET_FREE_HEALTH_CARESET_FREE_HEALTH_CARE = 0x71c0464a,
        NATIVE_IS_REPLAY_SYSTEM_SAVING = 0x71e43510,
        NATIVE_ACTIVATE_VIEWPORT = 0x72175da6,
        NATIVE_SET_PED_IS_BLIND_RAGING = 0x724a81bf,
        NATIVE_SET_PLAYER_TEAM = 0x725adcf2,
        NATIVE_REGISTER_WORLD_POINT_SCRIPT_BRAIN = 0x725d91f7,
        NATIVE_SET_CAR_LIGHT_MULTIPLIER = 0x72610f9a,
        NATIVE_CREATE_EMERGENCY_SERVICES_CAR = 0x72625256,
        NATIVE_SET_ENABLE_RC_DETONATE = 0x726cdf5a,
        NATIVE_DRAW_TOPLEVEL_SPRITE = 0x728d1b2b,
        NATIVE_GET_PED_OBJECT_IS_ATTACHED_TO = 0x72adf3fc,
        NATIVE_POPULATE_NOW = 0x72c20700,
        NATIVE_GET_MOTION_CONTROLS_ENABLED = 0x72d970ba,
        NATIVE_SET_MULTIPLAYER_HUD_TIME = 0x72f2b585,
        NATIVE_GET_BLIP_SPRITE = 0x72ff2e73,
        NATIVE_IS_THIS_HELP_MESSAGE_WITH_NUMBER_BEING_DISPLAYED = 0x7303d366,
        NATIVE_FORCE_SPAWN_SCENARIO_PEDS_IN_AREA = 0x733089e7,
        NATIVE_SET_CHAR_COORDINATES_DONT_WARP_GANG_NO_OFFSET = 0x73487867,
        NATIVE_TASK_LEAVE_CAR_DONT_CLOSE_DOOR = 0x734e978d,
        NATIVE_SET_VEHICLE_STEER_BIAS = 0x7357c1eb,
        NATIVE_SET_MONEY_PICKUP_NETWORK_REGEN_TIME = 0x736823a0,
        NATIVE_SET_CAR_HAS_BEEN_CREATED_IN_INTERIOR = 0x737561da,
        NATIVE_IS_THIS_MODEL_A_PED = 0x73aa3b44,
        NATIVE_TASK_CHAR_SLIDE_TO_COORD_AND_PLAY_ANIM_HDG_RATE = 0x73be14b0,
        NATIVE_GET_AMMO_IN_CLIP = 0x73c100c3,
        NATIVE_GET_CAR_CHAR_IS_USING = 0x73ea87e1,
        NATIVE_BLOCK_CHAR_AMBIENT_ANIMS = 0x73fda4f4,
        NATIVE_STOP_SYNCING_SCRIPT_ANIMATIONS = 0x74098f99,
        NATIVE_SYNCH_RECORDING_WITH_WATER = 0x74537488,
        NATIVE_START_PTFX_ON_VEH = 0x7475356f,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_WEAPON_ACCURACY = 0x748f04ab,
        NATIVE_IS_CHAR_IN_ANY_CAR = 0x74c3e7a5,
        NATIVE_SET_IN_SPECTATOR_MODE = 0x74dbc1bf,
        NATIVE_SET_CONTENTS_OF_TEXT_WIDGET = 0x74e6f8f5,
        NATIVE_GET_WEB_PAGE_LINK_POSN = 0x75596ea5,
        NATIVE_NETWORK_GET_HOST_NAME = 0x755f37b6,
        NATIVE_REMOVE_ALL_CHAR_WEAPONS = 0x7569caae,
        NATIVE_GET_LOCAL_PLAYER_MP_CASH = 0x75a3813a,
        NATIVE_ATTACH_OBJECT_TO_OBJECT = 0x75f6a13e,
        NATIVE_IS_THIS_A_MINIGAME_SCRIPT = 0x7605ef6f,
        NATIVE_SET_VIEWPORT_PRIORITY = 0x7607fb4f,
        NATIVE_GET_CURRENT_LANGUAGE = 0x761be00b,
        NATIVE_IS_GAME_IN_CONTROL_OF_MUSIC = 0x7643170d,
        NATIVE_FLASH_BLIP = 0x76580d4c,
        NATIVE_SEARCH_CRITERIA_REJECT_PEDS_WITH_FLAG_FALSE = 0x7659e4da,
        NATIVE_IS_CAR_HEALTH_GREATER = 0x76833dc3,
        NATIVE_IS_CHAR_ON_PLAYER_MACHINE = 0x7690bff6,
        NATIVE_SET_MENU_COLUMN_ORIENTATION = 0x7695fe9e,
        NATIVE_GET_DEBUG_CAM = 0x76a50592,
        NATIVE_SET_CAM_INHERIT_ROLL_PED = 0x770d2b86,
        NATIVE_WAIT = 0x7715c03b,
        NATIVE_NETWORK_EXPAND_TO_32_PLAYERS = 0x7715e2db,
        NATIVE_SET_SIREN_WITH_NO_DRIVER = 0x77182d58,
        NATIVE_GET_VEHICLE_FROM_NETWORK_ID = 0x771f4ac6,
        NATIVE_GET_SCREEN_FADE_ALPHA = 0x771f7eeb,
        NATIVE_SET_PICKUP_COLLECTABLE_BY_CAR = 0x773cc2dd,
        NATIVE_NETWORK_SHOW_MET_PLAYER_FEEDBACK_UI = 0x7759a85a,
        NATIVE_GET_GFWL_HAS_SAFE_HOUSE = 0x7774811c,
        NATIVE_ADD_CAR_TO_MISSION_DELETION_LIST = 0x77c876a6,
        NATIVE_GET_TIME_SINCE_PLAYER_RAN_LIGHT = 0x77e9ff3e,
        NATIVE_STORE_SCORE = 0x77f7d38e,
        NATIVE_GET_CURRENT_PLAYBACK_NUMBER_FOR_CAR = 0x78086269,
        NATIVE_DRAW_WINDOW_TEXT = 0x781c5c59,
        NATIVE_GET_CURRENT_DATE = 0x781d7c7d,
        NATIVE_STOP_MOVIE = 0x7827e516,
        NATIVE_FORCE_GAME_TELESCOPE_CAM = 0x78565afc,
        NATIVE_GET_NAME_OF_ZONE = 0x7875ce91,
        NATIVE_HAS_CAR_BEEN_DAMAGED_BY_CAR = 0x7887012b,
        NATIVE_DOES_OBJECT_HAVE_THIS_MODEL = 0x7890b477,
        NATIVE_SET_CAR_WATERTIGHT = 0x789be554,
        NATIVE_REGISTER_NETWORK_BEST_GAME_SCORES = 0x78a27645,
        NATIVE_ALTER_WANTED_LEVEL_NO_DROP = 0x78b255f7,
        NATIVE_ALLOW_AUTO_CONVERSATION_LOOKATS = 0x78c7805c,
        NATIVE_TASK_FLEE_CHAR_ANY_MEANS = 0x78cdd466,
        NATIVE_IS_THREAD_ACTIVE = 0x78d7a5a0,
        NATIVE_GET_NO_OF_PLAYERS_IN_TEAM = 0x78d7c5bb,
        NATIVE_IS_PROJECTILE_IN_AREA = 0x78e1a557,
        NATIVE_CHANGE_BLIP_TEAM_RELEVANCE = 0x79100c76,
        NATIVE_SET_CHAR_VISIBLE = 0x792360dc,
        NATIVE_IS_SCREEN_FADING_OUT = 0x79275a57,
        NATIVE_IS_THIS_HELP_MESSAGE_BEING_DISPLAYED = 0x792ecc8c,
        NATIVE_SET_ZONE_NO_COPS = 0x793b35b6,
        NATIVE_COPY_SHARED_COMBAT_DECISION_MAKER = 0x7957466c,
        NATIVE_NETWORK_HOST_GAME = 0x79a5f0c4,
        NATIVE_SWITCH_STREAMING = 0x79d5836e,
        NATIVE_GET_CURRENT_TAXI_CAR_MODEL = 0x79dd4dc5,
        NATIVE_COMPARE_STRING = 0x79e7938d,
        NATIVE_TASK_PLAY_ANIM_READY_TO_BE_EXECUTED = 0x79eaac23,
        NATIVE_ATAN = 0x7a03cc8e,
        NATIVE_SET_NM_MESSAGE_STRING = 0x7a0df013,
        NATIVE_NETWORK_IS_PLAYER_MUTED_BY_ME = 0x7a21050e,
        NATIVE_CAN_RENDER_RADIOHUD_SPRITE_IN_MOBILE_PHONE = 0x7a4ebf9a,
        NATIVE_SET_VEHICLE_QUATERNION = 0x7a5b849e,
        NATIVE_SET_CAM_SPLINE_PROGRESS = 0x7a656c32,
        NATIVE_LINE = 0x7a6d718f,
        NATIVE_SET_MISSION_PICKUP_SOUND = 0x7a8f9cea,
        NATIVE_SET_PED_NON_CREATION_AREA = 0x7a97283f,
        NATIVE_PRINT_WITH_6_NUMBERS_NOW = 0x7aaca55b,
        NATIVE_GET_PLAYER_RADIO_STATION_NAME_ROLL = 0x7abcad40,
        NATIVE_REGISTER_PLAYER_RESPAWN_COORDS = 0x7ac5fedc,
        NATIVE_NETWORK_LEAVE_GAME_PENDING = 0x7ac97d6f,
        NATIVE_ADD_COMBAT_DECISION_MAKER_EVENT_RESPONSE = 0x7ad533ba,
        NATIVE_GIVE_REMOTE_CONTROLLED_MODEL_TO_PLAYER = 0x7ae18c67,
        NATIVE_TASK_GUARD_ASSIGNED_DEFENSIVE_AREA = 0x7af0133d,
        NATIVE_SET_CHAR_DESIRED_HEADING = 0x7b0bfd93,
        NATIVE_GET_BLIP_INFO_ID_POSITION = 0x7b0ce904,
        NATIVE_TASK_SET_CHAR_DECISION_MAKER = 0x7b58e93d,
        NATIVE_IS_CHAR_GESTURING = 0x7b6ee700,
        NATIVE_TASK_LOOK_AT_COORD = 0x7b784dd8,
        NATIVE_SET_GROUP_SEPARATION_RANGE = 0x7b820cd5,
        NATIVE_STOP_PED_MOBILE_RINGING = 0x7b89bcc9,
        NATIVE_TASK_SEEK_COVER_TO_OBJECT = 0x7baa54e3,
        NATIVE_PRINT_STRING_WITH_SUBSTRING_GIVEN_HASH_KEY_NOW = 0x7bbabe18,
        NATIVE_IS_BUTTON_PRESSED = 0x7bcb3f15,
        NATIVE_SET_RICH_PRESENCE = 0x7bdcbd45,
        NATIVE_FORCE_ALL_VEHICLE_LIGHTS_OFF = 0x7c1b8647,
        NATIVE_SET_TRAIN_FORCED_TO_SLOW_DOWN = 0x7c3600d4,
        NATIVE_WAITUNPAUSED = 0x7c496803,
        NATIVE_GET_MENU_ITEM_ACCEPTED = 0x7c4e6deb,
        NATIVE_SET_GRAVITY_OFF = 0x7c65ca59,
        NATIVE_IS_CHAR_IN_TAXI = 0x7c705f01,
        NATIVE_ATTACH_OBJECT_TO_OBJECT_PHYSICALLY = 0x7c98bd8e,
        NATIVE_NETWORK_HOST_GAME_PENDING = 0x7ca0e52b,
        NATIVE_SET_SCRIPTED_ANIM_SEAT_OFFSET = 0x7ceffa45,
        NATIVE_IS_PAIN_PLAYING = 0x7cfd6ba0,
        NATIVE_SWITCH_POLICE_HELIS = 0x7d37e46e,
        NATIVE_SET_HINT_TIMES_DEFAULT = 0x7d42a295,
        NATIVE_SET_HINT_MOVE_IN_DIST_DEFAULT = 0x7d4c10e3,
        NATIVE_SET_CAR_GENERATORS_ACTIVE_IN_AREA = 0x7d56439e,
        NATIVE_SET_CAR_AS_MISSION_CAR = 0x7d5e8472,
        NATIVE_REGISTER_TRACK_NUMBER = 0x7d7e9e4c,
        NATIVE_GET_OFFSET_FROM_INTERIOR_IN_WORLD_COORDS = 0x7d8f26a1,
        NATIVE_IS_HINT_RUNNING = 0x7d908973,
        NATIVE_DISPLAY_TEXT_WITH_BLIP_NAME = 0x7dc5dce6,
        NATIVE_NETWORK_IS_BEING_KICKED = 0x7dc7097c,
        NATIVE_GET_CLOSEST_CAR_NODE = 0x7dd4ce01,
        NATIVE_GET_FIRST_N_CHARACTERS_OF_LITERAL_STRING = 0x7de21cec,
        NATIVE_IS_CLOSEST_OBJECT_OF_TYPE_SMASHED_OR_DAMAGED = 0x7e3857ce,
        NATIVE_CAN_REGISTER_MISSION_OBJECT = 0x7e38b6c7,
        NATIVE_NETWORK_FIND_GAME = 0x7e553fb6,
        NATIVE_SET_CHAR_READY_TO_BE_EXECUTED = 0x7e59848e,
        NATIVE_DONT_DISPATCH_COPS_FOR_PLAYER = 0x7e64dcde,
        NATIVE_IS_THIS_MODEL_A_BIKE = 0x7e702cdd,
        NATIVE_SET_CAMERA_STATE = 0x7e80555e,
        NATIVE_HAS_PLAYER_DAMAGED_AT_LEAST_ONE_VEHICLE = 0x7e99e4fe,
        NATIVE_SET_STAT_FRONTEND_ALWAYS_VISIBLE = 0x7ea7d0e5,
        NATIVE_COPY_SHARED_CHAR_DECISION_MAKER = 0x7ebb892b,
        NATIVE_TAKE_SCREEN_SHOT = 0x7ecb89a9,
        NATIVE_NETWORK_KICK_PLAYER = 0x7edd6266,
        NATIVE_SET_ALLOW_DUMMY_CONVERSIONS = 0x7f0d7e5b,
        NATIVE_IS_PLAYER_BEING_ARRESTED = 0x7f6a60d3,
        NATIVE_REGISTER_HATED_TARGETS_AROUND_PED = 0x7f87559e,
        NATIVE_TRIGGER_MISSION_COMPLETE_AUDIO = 0x7f8ad6d6,
        NATIVE_ADD_LINE_TO_MOBILE_PHONE_CALL = 0x7f8c2272,
        NATIVE_CLEAR_EVENT_PRECEDENCE = 0x7f8ea522,
        NATIVE_CELL_CAM_SET_ZOOM = 0x7f9ef5a1,
        NATIVE_GET_EPISODE_INDEX_FROM_SUMMONS = 0x7fa5a17c,
        NATIVE_SET_NM_MESSAGE_INT = 0x7fa76ee4,
        NATIVE_IS_BUTTON_JUST_PRESSED = 0x7fcd1fa1,
        NATIVE_SET_PHONE_HUD_ITEM = 0x7fd60931,
        NATIVE_SET_CHAR_AS_ENEMY = 0x7fed5ff2,
        NATIVE_GET_CHAR_ARMOUR = 0x7ff4e3ce,
        NATIVE_SET_BRIANS_MOOD = 0x7ff92cd4,
        NATIVE_PRINT_WITH_NUMBER_NOW = 0x7fff2957,
        NATIVE_SET_FORCE_LOOK_BEHIND = 0x8023a6b0,
        NATIVE_CONVERT_INT_TO_PLAYERINDEX = 0x8035e327,
        NATIVE_SET_INFORM_RESPECTED_FRIENDS = 0x8040fee5,
        NATIVE_GET_OBJECT_FROM_NETWORK_ID = 0x8055551f,
        NATIVE_USE_PREVIOUS_FONT_SETTINGS = 0x8056f873,
        NATIVE_SET_ENABLE_NEAR_CLIP_SCAN = 0x805814e3,
        NATIVE_PRIORITIZE_STREAMING_REQUEST = 0x8058667c,
        NATIVE_ADD_WIDGET_READ_ONLY = 0x806eec47,
        NATIVE_GENERATE_RANDOM_FLOAT_IN_RANGE = 0x80a36a9c,
        NATIVE_HAS_THIS_ADDITIONAL_TEXT_LOADED = 0x80a52040,
        NATIVE_TASK_GO_STRAIGHT_TO_COORD = 0x80a9e7a7,
        NATIVE_SET_TEXT_FONT = 0x80bc530d,
        NATIVE_SWITCH_PED_PATHS_ON = 0x80d98bb2,
        NATIVE_GET_NTH_CLOSEST_CAR_NODE = 0x8109a334,
        NATIVE_GET_NEXT_CLOSEST_CAR_NODE = 0x810b595b,
        NATIVE_GET_PLAYER_MAX_HEALTH = 0x8154e470,
        NATIVE_IS_CHAR_GETTING_UP = 0x815e1c7b,
        NATIVE_DOES_CAR_HAVE_STUCK_CAR_CHECK = 0x818bf53e,
        NATIVE_PRINT_WITH_4_NUMBERS_NOW = 0x81931ae2,
        NATIVE_MUTE_POSITIONED_RADIO = 0x819efcfd,
        NATIVE_NETWORK_INVITE_FRIEND = 0x81a2a4ca,
        NATIVE_POINT_CAM_AT_PED = 0x81bc4966,
        NATIVE_RESET_CAR_WHEELS = 0x821f6ba7,
        NATIVE_NETWORK_CHANGE_GAME_MODE_PENDING = 0x8226f769,
        NATIVE_SAY_AMBIENT_SPEECH = 0x822ba388,
        NATIVE_SET_CHAR_ANIM_SPEED = 0x8236e8e0,
        NATIVE_GET_CHAR_WEAPON_IN_SLOT = 0x82abaa80,
        NATIVE_TASK_SMART_FLEE_CHAR_PREFERRING_PAVEMENTS = 0x82abe2ac,
        NATIVE_NETWORK_GET_SERVER_NAME = 0x82b4acb1,
        NATIVE_GET_SEQUENCE_PROGRESS_RECURSIVE = 0x82de239d,
        NATIVE_CAN_REGISTER_MISSION_VEHICLE = 0x82e4dbe4,
        NATIVE_TASK_AIM_GUN_AT_CHAR = 0x83080242,
        NATIVE_SET_RICH_PRESENCE_TEMPLATESP1 = 0x832b28da,
        NATIVE_FIND_NEAREST_ENTITIES_WITH_SPECIAL_ATTRIBUTE = 0x833d5180,
        NATIVE_SET_TIME_OF_NEXT_APPOINTMENT = 0x834d6ed2,
        NATIVE_CLEAR_ROOM_FOR_CAR = 0x834f3bff,
        NATIVE_IS_PED_IN_GROUP = 0x836d9795,
        NATIVE_CAN_REGISTER_MISSION_ENTITIES = 0x83794008,
        NATIVE_PRINTINT2 = 0x83b2e331,
        NATIVE_SET_CAM_ROLL = 0x83c38c64,
        NATIVE_STOP_END_CREDITS_MUSIC = 0x83ceb72b,
        NATIVE_DELETE_ALL_TRAINS = 0x83de7abf,
        NATIVE_TASK_SEEK_COVER_FROM_POS = 0x83f18ee9,
        NATIVE_NETWORK_FINISH_EXTENDED_SEARCH = 0x840af364,
        NATIVE_SET_MOBILE_PHONE_POSITION = 0x841800b3,
        NATIVE_NETWORK_SET_MATCH_PROGRESS = 0x841c0d19,
        NATIVE_SET_CHAR_DEFENSIVE_AREA_ATTACHED_TO_PED = 0x84407447,
        NATIVE_GET_CAR_MASS = 0x846d03e7,
        NATIVE_IS_CHAR_ON_FOOT = 0x84bd7342,
        NATIVE_LOCATE_CHAR_IN_CAR_CHAR_2D = 0x84c30447,
        NATIVE_SET_FREEBIES_IN_VEHICLE = 0x84c8f466,
        NATIVE_SET_VOICE_ID_FROM_HEAD_COMPONENT = 0x84edb1b8,
        NATIVE_IS_CHAR_USING_ANY_SCENARIO = 0x85018dc2,
        NATIVE_NETWORK_SEND_TEXT_CHAT = 0x85022d87,
        NATIVE_PLAY_OBJECT_ANIM = 0x853e879e,
        NATIVE_CLEAR_AREA = 0x854e9ab8,
        NATIVE_GET_RANDOM_CAR_IN_SPHERE = 0x85a18786,
        NATIVE_SET_FAKE_WANTED_LEVEL = 0x85b1c9fa,
        NATIVE_SET_EXTRA_CAR_COLOURS = 0x85bb75b6,
        NATIVE_IS_PLAYER_FREE_FOR_AMBIENT_TASK = 0x85c7e232,
        NATIVE_SKIP_TO_NEXT_SCRIPTED_CONVERSATION_LINE = 0x85c98304,
        NATIVE_POW = 0x85d134f8,
        NATIVE_HAS_CHAR_BEEN_DAMAGED_BY_WEAPON = 0x85d3cc9f,
        NATIVE_IS_PED_FLEEING = 0x85d813c6,
        NATIVE_TASK_OPEN_PASSENGER_DOOR = 0x85e6fb5f,
        NATIVE_UNLOCK_RAGDOLL = 0x860b7f20,
        NATIVE_FLUSH_ALL_PLAYER_RESPAWN_COORDS = 0x86149e7c,
        NATIVE_DEACTIVATE_SCRIPT_POPULATION_ZONE = 0x862213d3,
        NATIVE_EXPLODE_CAR_IN_CUTSCENE = 0x8645b709,
        NATIVE_CAN_FONT_BE_LOADED = 0x865a02d2,
        NATIVE_SET_GROUP_FOLLOW_STATUS = 0x865b9dac,
        NATIVE_SET_ROOM_FOR_CHAR_BY_NAME = 0x868589e4,
        NATIVE_PRINTNL = 0x868997da,
        NATIVE_FLASH_WEAPON_ICON = 0x868fd46b,
        NATIVE_GET_BLIP_INFO_ID_PICKUP_INDEX = 0x86913d37,
        NATIVE_TASK_GUARD_SPHERE_DEFENSIVE_AREA = 0x86b76cb7,
        NATIVE_SET_CAR_ONLY_DAMAGED_BY_RELATIONSHIP_GROUP = 0x86bbd0bf,
        NATIVE_DELETE_MISSION_TRAIN = 0x86c9497d,
        NATIVE_UNPAUSE_RADIO = 0x86cff426,
        NATIVE_IS_PLAYER_ONLINE_GAMESPY = 0x86d608a4,
        NATIVE_ADD_AMMO_TO_CHAR = 0x86e05b02,
        NATIVE_DONT_SUPPRESS_PED_MODEL = 0x87038c38,
        NATIVE_GET_NUMBER_OF_WEB_PAGE_LINKS = 0x8721c767,
        NATIVE_DROP_OBJECT = 0x8723dddc,
        NATIVE_TASK_LEAVE_GROUP = 0x87288270,
        NATIVE_DOES_VEHICLE_EXIST = 0x8737cc23,
        NATIVE_SET_SCENARIO_PED_DENSITY_MULTIPLIER = 0x874b05be,
        NATIVE_HAS_OBJECT_BEEN_DAMAGED_BY_CHAR = 0x87836d8b,
        NATIVE_REMOVE_TXD = 0x87a1cc5b,
        NATIVE_FORCE_RANDOM_PED_TYPE = 0x87e547d9,
        NATIVE_REGISTER_GAME_TYPE_ID = 0x87f3a645,
        NATIVE_SET_PED_DENSITY_MULTIPLIER = 0x87fdb5d1,
        NATIVE_SET_USES_COLLISION_OF_CLOSEST_OBJECT_OF_TYPE = 0x88042dc7,
        NATIVE_SET_CHAR_NOT_DAMAGED_BY_RELATIONSHIP_GROUP = 0x880fc806,
        NATIVE_TASK_FOLLOW_NAV_MESH_AND_SLIDE_TO_COORD = 0x882af382,
        NATIVE_GET_TIME_SINCE_PLAYER_DROVE_ON_PAVEMENT = 0x8836e732,
        NATIVE_IS_PAY_N_SPRAY_ACTIVE = 0x8838587e,
        NATIVE_FIND_MAX_NUMBER_OF_GROUP_MEMBERS = 0x889df868,
        NATIVE_GET_MOBILE_PHONE_RENDER_ID = 0x88e4fece,
        NATIVE_SET_OBJECT_LIGHTS = 0x88eb06e8,
        NATIVE_DISABLE_FRONTEND_RADIO = 0x88eccab4,
        NATIVE_FORCE_PED_TO_LOAD_COVER = 0x89029959,
        NATIVE_TURN_CAR_TO_FACE_COORD = 0x89073b0f,
        NATIVE_SET_DO_NOT_SPAWN_PARKED_CARS_ON_TOP = 0x8924931e,
        NATIVE_GET_NETWORK_JOIN_FAIL = 0x8931712f,
        NATIVE_RESET_WEAPON_PICKUP_NETWORK_REGEN_TIME = 0x89760433,
        NATIVE_SET_RENDER_TRAIN_AS_DERAILED = 0x899d9092,
        NATIVE_PRINT_HELP_WITH_STRING_NO_SOUND = 0x89a0ff88,
        NATIVE_PLAYER_HAS_GREYED_OUT_STARS = 0x89af0283,
        NATIVE_GET_PLAYER_RADIO_MODE = 0x89c29d95,
        NATIVE_UPDATE_NETWORK_STATISTICS = 0x89cf3b57,
        NATIVE_DO_SCREEN_FADE_OUT = 0x89d01805,
        NATIVE_SHAKE_PAD = 0x8a2ff5c8,
        NATIVE_READ_LOBBY_PREFERENCE = 0x8a31914c,
        NATIVE_COMPARE_TWO_DATES = 0x8a3a0bbc,
        NATIVE_SAVE_SCRIPT_ARRAY_IN_SCRATCHPAD = 0x8a3a3c98,
        NATIVE_SET_ALL_CARS_CAN_BE_DAMAGED = 0x8a3e2dfd,
        NATIVE_PLAYSTATS_INT_FLOAT = 0x8a4a3639,
        NATIVE_FIND_POSITION_IN_RECORDING = 0x8a585e98,
        NATIVE_DISABLE_CAR_GENERATORS = 0x8a5bba90,
        NATIVE_PLAY_SOUND_FROM_VEHICLE = 0x8a5f9685,
        NATIVE_SET_SLEEP_MODE_ACTIVE = 0x8ac848ba,
        NATIVE_UNOBFUSCATE_INT_ARRAY = 0x8acdfbba,
        NATIVE_IS_THIS_MODEL_A_HELI = 0x8af7f568,
        NATIVE_GET_NUMBER_LINES = 0x8afecc9b,
        NATIVE_SET_TEXT_WRAPX = 0x8b219681,
        NATIVE_SET_ALL_CAR_GENERATORS_BACK_TO_ACTIVE = 0x8b334400,
        NATIVE_CREATE_CAR = 0x8b3fed78,
        NATIVE_SWITCH_MAD_DRIVERS = 0x8b425e30,
        NATIVE_RELEASE_ENTITY_FROM_ROPE_FOR_OBJECT = 0x8b5865f8,
        NATIVE_REGISTER_BEST_POSITION = 0x8b5f99e2,
        NATIVE_SET_HINT_TIMES = 0x8b77559f,
        NATIVE_SET_NETWORK_PLAYER_AS_VIP = 0x8b87f9e1,
        NATIVE_SET_CAR_FORWARD_SPEED = 0x8baaf091,
        NATIVE_TASK_COMBAT_ROLL = 0x8bb401ce,
        NATIVE_SET_CHAR_USES_DEAFULT_ANIM_GROUP_WHEN_FLEEING = 0x8bc4dc20,
        NATIVE_CLEAR_BIT = 0x8bc9e618,
        NATIVE_GET_CLOSEST_STEALABLE_OBJECT = 0x8bfb4865,
        NATIVE_LOAD_PATH_NODES_IN_AREA = 0x8bff98ac,
        NATIVE_GET_NETWORK_PLAYER_VIP = 0x8c0a93e3,
        NATIVE_LOCATE_CHAR_ON_FOOT_CAR_2D = 0x8c1f0706,
        NATIVE_GET_RANDOM_CAR_NODE_INCLUDE_SWITCHED_OFF_NODES = 0x8c3c0cfb,
        NATIVE_IS_OBJECT_PLAYING_ANIM = 0x8ca17b14,
        NATIVE_DELETE_MISSION_TRAINS = 0x8ca24934,
        NATIVE_CLEAR_OBJECT_LAST_WEAPON_DAMAGE = 0x8cce814e,
        NATIVE_IS_CHAR_IN_ANGLED_AREA_3D = 0x8cdb510b,
        NATIVE_ATTACH_CAM_TO_VEHICLE = 0x8d33a0b5,
        NATIVE_GET_STRING_FROM_TEXT_FILE = 0x8d4ad2bd,
        NATIVE_SET_INTERP_FROM_GAME_TO_SCRIPT = 0x8d5ac711,
        NATIVE_FORCE_INITIAL_PLAYER_STATION = 0x8d750e5a,
        NATIVE_CLEAR_TIMECYCLE_MODIFIER = 0x8d8df8ee,
        NATIVE_CREATE_GROUP = 0x8dc0368d,
        NATIVE_CLEAR_CAR_LAST_WEAPON_DAMAGE = 0x8dc580ac,
        NATIVE_TASK_HANDS_UP = 0x8dcc19c5,
        NATIVE_WARP_CHAR_FROM_CAR_TO_CAR = 0x8de2faba,
        NATIVE_REGISTER_INT_STAT = 0x8df8fae6,
        NATIVE_SET_POLICE_RADAR_BLIPS = 0x8e114b10,
        NATIVE_IS_PLAYER_IN_REMOTE_MODE = 0x8e263263,
        NATIVE_IS_STRING_NULL = 0x8e71e00f,
        NATIVE_TASK_CHAR_SLIDE_TO_COORD = 0x8ead1dd0,
        NATIVE_SET_PLAYER_GROUP_TO_FOLLOW_NEVER = 0x8ee333a9,
        NATIVE_SET_MENU_ITEM_WITH_2_NUMBERS = 0x8ef83a4d,
        NATIVE_DISPLAY_PLAYER_NAMES = 0x8f01c7d0,
        NATIVE_ENABLE_XBOX_SCREEN_SAVER = 0x8f03d4ec,
        NATIVE_TASK_LEAVE_CAR_AND_FLEE = 0x8f50eb98,
        NATIVE_IS_PLAYER_LOGGING_IN_NP = 0x8f72fad0,
        NATIVE_SET_GROUP_CHAR_DUCKS_WHEN_AIMED_AT = 0x8fd75169,
        NATIVE_IS_THIS_HELP_MESSAGE_WITH_STRING_BEING_DISPLAYED = 0x8fdb39d4,
        NATIVE_IS_FRONTEND_FADING = 0x8ff6232c,
        NATIVE_IS_CAR_STREET_RACER = 0x8ff76282,
        NATIVE_IS_CHAR_GETTING_IN_TO_A_CAR = 0x9002c89c,
        NATIVE_TASK_PLAY_ANIM_NON_INTERRUPTABLE = 0x90091839,
        NATIVE_STOP_CAR_BREAKING = 0x901a08b7,
        NATIVE_SET_LOAD_COLLISION_FOR_CAR_FLAG = 0x90214161,
        NATIVE_IS_BIT_SET = 0x902e26ac,
        NATIVE_GET_DISTANCE_BETWEEN_COORDS_3D = 0x9032aa79,
        NATIVE_GET_MOBILE_PHONE_SCALE = 0x905e4b9c,
        NATIVE_NETWORK_HAVE_SUMMONS = 0x9060239e,
        NATIVE_TASK_CLIMB = 0x90847790,
        NATIVE_CHEAT_HAPPENED_RECENTLY = 0x908880a0,
        NATIVE_TASK_COMBAT_HATED_TARGETS_AROUND_CHAR = 0x90a16603,
        NATIVE_SET_TOTAL_NUMBER_OF_MISSIONS = 0x90b87d6c,
        NATIVE_GET_DEAD_CHAR_PICKUP_COORDS = 0x90da4404,
        NATIVE_CALCULATE_CHECKSUM = 0x90e0e14d,
        NATIVE_ADD_POINT_TO_GPS_RACE_TRACK = 0x90fba617,
        NATIVE_ADD_NETWORK_RESTART = 0x9108aaa7,
        NATIVE_NETWORK_HOST_GAME_SUCCEEDED = 0x910f6483,
        NATIVE_POINT_CAM_AT_COORD = 0x914bc21a,
        NATIVE_CLEAR_ANGLED_AREA_OF_CARS = 0x916dbc3c,
        NATIVE_REQUEST_MISSION_AUDIO_BANK = 0x916e37ca,
        NATIVE_GET_NAME_OF_SCRIPT_TO_AUTOMATICALLY_START = 0x9183c7b7,
        NATIVE_CLEAR_ROOM_FOR_CHAR = 0x91857b2b,
        NATIVE_GET_SCRIPT_DRAW_CAM = 0x918b9b12,
        NATIVE_INCREMENT_INT_STAT_NO_MESSAGE = 0x918e4333,
        NATIVE_GET_MODEL_DIMENSIONS = 0x91abb8e0,
        NATIVE_CLEAR_CHAR_TASKS = 0x91d81adb,
        NATIVE_NETWORK_IS_SESSION_INVITABLE = 0x91e81052,
        NATIVE_DRAW_CURVED_WINDOW = 0x91fec4df,
        NATIVE_SECUROM_SPOT_CHECK2 = 0x921a0ad3,
        NATIVE_IS_NETWORK_GAME_PENDING = 0x9249610b,
        NATIVE_MARK_STREAMED_TXD_AS_NO_LONGER_NEEDED = 0x92593be4,
        NATIVE_SET_GPS_VOICE_FOR_VEHICLE = 0x927cb54d,
        NATIVE_PLAYER_HAS_FLASHING_STAR_AFTER_OFFENCE = 0x9292df39,
        NATIVE_SET_PLAYER_GROUP_RECRUITMENT = 0x92a01102,
        NATIVE_DISPLAY_AMMO = 0x92a4c55c,
        NATIVE_SHUTDOWN_AND_LAUNCH_SINGLE_PLAYER_GAME = 0x92b7351c,
        NATIVE_IS_THIS_MODEL_A_VEHICLE = 0x92b9dad2,
        NATIVE_CREATE_WIDGET_GROUP = 0x92de0ecc,
        NATIVE_GET_IS_DEPOSIT_ANIM_RUNNING = 0x92e29e34,
        NATIVE_IS_CHAR_DEAD = 0x931f73a2,
        NATIVE_TASK_PLAY_ANIM_FACIAL = 0x934352ee,
        NATIVE_GET_NEXT_BLIP_INFO_ID = 0x9356e92f,
        NATIVE_DOES_GROUP_EXIST = 0x935c978d,
        NATIVE_SET_SCRIPT_LIMIT_TO_GANG_SIZE = 0x93675a29,
        NATIVE_IS_MISSION_COMPLETE_PLAYING = 0x939982a1,
        NATIVE_GET_INTERIOR_FROM_CHAR = 0x93ec6cf9,
        NATIVE_DISABLE_CAR_GENERATORS_WITH_HELI = 0x93f50422,
        NATIVE_GET_RANDOM_NETWORK_RESTART_NODE = 0x943f64ad,
        NATIVE_SET_CAR_ANIM_SPEED = 0x9440a262,
        NATIVE_IS_AUSSIE_VERSION = 0x944ba1dc,
        NATIVE_MARK_SCRIPT_AS_NO_LONGER_NEEDED = 0x944e9033,
        NATIVE_SET_CAM_SPLINE_SPEED_GRAPH = 0x945ea498,
        NATIVE_IS_GROUP_MEMBER = 0x947966a8,
        NATIVE_UNINHERIT_CAM_ROLL = 0x94825e67,
        NATIVE_REQUEST_ANIMS = 0x94b10254,
        NATIVE_GET_CAR_HEADING = 0x94b9a4ef,
        NATIVE_CLEAR_COMBAT_DECISION_MAKER_EVENT_RESPONSE = 0x94c26416,
        NATIVE_TRIGGER_PTFX = 0x94c4f762,
        NATIVE_IS_CHAR_SITTING_IN_ANY_CAR = 0x94f78256,
        NATIVE_GET_MISSION_FLAG = 0x95115f97,
        NATIVE_SET_CAR_HEADING = 0x951cb856,
        NATIVE_NETWORK_AM_I_BLOCKED_BY_PLAYER = 0x953ef45e,
        NATIVE_REMOVE_DECISION_MAKER = 0x95465154,
        NATIVE_HAND_VEHICLE_CONTROL_BACK_TO_PLAYER = 0x9550e5f2,
        NATIVE_IS_GAME_KEYBOARD_KEY_PRESSED = 0x958135c3,
        NATIVE_CHANGE_BLIP_NAME_FROM_TEXT_FILE = 0x95823232,
        NATIVE_ENABLE_FOV_LOD_MULTIPLIER = 0x95891186,
        NATIVE_NETWORK_CLEAR_SUMMONS = 0x95a210e9,
        NATIVE_ALLOCATE_SCRIPT_TO_OBJECT = 0x95a2bc99,
        NATIVE_SET_CAR_STAY_IN_FAST_LANE = 0x95b1235b,
        NATIVE_NETWORK_IS_INVITEE_ONLINE = 0x95b2c62f,
        NATIVE_CLEAR_AREA_OF_COPS = 0x95c53824,
        NATIVE_SET_TEXT_USE_UNDERSCORE = 0x95cd1881,
        NATIVE_POINT_FIXED_CAM_AT_PED = 0x95ce144c,
        NATIVE_ACTIVATE_DAMAGE_TRACKER_ON_NETWORK_ID = 0x95d07ba5,
        NATIVE_ATTACH_PED_TO_CAR = 0x95ec13eb,
        NATIVE_SHUT_CAR_DOOR = 0x961bca1b,
        NATIVE_GET_CURRENT_SCRIPTED_CONVERSATION_LINE = 0x9620e41f,
        NATIVE_UNSET_CHAR_MELEE_MOVEMENT_CONSTAINT_BOX = 0x962c6074,
        NATIVE_TASK_SHUFFLE_TO_NEXT_CAR_SEAT = 0x96335883,
        NATIVE_GET_FRAME_TIME = 0x96374262,
        NATIVE_GET_NAVMESH_ROUTE_RESULT = 0x96491602,
        NATIVE_SET_HOST_MATCH_ON = 0x9660fd45,
        NATIVE_FORCE_WEATHER_NOW = 0x96641599,
        NATIVE_HAS_GAMER_CHANGED_NETWORK_MODEL_SETTINGS = 0x96700018,
        NATIVE_GET_CHAR_HEADING = 0x96843575,
        NATIVE_GET_TXD = 0x968fb1bb,
        NATIVE_GET_RANDOM_NETWORK_RESTART_NODE_EXCLUDING_GROUP = 0x96940301,
        NATIVE_ADD_LINE_TO_CONVERSATION = 0x96cd0513,
        NATIVE_GET_PETROL_TANK_HEALTH = 0x96d3f96f,
        NATIVE_UPDATE_PTFX_OFFSETS = 0x96dd20b9,
        NATIVE_GET_SCREEN_VIEWPORT_ID = 0x97238434,
        NATIVE_IS_PED_IN_COVER = 0x972c5a8b,
        NATIVE_INCREMENT_FLOAT_STAT_NO_MESSAGE = 0x972faf69,
        NATIVE_NETWORK_GET_FRIEND_NAME = 0x97420b6d,
        NATIVE_TASK_SHIMMY = 0x974682ca,
        NATIVE_TASK_PERFORM_SEQUENCE_LOCALLY = 0x974d3d66,
        NATIVE_UNLOCK_LAZLOW_STATION = 0x9754a4da,
        NATIVE_SKIP_TIME_IN_PLAYBACK_RECORDED_CAR = 0x9786b695,
        NATIVE_IS_EPISODE_AVAILABLE = 0x97ab03ac,
        NATIVE_GET_RADIO_NAME = 0x97c074a0,
        NATIVE_COUNT_SCRIPT_CAMS_BY_TYPE_AND_OR_STATE = 0x97f869b7,
        NATIVE_SNAPSHOT_CAM = 0x98104441,
        NATIVE_DISPLAY_LOADING_THIS_FRAME_WITH_SCRIPT_SPRITES = 0x98127027,
        NATIVE_KNOCK_PED_OFF_BIKE = 0x98200d3c,
        NATIVE_START_LOAD_SCENE = 0x9843b07f,
        NATIVE_TRIGGER_PTFX_ON_PED = 0x98502552,
        NATIVE_GET_CURRENT_BASIC_POLICE_CAR_MODEL = 0x98509e88,
        NATIVE_GET_PLAYER_TEAM = 0x9873e404,
        NATIVE_GET_CAM_FAR_DOF = 0x98c5cce9,
        NATIVE_SET_OBJECT_ALPHA = 0x98e5b61d,
        NATIVE_SET_PED_MOBILE_RING_TYPE = 0x98eaca79,
        NATIVE_SET_CAR_COORDINATES = 0x98ee9042,
        NATIVE_GET_HASH_KEY = 0x98eff6f1,
        NATIVE_SET_MOBILE_RADIO_ENABLED_DURING_GAMEPLAY = 0x990085f0,
        NATIVE_DOES_VEHICLE_EXIST_WITH_NETWORK_ID = 0x99302e1e,
        NATIVE_GET_LENGTH_OF_LITERAL_STRING = 0x99379d55,
        NATIVE_START_CHAR_FIRE = 0x996d5347,
        NATIVE_TASK_TURN_CHAR_TO_FACE_CHAR = 0x998d5c90,
        NATIVE_ASIN = 0x998e5cad,
        NATIVE_TIMESTEPUNWARPED = 0x99b02b53,
        NATIVE_GET_CHAR_TEXTURE_VARIATION = 0x99d0e550,
        NATIVE_CODE_WANTS_MOBILE_PHONE_REMOVED_FOR_WEAPON_SWITCHING = 0x99dfcfb3,
        NATIVE_IS_ANY_CHAR_SHOOTING_IN_AREA = 0x99e5d601,
        NATIVE_SET_RECORDING_TO_POINT_NEAREST_TO_COORS = 0x9a004b62,
        NATIVE_FORWARD_TO_TIME_OF_DAY = 0x9a15dfa4,
        NATIVE_UPDATE_LOAD_SCENE = 0x9a31bd09,
        NATIVE_ACTIVATE_SCRIPT_POPULATION_ZONE = 0x9a339637,
        NATIVE_NETWORK_IS_LINK_CONNECTED = 0x9a402720,
        NATIVE_LOAD_TEXT_FONT = 0x9a4f5026,
        NATIVE_IS_WANTED_LEVEL_GREATER = 0x9a5e07c5,
        NATIVE_MODIFY_CHAR_MOVE_BLEND_RATIO = 0x9a7b0abe,
        NATIVE_REMOVE_TEMPORARY_RADAR_BLIPS_FOR_PICKUPS = 0x9a951332,
        NATIVE_IS_HUD_RETICULE_COMPLEX = 0x9a99c9c7,
        NATIVE_GET_STRING_FROM_HASH_KEY = 0x9aa6d1bd,
        NATIVE_TRIGGER_PTFX_ON_PED_BONE = 0x9ab3e389,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEMP2 = 0x9ae89d93,
        NATIVE_GET_FIRST_N_CHARACTERS_OF_STRING = 0x9b04ca1c,
        NATIVE_FORCE_RANDOM_CAR_MODEL = 0x9b16d31f,
        NATIVE_BLOCK_CHAR_VISEME_ANIMS = 0x9b363732,
        NATIVE_DISPLAY_TEXT_WITH_FLOAT = 0x9b4d3a1c,
        NATIVE_SET_CAM_ATTACH_OFFSET_IS_RELATIVE = 0x9b5003c4,
        NATIVE_TASK_TIRED = 0x9b64d380,
        NATIVE_DETACH_CAM_FROM_VIEWPORT = 0x9b68ef6e,
        NATIVE_GET_NETWORK_RESTART_NODE_DEBUG = 0x9b999753,
        NATIVE_MUTE_GAMEWORLD_AND_POSITIONED_RADIO_FOR_TV = 0x9ba490a1,
        NATIVE_SET_CAR_PROOFS = 0x9bd55895,
        NATIVE_IS_CAM_COLLIDING = 0x9be0eafe,
        NATIVE_RELEASE_SOUND_ID = 0x9c080899,
        NATIVE_GET_DISTANCE_BETWEEN_COORDS_2D = 0x9c0dc0c7,
        NATIVE_ATTACH_OBJECT_TO_PED_PHYSICALLY = 0x9c24e338,
        NATIVE_NETWORK_GET_HOST_LATENCY = 0x9c4308f8,
        NATIVE_IS_NEXT_STATION_ALLOWED = 0x9c481718,
        NATIVE_REQUEST_STREAMED_TXD = 0x9c4b3ae4,
        NATIVE_SET_CHAR_WILL_ONLY_FIRE_WITH_CLEAR_LOS = 0x9c4d8ef0,
        NATIVE_DOES_PICKUP_EXIST = 0x9c6da0b3,
        NATIVE_GET_HOST_MATCH_ON = 0x9c7296f4,
        NATIVE_NETWORK_DID_INVITE_FRIEND = 0x9c8802da,
        NATIVE_UPDATE_PED_PHYSICAL_ATTACHMENT_POSITION = 0x9c91b2ff,
        NATIVE_IS_SCREEN_FADED_OUT = 0x9caa05fa,
        NATIVE_IS_BIG_VEHICLE = 0x9cdba8de,
        NATIVE_TASK_COWER = 0x9cf1c19b,
        NATIVE_CREATE_RANDOM_MALE_CHAR = 0x9d0aa54a,
        NATIVE_SET_CHAR_HEADING = 0x9d0e2598,
        NATIVE_IS_LAZLOW_STATION_LOCKED = 0x9d1d72c4,
        NATIVE_SET_OBJECT_ONLY_DAMAGED_BY_PLAYER = 0x9d22cd69,
        NATIVE_SET_ROOM_FOR_VIEWPORT_BY_NAME = 0x9d4cbba5,
        NATIVE_LOCATE_CHAR_ANY_MEANS_3D = 0x9d579293,
        NATIVE_SET_CHAR_ALLOWED_TO_DUCK = 0x9d64e554,
        NATIVE_GET_TEXT_INPUT_ACTIVE = 0x9d7ef3d5,
        NATIVE_TASK_SWIM_TO_COORD = 0x9d7fb34c,
        NATIVE_NETWORK_IS_SESSION_STARTED = 0x9d854a37,
        NATIVE_GET_OFFSET_FROM_CHAR_IN_WORLD_COORDS = 0x9d90d752,
        NATIVE_GET_OBJECT_QUATERNION = 0x9dae7d3b,
        NATIVE_SET_OBJECT_VISIBLE = 0x9db02973,
        NATIVE_TASK_CHAR_ARREST_CHAR = 0x9dd10f12,
        NATIVE_GET_CONSOLE_COMMAND_TOKEN = 0x9de3de24,
        NATIVE_GET_LENGTH_OF_STRING_WITH_THIS_HASH_KEY = 0x9df4fd21,
        NATIVE_FLUSH_ALL_OUT_OF_DATE_RADAR_BLIPS_FROM_MISSION_CLEANUP_LIST = 0x9e53afd9,
        NATIVE_TASK_JETPACK = 0x9e741875,
        NATIVE_GET_TOTAL_NUMBER_OF_STATS = 0x9e9efa62,
        NATIVE_RELEASE_MOVIE = 0x9eaf5ca0,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEPARTY = 0x9edd0e5f,
        NATIVE_SET_PLAYERSETTINGS_MODEL_VARIATIONS_CHOICE = 0x9ef2997a,
        NATIVE_GET_TIME_SINCE_PLAYER_DROVE_AGAINST_TRAFFIC = 0x9f27d00e,
        NATIVE_PRINT_WITH_6_NUMBERS = 0x9f39c0d9,
        NATIVE_GET_RETURN_TO_FILTER_MENU = 0x9f44ee34,
        NATIVE_CLEAR_BRIEF = 0x9f75a929,
        NATIVE_TERMINATE_ALL_SCRIPTS_WITH_THIS_NAME = 0x9f861fd4,
        NATIVE_GET_NETWORK_ID_FROM_OBJECT = 0x9fa75090,
        NATIVE_REQUEST_ADDITIONAL_TEXT = 0x9fa9175b,
        NATIVE_IS_PLAYER_ONLINE = 0x9fab6729,
        NATIVE_PRINT_WITH_NUMBER = 0x9fbddd94,
        NATIVE_IS_PLAYER_PERFORMING_STOPPIE = 0x9ff4a9a1,
        NATIVE_GET_OBJECT_SPEED = 0xa059ff6b,
        NATIVE_SET_DEATH_WEAPONS_PERSIST = 0xa07e10c8,
        NATIVE_HAS_CAR_BEEN_DAMAGED_BY_CHAR = 0xa07e4e19,
        NATIVE_ADD_COVER_POINT = 0xa0af0b98,
        NATIVE_IS_PED_LOOKING_AT_PED = 0xa114b530,
        NATIVE_GET_CUTSCENE_PED_POSITION = 0xa12a1645,
        NATIVE_BLOCK_CHAR_GESTURE_ANIMS = 0xa14a7490,
        NATIVE_SET_CHAR_WILL_USE_CARS_IN_COMBAT = 0xa163a070,
        NATIVE_GET_INTERIOR_AT_COORDS = 0xa17fbf37,
        NATIVE_SET_MOVIE_TIME = 0xa1930880,
        NATIVE_ATTACH_ANIMS_TO_MODEL = 0xa1a55199,
        NATIVE_GET_GROUND_Z_FOR_3D_COORD = 0xa1bfd5e0,
        NATIVE_CLEAR_CAR_LAST_DAMAGE_ENTITY = 0xa1c2e905,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_TARGET_INJURED_REACTION = 0xa1c7a26c,
        NATIVE_PLAY_STREAM_FROM_PED = 0xa1d7fabe,
        NATIVE_GET_CHAR_HEALTH = 0xa1dfed67,
        NATIVE_SET_ENABLE_RC_DETONATE_ON_CONTACT = 0xa1e4ba3c,
        NATIVE_TASK_DIE = 0xa1f683a8,
        NATIVE_NETWORK_START_EXTENDED_SEARCH = 0xa23a23f7,
        NATIVE_FIND_NEAREST_COLLECTABLE_BIN_BAGS = 0xa244d735,
        NATIVE_GET_PROGRESS_PERCENTAGE = 0xa24de0dc,
        NATIVE_CLEAR_CHAR_LAST_DAMAGE_ENTITY = 0xa2544879,
        NATIVE_ATTACH_CAR_TO_CAR_PHYSICALLY = 0xa26c136a,
        NATIVE_CLOSE_GARAGE = 0xa2805438,
        NATIVE_GET_PED_CLIMB_STATE = 0xa282d424,
        NATIVE_TASK_SIT_DOWN_ON_NEAREST_OBJECT = 0xa287d0bd,
        NATIVE_SET_CAM_NAME = 0xa2934b05,
        NATIVE_GET_MENU_ITEM_SELECTED = 0xa298b991,
        NATIVE_ADD_PICKUP_TO_INTERIOR_ROOM_BY_NAME = 0xa2a73564,
        NATIVE_GET_AUDIBLE_MUSIC_TRACK_TEXT_ID = 0xa2b88ca7,
        NATIVE_IS_CAR_ATTACHED = 0xa2c118a0,
        NATIVE_FORCE_PED_TO_FLEE_WHILST_DRIVING_VEHICLE = 0xa2c145aa,
        NATIVE_GET_NUM_OF_MODELS_KILLED_BY_PLAYER = 0xa2cbaa96,
        NATIVE_START_PTFX = 0xa3126963,
        NATIVE_SET_MISSION_PASSED_CASH = 0xa3234440,
        NATIVE_GET_SEQUENCE_PROGRESS = 0xa3419909,
        NATIVE_LAUNCH_LOCAL_PLAYER_IN_NETWORK_GAME = 0xa3594132,
        NATIVE_CHANGE_BLIP_PRIORITY = 0xa37193ab,
        NATIVE_CAM_SET_INTERP_GRAPH_POS = 0xa380dd36,
        NATIVE_ADD_SCENARIO_BLOCKING_AREA = 0xa38c0234,
        NATIVE_NETWORK_GET_FRIEND_COUNT = 0xa396acde,
        NATIVE_SET_IGNORE_LOW_PRIORITY_SHOCKING_EVENTS = 0xa3d675ed,
        NATIVE_FLASH_RADAR = 0xa3f128e3,
        NATIVE_TASK_CAR_MISSION_PED_TARGET = 0xa42cbeb4,
        NATIVE_SET_CHAR_VELOCITY = 0xa43f97d0,
        NATIVE_HAS_POOL_OBJECT_COLLIDED_WITH_OBJECT = 0xa447434f,
        NATIVE_SET_PLAYER_MAY_ONLY_ENTER_THIS_VEHICLE = 0xa454dd29,
        NATIVE_DRAW_FRONTEND_HELPER_TEXT = 0xa486e58c,
        NATIVE_GET_KEY_FOR_CAR_IN_ROOM = 0xa49692cd,
        NATIVE_SET_MENU_COLUMN_WIDTH = 0xa4978e2a,
        NATIVE_IMPROVE_LOW_PERFORMANCE_MISSION_PER_FRAME_FLAG = 0xa4a53723,
        NATIVE_m = 0xa4c9c975,
        NATIVE_GET_LENGTH_OF_STRING_WITH_THIS_TEXT_LABEL = 0xa4ca7be5,
        NATIVE_GET_MOTION_CONTROL_PREFERENCE = 0xa4ca9c1c,
        NATIVE_GET_WIDTH_OF_LITERAL_STRING = 0xa4cad139,
        NATIVE_GET_GAME_TIMER = 0xa4ea0691,
        NATIVE_DOES_CAR_HAVE_HYDRAULICS = 0xa511f94d,
        NATIVE_NETWORK_STORE_SINGLE_PLAYER_GAME = 0xa52597ae,
        NATIVE_SET_AMMO_IN_CLIP = 0xa54b0b10,
        NATIVE_GET_CHAR_SPEED = 0xa570e742,
        NATIVE_NETWORK_START_SESSION_SUCCEEDED = 0xa58e8638,
        NATIVE_PRINT_STRING_WITH_TWO_LITERAL_STRINGS_NOW = 0xa5a60741,
        NATIVE_GET_TEAM_COLOUR = 0xa5b47fa7,
        NATIVE_GET_RANDOM_CAR_OF_TYPE_IN_ANGLED_AREA_NO_SAVE = 0xa5bab24b,
        NATIVE_SET_CHAR_ANGLED_DEFENSIVE_AREA = 0xa5be26b3,
        NATIVE_PROCESS_MISSION_DELETION_LIST = 0xa5cb6b1b,
        NATIVE_ALLOW_LOCKON_TO_RANDOM_PEDS = 0xa5d3bc34,
        NATIVE_GET_PLAYER_GROUP = 0xa5edcde8,
        NATIVE_REGISTER_SCRIPT_WITH_AUDIO = 0xa6203643,
        NATIVE_PICKUPS_PASS_TIME = 0xa629e201,
        NATIVE_GET_ACCEPT_BUTTON = 0xa633958e,
        NATIVE_SET_WEAPON_PICKUP_NETWORK_REGEN_TIME = 0xa64325fe,
        NATIVE_IS_KEYBOARD_KEY_PRESSED = 0xa644ed03,
        NATIVE_IS_HELP_MESSAGE_BEING_DISPLAYED = 0xa65f262a,
        NATIVE_CLEAR_TEXT_LABEL = 0xa66aae8f,
        NATIVE_SET_FLOAT_STAT = 0xa671420d,
        NATIVE_START_END_CREDITS_MUSIC = 0xa67a298a,
        NATIVE_HIDE_CHAR_WEAPON_FOR_SCRIPTED_CUTSCENE = 0xa691d377,
        NATIVE_SET_PLANE_UNDERCARRIAGE_UP = 0xa6a393f7,
        NATIVE_GET_COORDINATES_FOR_NETWORK_RESTART_NODE = 0xa6a94cf0,
        NATIVE_SET_CAMERA_AUTO_SCRIPT_ACTIVATION = 0xa6ff8911,
        NATIVE_NETWORK_GET_MET_PLAYER_NAME = 0xa70ba410,
        NATIVE_GET_POSITION_OF_CAR_RECORDING_AT_TIME = 0xa71e2f3d,
        NATIVE_GET_DRIVER_OF_CAR = 0xa73ce2da,
        NATIVE_OPEN_DEBUG_FILE = 0xa754055a,
        NATIVE_SET_HEADING_LIMIT_FOR_ATTACHED_PED = 0xa7813774,
        NATIVE_CAN_BE_DESCRIBED_AS_A_CAR = 0xa7a49dad,
        NATIVE_CHANGE_GARAGE_TYPE = 0xa7a7aa9a,
        NATIVE_NETWORK_GET_NUM_UNFILLED_RESERVATIONS = 0xa7b2e01a,
        NATIVE_SET_CHAR_KEEP_TASK = 0xa7b69843,
        NATIVE_PLAYER_IS_NEAR_FIRST_PIGEON = 0xa7cbcdf9,
        NATIVE_SET_CHAR_DUCKING = 0xa7f1cd29,
        NATIVE_SET_TIME_SCALE = 0xa7f84694,
        NATIVE_PED_QUEUE_REJECT_PEDS_WITH_FLAG_FALSE = 0xa80135ab,
        NATIVE_GET_SCRIPT_FIRE_COORDS = 0xa811013e,
        NATIVE_SET_TIMECYCLE_MODIFIER = 0xa81f3638,
        NATIVE_INCREASE_PLAYER_MAX_HEALTH = 0xa834b934,
        NATIVE_SET_FILTER_MENU_ON = 0xa836eddc,
        NATIVE_CLEAR_SMALL_PRINTS = 0xa869a238,
        NATIVE_TASK_LEAVE_CAR = 0xa87664bc,
        NATIVE_TASK_CAR_MISSION_COORS_TARGET_NOT_AGAINST_TRAFFIC = 0xa8780570,
        NATIVE_STRING_STRING = 0xa8809ae5,
        NATIVE_START_CREDITS = 0xa88fccfc,
        NATIVE_TASK_PLAY_ANIM_WITH_FLAGS = 0xa8a1570e,
        NATIVE_DEFINE_PED_GENERATION_CONSTRAINT_AREA = 0xa8c04972,
        NATIVE_DAMAGE_CHAR = 0xa8c84a28,
        NATIVE_GET_NAME_OF_INFO_ZONE = 0xa8cb8bf6,
        NATIVE_SET_MULTIPLAYER_HUD_CASH = 0xa8db435e,
        NATIVE_ASCII_INT_TO_STRING = 0xa9114148,
        NATIVE_TASK_SHIMMY_CLIMB_UP = 0xa92ab2a6,
        NATIVE_DEACTIVATE_NETWORK_SETTINGS_MENU = 0xa93f3450,
        NATIVE_LOCATE_DEAD_CAR_3D = 0xa95cbfa7,
        NATIVE_DAMAGE_PED_BODY_PART = 0xa9867e62,
        NATIVE_GET_TASK_PLACE_CAR_BOMB_UNSUCCESSFUL = 0xa99b76a1,
        NATIVE_VEHICLE_DOES_PROVIDE_COVER = 0xa9c4718b,
        NATIVE_SHAKE_PLAYERPAD_WHEN_CONTROLLER_DISABLED = 0xa9cafdd0,
        NATIVE_IS_CAR_DEAD = 0xa9d6179f,
        NATIVE_SET_OBJECT_USED_IN_POOL_GAME = 0xa9dfb38b,
        NATIVE_IS_CAR_DOOR_FULLY_OPEN = 0xaa0d97b5,
        NATIVE_WARP_CHAR_FROM_CAR_TO_COORD = 0xaa1ab0c7,
        NATIVE_IS_NETWORK_CONNECTED = 0xaa1c6d31,
        NATIVE_IS_CHAR_IN_ANY_BOAT = 0xaa21c658,
        NATIVE_TASK_START_SCENARIO_AT_POSITION = 0xaa2c4ac2,
        NATIVE_RESET_LATEST_CONSOLE_COMMAND = 0xaa3ec981,
        NATIVE_FREEZE_OBJECT_POSITION = 0xaafbdb10,
        NATIVE_REMOVE_FAKE_NETWORK_NAME_FROM_PED = 0xab07f041,
        NATIVE_NETWORK_IS_GAME_RANKED = 0xab1db6b6,
        NATIVE_IS_CHAR_MALE = 0xab2069fc,
        NATIVE_GET_MOUSE_INPUT = 0xab2843da,
        NATIVE_SET_IGNORE_SERVER_UPDATE = 0xab3d01bb,
        NATIVE_LOCATE_CHAR_ANY_MEANS_OBJECT_3D = 0xab5e74d0,
        NATIVE_IS_BULLET_IN_BOX = 0xab73ed26,
        NATIVE_OPEN_SEQUENCE_TASK = 0xaba6923e,
        NATIVE_IS_CHAR_ON_SCREEN = 0xabcf8b91,
        NATIVE_SET_CAR_STOP_CLONING = 0xabe9b815,
        NATIVE_ADD_SCORE = 0xac14689f,
        NATIVE_IS_PED_DOING_DRIVEBY = 0xac3ceb9c,
        NATIVE_IS_CHAR_RESPONDING_TO_ANY_EVENT = 0xac44baea,
        NATIVE_GET_CHAR_READY_TO_BE_EXECUTED = 0xac5a20ae,
        NATIVE_IS_OBJECT_ON_FIRE = 0xac830162,
        NATIVE_ALLOW_SCENARIO_PEDS_TO_BE_RETURNED_BY_NEXT_COMMAND = 0xacb53cee,
        NATIVE_CLEAR_ALL_CHAR_RELATIONSHIPS = 0xacf03fce,
        NATIVE_CREATE_DUMMY_CHAR = 0xacf1f758,
        NATIVE_SET_TIME_OF_DAY = 0xad03186c,
        NATIVE_IS_OBJECT_ATTACHED = 0xad08ba79,
        NATIVE_ADD_CAM_SPLINE_NODE = 0xad3c7eaa,
        NATIVE_TASK_FALL_AND_GET_UP = 0xad5826db,
        NATIVE_GET_DEAD_CAR_COORDINATES = 0xad58ab44,
        NATIVE_RELEASE_PATH_NODES = 0xad7744e9,
        NATIVE_LOCATE_CHAR_ON_FOOT_CAR_3D = 0xad774b26,
        NATIVE_GET_LOCAL_GAMERLEVEL_FROM_PROFILESETTINGS = 0xadb257c7,
        NATIVE_NETWORK_LIMIT_TO_16_PLAYERS = 0xadcd9512,
        NATIVE_TASK_FOLLOW_PATROL_ROUTE = 0xaddf1c66,
        NATIVE_CAM_SET_INTERP_STATE_SRC = 0xaddf6529,
        NATIVE_PRINT_HELP_FOREVER_WITH_NUMBER = 0xade2e873,
        NATIVE_GET_MOUSE_POSITION = 0xae097e6c,
        NATIVE_SAVE_FLOAT_TO_DEBUG_FILE = 0xae315350,
        NATIVE_SET_DONT_ACTIVATE_RAGDOLL_FROM_PLAYER_IMPACT = 0xae3f53ba,
        NATIVE_NETWORK_IS_PLAYER_BLOCKED_BY_ME = 0xae4f4560,
        NATIVE_DOES_BLIP_EXIST = 0xae92dd96,
        NATIVE_SET_CAM_BEHIND_PED = 0xaec7d2be,
        NATIVE_ATTACH_CAM_TO_VIEWPORT = 0xaee4e5e9,
        NATIVE_IS_CAR_IN_AREA_3D = 0xaee6613c,
        NATIVE_SET_NM_MESSAGE_BOOL = 0xaef25dc5,
        NATIVE_TIMERC = 0xaf1f9434,
        NATIVE_GET_GFWL_IS_RETURNING_TO_SINGLE_PLAYER = 0xaf4fae7d,
        NATIVE_TASK_WANDER_STANDARD = 0xaf59151a,
        NATIVE_SET_OBJECT_STOP_CLONING = 0xaf5955b2,
        NATIVE_HOW_LONG_HAS_NETWORK_PLAYER_BEEN_DEAD_FOR = 0xaf6a8802,
        NATIVE_ABSF = 0xaf6f6e0b,
        NATIVE_ATTACH_PED_TO_WORLD_PHYSICALLY = 0xaf7b92c2,
        NATIVE_GIVE_PLAYER_HELMET = 0xaf80474d,
        NATIVE_CAM_SET_INTERPOLATION_DETAILS = 0xaf86e42a,
        NATIVE_REMOVE_WEAPON_FROM_CHAR = 0xafa3b71d,
        NATIVE_GET_CHAR_VELOCITY = 0xafa40d33,
        NATIVE_COPY_COMBAT_DECISION_MAKER = 0xafc86821,
        NATIVE_SET_REDUCE_PED_MODEL_BUDGET = 0xafcb2b86,
        NATIVE_GET_WEB_PAGE_HEIGHT = 0xafdcc2ff,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_GROUPS = 0xafddadfc,
        NATIVE_CLOSE_DEBUG_FILE = 0xafde128d,
        NATIVE_ATTACH_CAM_TO_PED = 0xafe56af8,
        NATIVE_NETWORK_GET_NUM_PLAYERS_MET = 0xb04fc561,
        NATIVE_FIX_AMBIENCE_ORIENTATION = 0xb072727f,
        NATIVE_DISPLAY_TEXT_WITH_TWO_STRINGS = 0xb07c454c,
        NATIVE_GET_CHAR_SWIM_STATE = 0xb07d365c,
        NATIVE_CELL_CAM_SET_CENTRE_POS = 0xb0c2efe3,
        NATIVE_HAS_ADDITIONAL_TEXT_LOADED = 0xb0e56045,
        NATIVE_COPY_GROUP_CHAR_DECISION_MAKER = 0xb0eb46fe,
        NATIVE_SET_CAM_IN_FRONT_OF_PED = 0xb0fd74d2,
        NATIVE_IS_CAR_DOOR_DAMAGED = 0xb1208711,
        NATIVE_PRINT_WITH_2_NUMBERS_BIG = 0xb1249f4e,
        NATIVE_ADD_TO_PREVIOUS_BRIEF_WITH_UNDERSCORE = 0xb12b4573,
        NATIVE_IS_GAME_KEYBOARD_NAV_LEFT_PRESSED = 0xb12d8c09,
        NATIVE_REPORT_TAGGED_RADIO_TRACK = 0xb132ca2f,
        NATIVE_GET_PED_TYPE = 0xb1460d43,
        NATIVE_GET_RANDOM_NETWORK_RESTART_NODE_USING_GROUP_LIST = 0xb150397e,
        NATIVE_SET_CHAR_COLLISION = 0xb1898130,
        NATIVE_WRITE_LOBBY_PREFERENCE = 0xb1a3a04e,
        NATIVE_SET_GROUP_FORMATION_SPACING = 0xb1e086ff,
        NATIVE_IS_CHAR_IN_FLYING_VEHICLE = 0xb1e15f0a,
        NATIVE_FREEZE_CAR_POSITION = 0xb1e61d60,
        NATIVE_SET_STAT_FRONTEND_DISPLAY_TYPE = 0xb1e9098b,
        NATIVE_SET_PLAYER_MOOD_NORMAL = 0xb1ff6041,
        NATIVE_GET_CAR_MODEL_VALUE = 0xb210232b,
        NATIVE_MARK_MISSION_TRAINS_AS_NO_LONGER_NEEDED = 0xb221f23e,
        NATIVE_SET_CHAR_WILL_MOVE_WHEN_INJURED = 0xb235cff8,
        NATIVE_IS_LIVE_VERSION = 0xb23f528b,
        NATIVE_GET_SCRIPT_TASK_STATUS = 0xb2477b23,
        NATIVE_SET_CAM_POINT_OFFSET = 0xb25547c8,
        NATIVE_GET_CURRENT_COP_MODEL = 0xb26e12b4,
        NATIVE_SET_COLLECTABLE1_TOTAL = 0xb28b4f7a,
        NATIVE_DOES_OBJECT_EXIST = 0xb2a3021e,
        NATIVE_FIRE_PED_WEAPON = 0xb2b2a16e,
        NATIVE_TASK_SET_COMBAT_DECISION_MAKER = 0xb2b7bfe3,
        NATIVE_GET_MOBILE_PHONE_POSITION = 0xb2e1e1a0,
        NATIVE_FORCE_POPULATION_INIT = 0xb2f722e1,
        NATIVE_REQUEST_CAR_RECORDING = 0xb310b81e,
        NATIVE_GET_GROUP_FORMATION_SPACING = 0xb312e0fc,
        NATIVE_SET_CAM_MOTION_BLUR = 0xb31d5b98,
        NATIVE_NETWORK_IS_RENDEZVOUS = 0xb375073a,
        NATIVE_START_PROFILE_TIMER = 0xb378cf91,
        NATIVE_SET_SYNC_WEATHER_AND_GAME_TIME = 0xb3a07403,
        NATIVE_TURN_OFF_VEHICLE_EXTRA = 0xb3a0f890,
        NATIVE_SET_CAR_HEALTH = 0xb3b086a2,
        NATIVE_DELETE_WIDGET = 0xb3cab5fb,
        NATIVE_CAM_SEQUENCE_CLOSE = 0xb3d11b70,
        NATIVE_HAS_OBJECT_BEEN_DAMAGED_BY_CAR = 0xb3ef3f52,
        NATIVE_CAM_SET_INTERP_GRAPH_ROT = 0xb3fda6fe,
        NATIVE_CLEAR_GROUP_DECISION_MAKER_EVENT_RESPONSE = 0xb405f8d1,
        NATIVE_TASK_SIT_DOWN = 0xb40fc847,
        NATIVE_GIVE_PED_AMBIENT_OBJECT = 0xb4140a3c,
        NATIVE_GET_FOLLOW_VEHICLE_CAM_SUBMODE = 0xb41fb311,
        NATIVE_IS_CHAR_HEALTH_GREATER = 0xb443f023,
        NATIVE_ABSI = 0xb44677c5,
        NATIVE_TASK_SIT_DOWN_ON_SEAT = 0xb457570a,
        NATIVE_GET_FRAME_COUNT = 0xb477a015,
        NATIVE_GET_MOBILE_PHONE_TASK_SUB_TASK = 0xb47c4cf0,
        NATIVE_CLEAR_CHAR_RELATIONSHIP = 0xb4a1647b,
        NATIVE_APPLY_FORCE_TO_OBJECT = 0xb4fca1f9,
        NATIVE_SET_TRAIN_CRUISE_SPEED = 0xb507f51d,
        NATIVE_CLEAR_CHAR_TASKS_IMMEDIATELY = 0xb5087d44,
        NATIVE_IS_VEHICLE_TOUCHING_OBJECT = 0xb50ab968,
        NATIVE_IS_CHAR_TOUCHING_CHAR = 0xb54e000c,
        NATIVE_IS_BULLET_IN_AREA = 0xb54f46ca,
        NATIVE_ACTIVATE_SCRIPTED_CAMS = 0xb5539ce8,
        NATIVE_CHANGE_BLIP_DISPLAY = 0xb555ea97,
        NATIVE_TRIGGER_POLICE_REPORT = 0xb56e38a5,
        NATIVE_LOCATE_CHAR_ANY_MEANS_CHAR_3D = 0xb58912ff,
        NATIVE_ADD_NEXT_MESSAGE_TO_PREVIOUS_BRIEFS = 0xb58b25bd,
        NATIVE_GET_NUMBER_OF_INSTANCES_OF_STREAMED_SCRIPT = 0xb5a5f10c,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_AREA = 0xb5b76a3c,
        NATIVE_CLEAR_PED_NON_REMOVAL_AREA = 0xb5ba896b,
        NATIVE_IS_CHAR_STUCK_UNDER_CAR = 0xb5c5016b,
        NATIVE_GET_TIME_SINCE_PLAYER_HIT_PED = 0xb6209195,
        NATIVE_ADD_STUNT_JUMP = 0xb630e5ff,
        NATIVE_IS_CHAR_VISIBLE = 0xb632f152,
        NATIVE_SWITCH_CAR_GENERATOR = 0xb6380612,
        NATIVE_IS_PED_A_MISSION_PED = 0xb653748d,
        NATIVE_DETACH_PED = 0xb65bd564,
        NATIVE_DELETE_CHECKPOINT = 0xb66cf3ca,
        NATIVE_PLAYSTATS_MISSION_FAILED = 0xb6777a27,
        NATIVE_RETUNE_RADIO_UP = 0xb68cab02,
        NATIVE_DISPLAY_TEXT_WITH_STRING = 0xb6ba7a8a,
        NATIVE_TASK_SAY = 0xb6c5340e,
        NATIVE_SET_TEXT_SCALE = 0xb6e15b23,
        NATIVE_PLAY_SOUND = 0xb6e1917f,
        NATIVE_SET_CHAR_PROP_INDEX = 0xb710a863,
        NATIVE_LOAD_SCENE = 0xb72403f5,
        NATIVE_CONTROL_CAR_DOOR = 0xb727e6cf,
        NATIVE_SET_IGNORE_NO_GPS_FLAG = 0xb72cf194,
        NATIVE_IS_CHAR_USING_SCENARIO = 0xb74c04f3,
        NATIVE_SET_HEADING_OF_CLOSEST_OBJECT_OF_TYPE = 0xb74d0e1b,
        NATIVE_CHANGE_PICKUP_BLIP_PRIORITY = 0xb756912a,
        NATIVE_ENABLE_CAM_COLLISION = 0xb75cd096,
        NATIVE_HIDE_HUD_AND_RADAR_THIS_FRAME = 0xb75d4ad2,
        NATIVE_LOCATE_CHAR_ON_FOOT_OBJECT_3D = 0xb75df3ea,
        NATIVE_DISABLE_PAUSE_MENU = 0xb76103dd,
        NATIVE_WANTED_STARS_ARE_FLASHING = 0xb7893903,
        NATIVE_PRINT_HELP_FOREVER = 0xb7ac63c3,
        NATIVE_TASK_PLAY_ANIM_UPPER_BODY = 0xb7addd40,
        NATIVE_TASK_LEAVE_ANY_CAR = 0xb7b097c4,
        NATIVE_DELETE_PLAYER = 0xb7d1d73b,
        NATIVE_SECUROM_SPOT_CHECK3 = 0xb7da5653,
        NATIVE_CAM_SEQUENCE_REMOVE = 0xb7fa8000,
        NATIVE_TASK_FOLLOW_POINT_ROUTE = 0xb837c816,
        NATIVE_SET_CHAR_CAN_BE_KNOCKED_OFF_BIKE = 0xb856ef1c,
        NATIVE_SUPPRESS_CAR_MODEL = 0xb8761517,
        NATIVE_SET_COMBAT_DECISION_MAKER = 0xb8c09f82,
        NATIVE_GET_PED_PATH_WILL_AVOID_DYNAMIC_OBJECTS = 0xb8e7670c,
        NATIVE_GET_PLAYERS_LAST_CAR_NO_SAVE = 0xb942887b,
        NATIVE_SET_PED_ALPHA = 0xb94da9b3,
        NATIVE_SYNCH_AMBIENT_PLANES = 0xb955b773,
        NATIVE_SET_TEXT_TO_USE_TEXT_FILE_COLOURS = 0xb95e39de,
        NATIVE_STOP_PREVIEW_RINGTONE = 0xb9659902,
        NATIVE_DELETE_CHAR = 0xb99b8a04,
        NATIVE_SET_USE_POOL_GAME_PHYSICS_SETTINGS = 0xb9b5609f,
        NATIVE_SET_OBJECT_ROTATION = 0xb9bf4ea7,
        NATIVE_CLEAR_CHAR_LAST_DAMAGE_BONE = 0xb9c43e78,
        NATIVE_PED_QUEUE_REJECT_PEDS_WITH_FLAG_TRUE = 0xba0856c7,
        NATIVE_GIVE_PED_FAKE_NETWORK_NAME = 0xba223e7b,
        NATIVE_IS_CHAR_IN_ANY_TRAIN = 0xba300a2c,
        NATIVE_SET_CHAR_MAX_TIME_UNDERWATER = 0xba35fe09,
        NATIVE_SET_CAR_EXISTS_ON_ALL_MACHINES = 0xba4c8feb,
        NATIVE_IS_OBJECT_WITHIN_BRAIN_ACTIVATION_RANGE = 0xba4caa56,
        NATIVE_GET_CAR_OBJECT_IS_ATTACHED_TO = 0xba5b5428,
        NATIVE_RESET_MONEY_PICKUP_NETWORK_REGEN_TIME = 0xba77274e,
        NATIVE_BURST_CAR_TYRE = 0xba77aec8,
        NATIVE_ENABLE_MAX_AMMO_CAP = 0xba9cc5c1,
        NATIVE_GET_STRING_WIDTH = 0xbabdf3d6,
        NATIVE_GET_CHAR_READY_TO_BE_STUNNED = 0xbaed4873,
        NATIVE_SET_RICH_PRESENCE_TEMPLATELOBBY = 0xbafa4f82,
        NATIVE_GET_ROPE_HEIGHT_FOR_OBJECT = 0xbb021feb,
        NATIVE_LOCK_CAR_DOORS = 0xbb0c9b53,
        NATIVE_SET_CURRENT_CHAR_WEAPON = 0xbb1a1c18,
        NATIVE_SET_TIME_ONE_DAY_FORWARD = 0xbb56c2e5,
        NATIVE_CLEAR_AREA_OF_OBJECTS = 0xbb720fe7,
        NATIVE_IS_PLAYER_READY_FOR_CUTSCENE = 0xbb77e9cd,
        NATIVE_CREATE_HTML_SCRIPT_OBJECT = 0xbb9dd763,
        NATIVE_SET_CAN_TARGET_CHAR_WITHOUT_LOS = 0xbbaa3dae,
        NATIVE_DOES_CHAR_EXIST = 0xbbd7272c,
        NATIVE_SET_USE_HIGHDOF = 0xbc0a5172,
        NATIVE_SET_PLAYER_GROUP_TO_FOLLOW_ALWAYS = 0xbc31136a,
        NATIVE_SET_VEH_INTERIORLIGHT = 0xbc45de3e,
        NATIVE_NETWORK_RETURN_TO_RENDEZVOUS = 0xbc50dadf,
        NATIVE_GET_VIEWPORT_POS_AND_SIZE = 0xbc6331cf,
        NATIVE_DISPLAY_SNIPER_SCOPE_THIS_FRAME = 0xbc6c73cb,
        NATIVE_CAM_RESTORE = 0xbc70553c,
        NATIVE_SET_TEXT_JUSTIFY = 0xbc971139,
        NATIVE_SET_GAME_CAM_HEADING = 0xbcaae01b,
        NATIVE_CHANGE_PICKUP_BLIP_DISPLAY = 0xbcc2d90f,
        NATIVE_HAS_NET_ID_BEEN_CLONED = 0xbcde0a76,
        NATIVE_IS_PED_CLIMBING = 0xbce03d35,
        NATIVE_GET_CAR_HEALTH = 0xbcf5c60b,
        NATIVE_SET_AMBIENT_VOICE_NAME = 0xbd2ea1a1,
        NATIVE_NETWORK_RETURN_TO_RENDEZVOUS_PENDING = 0xbd4a55b9,
        NATIVE_END_WIDGET_GROUP = 0xbd5d7f9c,
        NATIVE_SHOW_SIGNIN_UI = 0xbd7c5ee4,
        NATIVE_STOP_CREDITS = 0xbda19b03,
        NATIVE_IS_CAR_ON_SCREEN = 0xbda8e007,
        NATIVE_CREATE_CARS_ON_GENERATORS_IN_AREA = 0xbe065299,
        NATIVE_NETWORK_RETURN_TO_RENDEZVOUS_SUCCEEDED = 0xbe1fee66,
        NATIVE_CLOSE_ALL_CAR_DOORS = 0xbe30bed0,
        NATIVE_FIX_SCRIPT_MIC_TO_CURRENT_POSISITION = 0xbe50c2f0,
        NATIVE_SET_WEB_PAGE_LINK_ACTIVE = 0xbe670dc0,
        NATIVE_SET_VEH_ALARM = 0xbe730f29,
        NATIVE_SET_TEXT_VIEWPORT_ID = 0xbe9e0a9b,
        NATIVE_CELL_CAM_IS_CHAR_VISIBLE_NO_FACE_CHECK = 0xbea88097,
        NATIVE_IS_CAR_ON_FIRE = 0xbed4ec63,
        NATIVE_REGISTER_HOST_BROADCAST_VARIABLES = 0xbedd194d,
        NATIVE_HAS_CAR_STOPPED_BECAUSE_OF_LIGHT = 0xbf167f23,
        NATIVE_SET_CHAR_PROOFS = 0xbf7c253d,
        NATIVE_SIN = 0xbf987f58,
        NATIVE_GET_CAR_MODEL = 0xbfd2172a,
        NATIVE_SET_PED_ENABLE_LEG_IK = 0xbffb6621,
        NATIVE_IS_AREA_OCCUPIED = 0xc013972f,
        NATIVE_TASK_WARP_CHAR_INTO_CAR_AS_DRIVER = 0xc0249be5,
        NATIVE_GET_VEHICLE_CLASS = 0xc025338e,
        NATIVE_NETWORK_GET_FIND_RESULT = 0xc03fbd9c,
        NATIVE_SET_INT_STAT = 0xc05febe2,
        NATIVE_GET_CAR_DOOR_LOCK_STATUS = 0xc0708cdc,
        NATIVE_SET_CAR_VISIBLE = 0xc0807340,
        NATIVE_NETWORK_IS_ROCKSTART_SESSION_ID_VALID = 0xc09df659,
        NATIVE_SET_PARKED_CAR_DENSITY_MULTIPLIER = 0xc0b4a880,
        NATIVE_FIRE_SINGLE_BULLET = 0xc0bd06e2,
        NATIVE_SET_ROOM_FOR_DUMMY_CHAR_BY_NAME = 0xc0d111e1,
        NATIVE_CHANGE_PLAYER_PHONE_MODEL_OFFSETS = 0xc102c33a,
        NATIVE_ACTIVATE_MENU_ITEM = 0xc11470e1,
        NATIVE_TASK_PLAY_ANIM_SECONDARY = 0xc117897a,
        NATIVE_SET_VIEWPORT_DESTINATION = 0xc12f47c2,
        NATIVE_TASK_CHAT_WITH_CHAR = 0xc1369d7d,
        NATIVE_FREEZE_CAR_POSITION_AND_DONT_LOAD_COLLISION = 0xc136bca3,
        NATIVE_HAS_CAR_RECORDING_BEEN_LOADED = 0xc147dd7e,
        NATIVE_GRAB_NEARBY_OBJECT_WITH_SPECIAL_ATTRIBUTE = 0xc159ecdb,
        NATIVE_IS_POINT_OBSCURED_BY_A_MISSION_ENTITY = 0xc161558d,
        NATIVE_TASK_GOTO_CAR = 0xc16410fb,
        NATIVE_IS_OBJECT_IN_ANGLED_AREA_3D = 0xc19a7d73,
        NATIVE_SET_SERVER_ID = 0xc1bef9d0,
        NATIVE_TASK_SEEK_COVER_FROM_PED = 0xc1ec907e,
        NATIVE_HAS_OBJECT_BEEN_UPROOTED = 0xc220db67,
        NATIVE_DETACH_PED_FROM_WITHIN_CAR = 0xc22245a4,
        NATIVE_POINT_CAM_AT_OBJECT = 0xc2b50105,
        NATIVE_DETACH_CAR = 0xc2bd8cd2,
        NATIVE_SWITCH_ROADS_BACK_TO_ORIGINAL = 0xc2cc4455,
        NATIVE_LOCATE_CHAR_ON_FOOT_OBJECT_2D = 0xc3048ea7,
        NATIVE_GET_DOOR_ANGLE_RATIO = 0xc30fb7fd,
        NATIVE_SET_SCREEN_FADE = 0xc33f5593,
        NATIVE_GENERATE_RANDOM_INT_IN_RANGE = 0xc37df274,
        NATIVE_DESTROY_CAM = 0xc39302bd,
        NATIVE_IS_HUD_PREFERENCE_SWITCHED_ON = 0xc3bc1b4f,
        NATIVE_TASK_COMBAT = 0xc3e34f36,
        NATIVE_GET_PED_FROM_NETWORK_ID = 0xc43d0abb,
        NATIVE_CAM_PROCESS = 0xc455a8ca,
        NATIVE_START_PLAYBACK_RECORDED_CAR_LOOPED = 0xc45e5605,
        NATIVE_CREATE_VIEWPORT = 0xc46af947,
        NATIVE_GET_PED_MODEL_FROM_INDEX = 0xc4765bee,
        NATIVE_FIND_NETWORK_KILLER_OF_PLAYER = 0xc48c3103,
        NATIVE_GENERATE_DIRECTIONS = 0xc49b9aa6,
        NATIVE_SET_CLEAR_HELP_IN_MISSION_CLEANUP = 0xc4b9622d,
        NATIVE_SET_CHAR_CAN_BE_SHOT_IN_VEHICLE = 0xc500437a,
        NATIVE_GET_NUMBER_OF_CHAR_TEXTURE_VARIATIONS = 0xc50f3611,
        NATIVE_GET_PLANE_UNDERCARRIAGE_POSITION = 0xc513a653,
        NATIVE_PLAY_STREAM_FROM_OBJECT = 0xc5266bf7,
        NATIVE_GET_CONTROL_VALUE = 0xc526f3c6,
        NATIVE_ADD_WIDGET_STRING = 0xc541594c,
        NATIVE_NETWORK_IS_FRIEND_IN_SAME_TITLE = 0xc54365c2,
        NATIVE_WARP_CHAR_INTO_CAR_AS_PASSENGER = 0xc5506262,
        NATIVE_NETWORK_END_SESSION = 0xc561ddba,
        NATIVE_CONVERT_METRES_TO_FEET_INT = 0xc564cfeb,
        NATIVE_ADD_BLIP_FOR_WEAPON = 0xc5803316,
        NATIVE_GET_SAFE_LOCAL_RESTART_COORDS = 0xc581ff46,
        NATIVE_GET_CHAR_COORDINATES = 0xc5892f5f,
        NATIVE_GET_TIME_SINCE_PLAYER_HIT_CAR = 0xc5a5c559,
        NATIVE_NETWORK_STRING_VERIFY_SUCCEEDED = 0xc5bcd493,
        NATIVE_SET_CAN_BURST_CAR_TYRES = 0xc5beaa57,
        NATIVE_SET_TEXT_RENDER_ID = 0xc5c3b7f3,
        NATIVE_SET_CAM_DOF_FOCUSPOINT = 0xc5d8b1e3,
        NATIVE_SWITCH_PED_TO_RAGDOLL = 0xc5dcc21b,
        NATIVE_ENABLE_PED_HELMET = 0xc5f7bad0,
        NATIVE_ON_FIRE_SCREAM = 0xc60d6b5f,
        NATIVE_SET_CHAR_NEVER_LEAVES_GROUP = 0xc62ab646,
        NATIVE_GET_PLAYER_HAS_TRACKS = 0xc6621b28,
        NATIVE_IS_CHAR_IN_AREA_ON_FOOT_2D = 0xc6655ff6,
        NATIVE_LOAD_ALL_PATH_NODES = 0xc66e28c3,
        NATIVE_ADD_BLIP_FOR_COORD = 0xc6f43d0e,
        NATIVE_GET_MAP_AREA_FROM_COORDS = 0xc7191b29,
        NATIVE_SECUROM_SPOT_CHECK4 = 0xc777f58e,
        NATIVE_SET_LOUD_VEHICLE_RADIO = 0xc79b51c3,
        NATIVE_LOCATE_CHAR_ON_FOOT_2D = 0xc7a21f12,
        NATIVE_CAM_SEQUENCE_STOP = 0xc7b2b55e,
        NATIVE_GIVE_PLAYER_RAGDOLL_CONTROL = 0xc7b4d7ac,
        NATIVE_ENABLE_POLICE_SCANNER = 0xc7bb5fc6,
        NATIVE_IS_SCREEN_FADING_IN = 0xc7c82800,
        NATIVE_SET_CAM_COMPONENT_SHAKE = 0xc7cec33f,
        NATIVE_GET_CHAR_HIGHEST_PRIORITY_EVENT = 0xc7facf9e,
        NATIVE_MARK_CHAR_AS_NO_LONGER_NEEDED = 0xc808f143,
        NATIVE_GET_PICKUP_COORDINATES = 0xc80e9e6b,
        NATIVE_IS_PED_RAGDOLL = 0xc833bbe1,
        NATIVE_GET_PED_BONE_POSITION = 0xc8395a2c,
        NATIVE_FORCE_NET_PLAYER_INVISIBLE = 0xc83cd69a,
        NATIVE_ABORT_SCRIPTED_CONVERSATION = 0xc842f0c9,
        NATIVE_SAY_AMBIENT_SPEECH_WITH_VOICE = 0xc845ad08,
        NATIVE_RELEASE_TIME_OF_DAY = 0xc84e8398,
        NATIVE_VDIST2 = 0xc85def1f,
        NATIVE_RETUNE_RADIO_TO_STATION_INDEX = 0xc86b64d3,
        NATIVE_SET_CONVERTIBLE_ROOF = 0xc87b6a51,
        NATIVE_SCRIPT_IS_USING_MOBILE_PHONE = 0xc87fb3bc,
        NATIVE_SET_NM_MESSAGE_INSTANCE_INDEX = 0xc8b5dfe3,
        NATIVE_NETWORK_RESULT_MATCHES_SEARCH_CRITERIA = 0xc8baab49,
        NATIVE_POINT_FIXED_CAM_AT_POS = 0xc8dba54a,
        NATIVE_SET_UPSIDEDOWN_CAR_NOT_DAMAGED = 0xc9023fdb,
        NATIVE_IS_PLAYER_FREE_AIMING_AT_CHAR = 0xc9147ba8,
        NATIVE_SET_EVERYONE_IGNORE_PLAYER = 0xc915285e,
        NATIVE_SET_PED_FALL_OFF_BIKES_WHEN_SHOT = 0xc92c80c5,
        NATIVE_SET_RELATIONSHIP = 0xc94b8622,
        NATIVE_TASK_USE_MOBILE_PHONE_TIMED = 0xc99c19f5,
        NATIVE_SET_OBJECT_ANIM_PLAYING_FLAG = 0xc9a20688,
        NATIVE_BEGIN_CHAR_SEARCH_CRITERIA = 0xc9abf675,
        NATIVE_WAS_CUTSCENE_SKIPPED = 0xc9b6949d,
        NATIVE_LOAD_ALL_OBJECTS_NOW = 0xc9dbda90,
        NATIVE_GET_ROOM_KEY_FROM_PICKUP = 0xc9ea67b1,
        NATIVE_GET_BITS_IN_RANGE = 0xca03a1e5,
        NATIVE_SET_ALL_PEDS_SPAWNED_ARE_COPS = 0xca5237e4,
        NATIVE_GET_CUTSCENE_AUDIO_TIME_MS = 0xca56c61d,
        NATIVE_LOCATE_OBJECT_2D = 0xca752c3a,
        NATIVE_NETWORK_VERIFY_USER_STRING = 0xca82a790,
        NATIVE_DOES_VIEWPORT_EXIST = 0xca9dd46f,
        NATIVE_AWARD_ACHIEVEMENT = 0xcaa24b1a,
        NATIVE_TASK_SIT_DOWN_INSTANTLY = 0xcac2792f,
        NATIVE_IS_CAR_SIREN_ON = 0xcac9cf68,
        NATIVE_HAS_CLOSEST_OBJECT_OF_TYPE_BEEN_DAMAGED_BY_CAR = 0xcad55878,
        NATIVE_LOCATE_CHAR_ANY_MEANS_OBJECT_2D = 0xcade3513,
        NATIVE_SET_MENU_COLUMN = 0xcae90ec1,
        NATIVE_DONT_SUPPRESS_CAR_MODEL = 0xcb1d5557,
        NATIVE_SET_CAM_TARGET_PED = 0xcb4a937c,
        NATIVE_CAN_CREATE_RANDOM_CHAR = 0xcb78c625,
        NATIVE_NETWORK_CHANGE_GAME_MODE = 0xcb8178a3,
        NATIVE_IS_SCRIPTED_CONVERSATION_ONGOING = 0xcb8fd96f,
        NATIVE_GET_TRAIN_PLAYER_WOULD_ENTER = 0xcb979ee4,
        NATIVE_NETWORK_STRING_VERIFY_PENDING = 0xcb9e9a8d,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_STANDING_STYLE = 0xcbb4efc0,
        NATIVE_GET_NUMBER_OF_CHAR_DRAWABLE_VARIATIONS = 0xcbbb053e,
        NATIVE_GET_CLOSEST_CAR = 0xcbcec322,
        NATIVE_SET_CHAR_MELEE_MOVEMENT_CONSTAINT_BOX = 0xcbef0b60,
        NATIVE_SET_CAR_DISTANCE_AHEAD_MULTIPLIER = 0xcc2ce574,
        NATIVE_SET_GAME_CAM_PITCH = 0xcc3adfe1,
        NATIVE_IS_CHAR_ON_ANY_BIKE = 0xcc7cea5f,
        NATIVE_POINT_FIXED_CAM = 0xccb3ea46,
        NATIVE_GET_NUMBER_OF_FOLLOWERS = 0xccd6e5b7,
        NATIVE_UNLOCK_MISSION_NEWS_STORY = 0xccd9abe4,
        NATIVE_FLASH_ROUTE = 0xccdf3072,
        NATIVE_ADD_SPHERE = 0xcd32edf2,
        NATIVE_LOCATE_CHAR_IN_CAR_OBJECT_3D = 0xcd395628,
        NATIVE_DESTROY_PED_GENERATION_CONSTRAINT_AREA = 0xcd5687a7,
        NATIVE_STOP_SOUND = 0xcd7f4030,
        NATIVE_GET_CURRENT_BASIC_COP_MODEL = 0xcda04e40,
        NATIVE_SET_REDUCE_VEHICLE_MODEL_BUDGET = 0xcdb4fb7e,
        NATIVE_DRAW_CHECKPOINT_WITH_ALPHA = 0xcdc4b816,
        NATIVE_START_CUTSCENE_NOW = 0xcdc89731,
        NATIVE_SET_SEQUENCE_TO_REPEAT = 0xcddf1508,
        NATIVE_ALWAYS_USE_HEAD_ON_HORN_ANIM_WHEN_DEAD_IN_CAR = 0xcde92d9f,
        NATIVE_SET_POLICE_FOCUS_WILL_TRACK_CAR = 0xcdfced3c,
        NATIVE_SWITCH_ROADS_OFF = 0xce1459eb,
        NATIVE_GET_CHAR_PROP_INDEX = 0xce1f5012,
        NATIVE_NETWORK_SET_PLAYER_MUTED = 0xce451908,
        NATIVE_IS_CAR_TYRE_BURST = 0xce670ff4,
        NATIVE_TASK_SIT_DOWN_PLAY_ANIM = 0xce6cd835,
        NATIVE_UNMARK_ALL_ROAD_NODES_AS_DONT_WANDER = 0xce9c03ec,
        NATIVE_IS_GAME_KEYBOARD_NAV_UP_PRESSED = 0xcea368d6,
        NATIVE_NETWORK_IS_TVT = 0xceb6f262,
        NATIVE_SET_CAR_COLLISION = 0xcebb07fa,
        NATIVE_GET_PARKING_NODE_IN_AREA = 0xcebfbe8e,
        NATIVE_PAUSE_PLAYBACK_RECORDED_CAR = 0xcec801b1,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_TARGET_LOSS_RESPONSE = 0xcece27ea,
        NATIVE_LOCATE_CHAR_ANY_MEANS_2D = 0xcece7668,
        NATIVE_ADD_STRING_WITH_THIS_TEXT_LABEL_TO_PREVIOUS_BRIEF = 0xcee52ca5,
        NATIVE_GET_RANDOM_NETWORK_RESTART_NODE_OF_GROUP = 0xcf237a8b,
        NATIVE_IS_RADIO_RETUNING = 0xcf29097b,
        NATIVE_REMOVE_PED_QUEUE = 0xcf2df984,
        NATIVE_CREATE_CHAR_INSIDE_CAR = 0xcf2e377d,
        NATIVE_SET_CAR_ENGINE_ON = 0xcf45887f,
        NATIVE_SKIP_TO_NEXT_ALLOWED_STATION = 0xcf682ec7,
        NATIVE_TASK_SET_IGNORE_WEAPON_RANGE_FLAG = 0xcf76bc48,
        NATIVE_SEND_HOST_BROADCAST_VARIABLES_NOW = 0xcf78ba61,
        NATIVE_HAS_CAR_BEEN_RESPRAYED = 0xcf8019c1,
        NATIVE_REGISTER_STRING_FOR_FRONTEND_STAT = 0xcf8d582c,
        NATIVE_SET_CAR_DENSITY_MULTIPLIER = 0xcfbdc084,
        NATIVE_GET_CAM_NEAR_CLIP = 0xcfcd35ee,
        NATIVE_GET_FRONTEND_DESIGN_VALUE = 0xd00d09b3,
        NATIVE_SET_PLAYER_INVISIBLE_TO_AI = 0xd022f783,
        NATIVE_TASK_FOLLOW_FOOTSTEPS = 0xd0306dc4,
        NATIVE_RELEASE_WEATHER = 0xd03ac6a6,
        NATIVE_CAM_IS_SPHERE_VISIBLE = 0xd047dd84,
        NATIVE_SET_THIS_SCRIPT_CAN_REMOVE_BLIPS_CREATED_BY_ANY_SCRIPT = 0xd06f1720,
        NATIVE_SET_FIXED_CAM_POS = 0xd07755b2,
        NATIVE_SET_CHAR_WILL_DO_DRIVEBYS = 0xd0837ecb,
        NATIVE_SET_CAR_DOOR_LATCHED = 0xd0a33911,
        NATIVE_SWITCH_RANDOM_BOATS = 0xd0c08fce,
        NATIVE_HAS_PLAYER_RANK_BEEN_UPGRADED = 0xd0ccfb82,
        NATIVE_TASK_USE_NEAREST_SCENARIO_TO_POS = 0xd0ce5d22,
        NATIVE_GET_BLIP_INFO_ID_DISPLAY = 0xd0fc19f4,
        NATIVE_DISPLAY_HUD = 0xd10e4e31,
        NATIVE_SET_PLAYER_KEEPS_WEAPONS_WHEN_RESPAWNED = 0xd10fc340,
        NATIVE_TASK_STAND_GUARD = 0xd130f636,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_NUM_CARS = 0xd1352113,
        NATIVE_RESET_CAM_SPLINE_CUSTOM_SPEED_GRAPH = 0xd148477d,
        NATIVE_GET_NUMBER_LINES_WITH_SUBSTRINGS = 0xd172184d,
        NATIVE_SET_PLAYER_CONTROL = 0xd17afcd8,
        NATIVE_FREEZE_CHAR_POSITION_AND_DONT_LOAD_COLLISION = 0xd17d4854,
        NATIVE_SET_SCRIPTED_CONVERSION_CENTRE = 0xd1c73422,
        NATIVE_STOP_STREAM = 0xd1e364de,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEFILTER = 0xd1fe2cc0,
        NATIVE_TASK_GUARD_ANGLED_DEFENSIVE_AREA = 0xd2062ca9,
        NATIVE_GET_HEADING_FROM_VECTOR_2D = 0xd209d52b,
        NATIVE_DELETE_WIDGET_GROUP = 0xd215bace,
        NATIVE_TASK_CAR_MISSION_COORS_TARGET = 0xd2172ad9,
        NATIVE_REMOVE_CHAR_FROM_CAR_MAINTAIN_POSITION = 0xd21fa802,
        NATIVE_GET_CHAR_AREA_VISIBLE = 0xd2353856,
        NATIVE_DISABLE_END_CREDITS_FADE = 0xd272a818,
        NATIVE_IS_STREAMING_PRIORITY_REQUESTS = 0xd2e1e5dc,
        NATIVE_SET_PED_IS_DRUNK = 0xd2ea77a3,
        NATIVE_SET_CHAR_WILL_FLY_THROUGH_WINDSCREEN = 0xd2f6651d,
        NATIVE_SET_BIKE_RIDER_WILL_PUT_FOOT_DOWN_WHEN_STOPPED = 0xd2fa9a0b,
        NATIVE_GET_KEYBOARD_MOVE_INPUT = 0xd301cda2,
        NATIVE_GET_VEHICLE_QUATERNION = 0xd30891fa,
        NATIVE_CHANGE_BLIP_NAME_FROM_ASCII = 0xd30ebd66,
        NATIVE_TAN = 0xd320ce5e,
        NATIVE_GET_GAMER_NETWORK_SCORE = 0xd35be0fa,
        NATIVE_SET_DRUNK_CAM = 0xd35d7808,
        NATIVE_IS_PAUSE_MENU_ACTIVE = 0xd3600591,
        NATIVE_GET_PROFILE_SETTING = 0xd374bebc,
        NATIVE_AWARD_PLAYER_MISSION_RESPECT = 0xd381ce87,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEMP6 = 0xd3be0f3d,
        NATIVE_SET_CAM_FOV = 0xd3d5d74f,
        NATIVE_SET_ROUTE = 0xd3d8c987,
        NATIVE_IS_SCREEN_FADING = 0xd4216cc0,
        NATIVE_IS_EXPLOSION_IN_SPHERE = 0xd455a7f3,
        NATIVE_GET_HOURS_OF_DAY = 0xd455af99,
        NATIVE_IS_PED_BEING_JACKED = 0xd45d605c,
        NATIVE_PRINTFLOAT = 0xd48b90b6,
        NATIVE_NETWORK_IS_FIND_RESULT_VALID = 0xd4920850,
        NATIVE_IS_OBJECT_ON_PLAYER_MACHINE = 0xd4a13bda,
        NATIVE_GET_GROUP_LEADER = 0xd4addb85,
        NATIVE_SET_CHAR_NAME_DEBUG = 0xd4bcca69,
        NATIVE_CREATE_MISSION_TRAIN = 0xd4c2eafd,
        NATIVE_GET_CURRENT_DAY_OF_WEEK = 0xd4c86dc4,
        NATIVE_IS_PED_HOLDING_AN_OBJECT = 0xd502986d,
        NATIVE_IS_FONT_LOADED = 0xd50b4c8d,
        NATIVE_SET_TIMER_BEEP_COUNTDOWN_TIME = 0xd51e2a5f,
        NATIVE_IS_CHAR_IN_AREA_2D = 0xd52bf398,
        NATIVE_SET_INTERP_IN_OUT_VEHICLE_ENABLED_THIS_FRAME = 0xd533b18c,
        NATIVE_CEIL = 0xd536a1df,
        NATIVE_GET_SIMPLE_BLIP_ID = 0xd57804b4,
        NATIVE_SET_MISSION_TRAIN_COORDINATES = 0xd57d3c1d,
        NATIVE_CELL_CAM_SET_COLOUR_BRIGHTNESS = 0xd5cb71bc,
        NATIVE_REQUEST_COLLISION_AT_POSN = 0xd5cd7371,
        NATIVE_MARK_CAR_AS_NO_LONGER_NEEDED = 0xd5db8210,
        NATIVE_IS_CAR_A_MISSION_CAR = 0xd5e5fdf7,
        NATIVE_NETWORK_PLAYER_HAS_COMM_PRIVS = 0xd5ecb496,
        NATIVE_RENDER_WEAPON_PICKUPS_BIGGER = 0xd5ee42f9,
        NATIVE_IS_2PLAYER_GAME_GOING_ON = 0xd60115d4,
        NATIVE_IS_CHAR_IN_CAR = 0xd60a5a37,
        NATIVE_GET_DESTROYER_OF_NETWORK_ID = 0xd6473e63,
        NATIVE_GET_OBJECT_COORDINATES = 0xd64ebd35,
        NATIVE_FORCE_LOADING_SCREEN = 0xd6b045df,
        NATIVE_DISPLAY_PLAYBACK_RECORDED_CAR = 0xd6c29810,
        NATIVE_PRINT_WITH_5_NUMBERS_NOW = 0xd6c3188f,
        NATIVE_GET_RANDOM_CAR_IN_SPHERE_NO_SAVE = 0xd6d6d58f,
        NATIVE_GET_CAM_FOV = 0xd6e9fcf5,
        NATIVE_DELETE_OBJECT = 0xd6ef9da7,
        NATIVE_CLEAR_NEWS_SCROLLBAR = 0xd70532e8,
        NATIVE_GET_TRAIN_CABOOSE = 0xd717ad46,
        NATIVE_SET_OBJECT_DYNAMIC = 0xd73719ef,
        NATIVE_SET_CAR_ONLY_DAMAGED_BY_PLAYER = 0xd7448db5,
        NATIVE_ADD_ARMOUR_TO_CHAR = 0xd74c40dd,
        NATIVE_ENABLE_DISABLED_ATTRACTORS_ON_OBJECT = 0xd76daeb0,
        NATIVE_NETWORK_HAVE_ACCEPTED_INVITE = 0xd780795d,
        NATIVE_PLAY_SCRIPTED_CONVERSATION_FRONTEND = 0xd78638e1,
        NATIVE_DID_SAVE_COMPLETE_SUCCESSFULLY = 0xd79c026d,
        NATIVE_NETWORK_SET_LOCAL_PLAYER_CAN_TALK = 0xd7a9cce2,
        NATIVE_SET_CHAR_FIRE_DAMAGE_MULTIPLIER = 0xd7bf444b,
        NATIVE_IS_SITTING_OBJECT_NEAR = 0xd81f06c2,
        NATIVE_GET_ASCII_PRESSED = 0xd85d60ae,
        NATIVE_GET_WATER_HEIGHT = 0xd864e17c,
        NATIVE_SET_START_FROM_FILTER_MENU = 0xd87d1555,
        NATIVE_HAS_OVERRIDEN_SIT_IDLE_ANIM_FINISHED = 0xd8a5d041,
        NATIVE_START_PTFX_ON_OBJ = 0xd8aa4503,
        NATIVE_ATTACH_CAM_TO_OBJECT = 0xd8ad0661,
        NATIVE_CAM_SEQUENCE_WAIT = 0xd8c240c6,
        NATIVE_REMOVE_BLIP = 0xd8c3c1cd,
        NATIVE_SET_GFWL_HAS_SAFE_HOUSE = 0xd8d46d4d,
        NATIVE_SET_PLAYER_CAN_DROP_WEAPONS_IN_CAR = 0xd8e74749,
        NATIVE_TASK_PLAY_ANIM_WITH_ADVANCED_FLAGS = 0xd8e78f1f,
        NATIVE_TASK_OPEN_DRIVER_DOOR = 0xd8e98d45,
        NATIVE_GET_PLAYER_RADIO_STATION_NAME = 0xd909c107,
        NATIVE_TASK_SHIMMY_IN_DIRECTION = 0xd9160aa0,
        NATIVE_TASK_GOTO_CHAR_OFFSET = 0xd918f583,
        NATIVE_SET_CHAR_RANDOM_COMPONENT_VARIATION = 0xd962c873,
        NATIVE_TASK_DEAD = 0xd97fe67a,
        NATIVE_GET_CAR_LIVERY = 0xd9930d1e,
        NATIVE_SET_IK_DISABLED_FOR_NETWORK_PLAYER = 0xd99ce506,
        NATIVE_HAS_OBJECT_COLLIDED_WITH_ANYTHING = 0xd9b3dbc9,
        NATIVE_SCRIPT_ASSERT = 0xd9bcce95,
        NATIVE_CLEAR_ROOM_FOR_DUMMY_CHAR = 0xd9d9f1ea,
        NATIVE_IS_THIS_MACHINE_THE_SERVER = 0xda302665,
        NATIVE_IS_DEBUG_CAMERA_ON = 0xda5fb969,
        NATIVE_PLAY_FIRE_SOUND_FROM_POSITION = 0xda668659,
        NATIVE_GET_MINUTES_OF_DAY = 0xda92d2d5,
        NATIVE_NETWORK_IS_PLAYER_TALKING = 0xda9fd9db,
        NATIVE_ADD_SPAWN_BLOCKING_AREA = 0xdaa55b46,
        NATIVE_SET_SCRIPT_MIC_POSITION = 0xdaad7c95,
        NATIVE_GET_RANDOM_CAR_MODEL_IN_MEMORY = 0xdab49713,
        NATIVE_SET_PED_EXISTS_ON_ALL_MACHINES = 0xdaba6b79,
        NATIVE_GET_CAM_ROT = 0xdac84c9f,
        NATIVE_FAKE_DEATHARREST = 0xdae906b1,
        NATIVE_SETTIMERC = 0xdaec1e1c,
        NATIVE_TASK_SWAP_WEAPON = 0xdaf4f8fc,
        NATIVE_FORCE_CAR_LIGHTS = 0xdb0cdd44,
        NATIVE_THIS_SCRIPT_SHOULD_BE_SAVED = 0xdb0fc3f1,
        NATIVE_SET_ROOM_FOR_CHAR_BY_KEY = 0xdb13ad1b,
        NATIVE_PRINT_HELP_FOREVER_WITH_STRING = 0xdb159d05,
        NATIVE_SET_SUPPRESS_HEADLIGHT_SWITCH = 0xdb288c1d,
        NATIVE_SET_CAM_SHAKE = 0xdb2a65be,
        NATIVE_SET_GROUP_CHAR_DECISION_MAKER = 0xdb2a80fe,
        NATIVE_SET_RANDOM_SEED = 0xdb3feb5c,
        NATIVE_GET_RANDOM_CHAR_IN_AREA_OFFSET_NO_SAVE = 0xdb49b664,
        NATIVE_GET_CORRECTED_COLOUR = 0xdb5ac03e,
        NATIVE_SET_PTFX_CAM_INSIDE_VEHICLE = 0xdb647091,
        NATIVE_RELEASE_TEXTURE = 0xdb7643ac,
        NATIVE_ATTACH_OBJECT_TO_PED = 0xdb806b1d,
        NATIVE_SWITCH_PED_PATHS_OFF = 0xdb86cfd0,
        NATIVE_DISABLE_POLICE_SCANNER = 0xdb9db160,
        NATIVE_PLAYSTATS_FLOAT = 0xdba09488,
        NATIVE_RENDER_RACE_TRACK = 0xdba37931,
        NATIVE_SET_CAM_STATE = 0xdba62a7c,
        NATIVE_DISPLAY_NON_MINIGAME_HELP_MESSAGES = 0xdbd36a26,
        NATIVE_CHANGE_CAR_COLOUR = 0xdbe7f83d,
        NATIVE_GET_ANGLE_BETWEEN_2D_VECTORS = 0xdbf75e58,
        NATIVE_SET_CAR_ANIM_CURRENT_TIME = 0xdbfc615b,
        NATIVE_IS_MOUSE_BUTTON_JUST_PRESSED = 0xdc23f798,
        NATIVE_GET_CLOSEST_MAJOR_CAR_NODE = 0xdc5ff07e,
        NATIVE_TRIGGER_LOADING_MUSIC_ON_NEXT_FADE = 0xdc7146e2,
        NATIVE_SET_CHAR_DUCKING_TIMED = 0xdc759f24,
        NATIVE_TASK_USE_NEAREST_SCENARIO_TO_POS_WARP = 0xdc78ab7a,
        NATIVE_CHANGE_BLIP_SCALE = 0xdc8c2e35,
        NATIVE_SET_CAN_RESPRAY_CAR = 0xdcd232cb,
        NATIVE_NETWORK_SET_TALKER_FOCUS = 0xdcdac012,
        NATIVE_IS_MOUSE_BUTTON_PRESSED = 0xdcf83c08,
        NATIVE_STOP_PROFILE_TIMER = 0xdcfca5f4,
        NATIVE_SET_PED_WONT_ATTACK_PLAYER_WITHOUT_WANTED_LEVEL = 0xdcfddc9c,
        NATIVE_RESURRECT_NETWORK_PLAYER = 0xdd08d07a,
        NATIVE_IS_VEH_DRIVEABLE = 0xdd161a1a,
        NATIVE_DRAW_RECT = 0xdd2bfc77,
        NATIVE_NETWORK_GET_FRIENDLY_FIRE_OPTION = 0xdd34e60c,
        NATIVE_GET_BLIP_COLOUR = 0xdd6a1e54,
        NATIVE_GET_INTERIOR_FROM_CAR = 0xdd834626,
        NATIVE_IS_CHAR_SWIMMING = 0xdd89eee8,
        NATIVE_GET_NUM_STREAMING_REQUESTS = 0xdda8f000,
        NATIVE_SET_GPS_REMAINS_WHEN_TARGET_REACHED_FLAG = 0xdde761b2,
        NATIVE_SPECIFY_SCRIPT_POPULATION_ZONE_NUM_SCENARIO_PEDS = 0xde0a52c0,
        NATIVE_ALLOW_TARGET_WHEN_INJURED = 0xde11760c,
        NATIVE_TASK_TOGGLE_PED_THREAT_SCANNER = 0xde2eb558,
        NATIVE_GET_ID_OF_THIS_THREAD = 0xde524830,
        NATIVE_GET_PED_PATH_MAY_USE_CLIMBOVERS = 0xde6ed972,
        NATIVE_OPEN_CAR_DOOR = 0xde6f6ea7,
        NATIVE_IS_NUMLOCK_ENABLED = 0xde8b83b4,
        NATIVE_FIND_PRIMARY_POPULATION_ZONE_GROUP = 0xde97c33c,
        NATIVE_BEGIN_PED_QUEUE_MEMBERSHIP_LIST = 0xdeab7a3c,
        NATIVE_DOES_SCRIPT_EXIST = 0xdeab87ab,
        NATIVE_IS_RADIO_HUD_ON = 0xdef24cbd,
        NATIVE_TASK_COMBAT_HATED_TARGETS_IN_AREA = 0xdf099e18,
        NATIVE_REMOVE_IPL = 0xdf7cbd36,
        NATIVE_SET_OBJECT_ANIM_CURRENT_TIME = 0xdfa5ad5a,
        NATIVE_SET_PLAYER_INVINCIBLE = 0xdfb9a2a2,
        NATIVE_SET_TRAIN_SPEED = 0xdfc35e4d,
        NATIVE_TASK_CAR_DRIVE_TO_COORD = 0xdfe16cce,
        NATIVE_SET_BLOCKING_OF_NON_TEMPORARY_EVENTS = 0xdfe34e4a,
        NATIVE_IS_OBJECT_IN_AREA_3D = 0xdff98e28,
        NATIVE_HAS_CHAR_BEEN_ARRESTED = 0xe01ab5e0,
        NATIVE_IS_GERMAN_VERSION = 0xe023a0ad,
        NATIVE_UNATTACH_CAM = 0xe02de912,
        NATIVE_GET_CHAR_DRAWABLE_VARIATION = 0xe03f58dc,
        NATIVE_CLEAR_CHAR_LAST_WEAPON_DAMAGE = 0xe0586999,
        NATIVE_LOCATE_CHAR_ANY_MEANS_CHAR_2D = 0xe08869e5,
        NATIVE_SET_OBJECT_HEADING = 0xe094e341,
        NATIVE_DOES_OBJECT_EXIST_WITH_NETWORK_ID = 0xe09ad5ce,
        NATIVE_ADD_GROUP_DECISION_MAKER_EVENT_RESPONSE = 0xe09e6893,
        NATIVE_NETWORK_IS_FRIEND_ONLINE = 0xe0a42430,
        NATIVE_TASK_TURN_CHAR_TO_FACE_COORD = 0xe0ed9289,
        NATIVE_SET_SENSE_RANGE = 0xe0fa2400,
        NATIVE_TELL_NET_PLAYER_TO_START_PLAYING = 0xe1027b43,
        NATIVE_NETWORK_AM_I_MUTED_BY_PLAYER = 0xe128f2b0,
        NATIVE_ADD_TO_WIDGET_COMBO = 0xe136e83e,
        NATIVE_IS_PLAYER_PLAYING = 0xe15d777f,
        NATIVE_SET_CHAR_ANIM_PLAYING_FLAG = 0xe15f39a7,
        NATIVE_ADD_TEXT_WIDGET = 0xe178aa0f,
        NATIVE_CHANGE_BLIP_NAME_TO_PLAYER_NAME = 0xe179712b,
        NATIVE_SET_MOBILE_PHONE_RADIO_STATE = 0xe1e0ed34,
        NATIVE_SET_HOT_WEAPON_SWAP = 0xe1e8530b,
        NATIVE_MARK_MODEL_AS_NO_LONGER_NEEDED = 0xe1fe3fdf,
        NATIVE_SET_OBJECT_INITIAL_VELOCITY = 0xe20c80e4,
        NATIVE_EXP = 0xe2313450,
        NATIVE_PRELOAD_STREAM = 0xe2370818,
        NATIVE_HAS_OBJECT_BEEN_PHOTOGRAPHED = 0xe23973a5,
        NATIVE_NETWORK_LEAVE_GAME = 0xe269a5ef,
        NATIVE_REQUEST_SCRIPT = 0xe26b2666,
        NATIVE_SET_TEXT_CENTRE = 0xe26d39a1,
        NATIVE_SET_TRAIN_IS_STOPPED_AT_STATION = 0xe276a20d,
        NATIVE_SET_NM_MESSAGE_FLOAT = 0xe2959702,
        NATIVE_IS_OUR_PLAYER_HIGHER_PRIORITY_FOR_CAR_GENERATION = 0xe2af6d4e,
        NATIVE_WARP_CHAR_INTO_CAR = 0xe2afccba,
        NATIVE_PAUSE_SCRIPTED_CONVERSATION = 0xe2c9c6f8,
        NATIVE_REMOVE_NAVMESH_REQUIRED_REGION = 0xe33208d6,
        NATIVE_HAS_RELOADED_WITH_MOTION_CONTROL = 0xe338b363,
        NATIVE_STOP_RECORDING_CAR = 0xe361a220,
        NATIVE_FREEZE_POSITION_OF_CLOSEST_OBJECT_OF_TYPE = 0xe3709d6d,
        NATIVE_SET_FOLLOW_PED_PITCH_LIMIT_DOWN = 0xe37975ae,
        NATIVE_ARE_ENEMY_PEDS_IN_AREA = 0xe3cdf209,
        NATIVE_GET_STAT_FRONTEND_DISPLAY_TYPE = 0xe3d34da2,
        NATIVE_CHANGE_PLAYER_PHONE_MODEL = 0xe3d97806,
        NATIVE_PRINT_STRING_WITH_TWO_LITERAL_STRINGS = 0xe3ee933a,
        NATIVE_GET_ROOM_NAME_FROM_CHAR_DEBUG = 0xe410e242,
        NATIVE_GET_NTH_CLOSEST_CAR_NODE_WITH_HEADING = 0xe43be593,
        NATIVE_SET_RICH_PRESENCE_TEMPLATEMP1 = 0xe43f303f,
        NATIVE_ARE_TAXI_LIGHTS_ON = 0xe4518021,
        NATIVE_SET_CHAR_WATCH_MELEE = 0xe45bcaef,
        NATIVE_ALLOW_THIS_SCRIPT_TO_BE_PAUSED = 0xe45dd496,
        NATIVE_SET_CAM_INHERIT_ROLL_VEHICLE = 0xe4bd5342,
        NATIVE_CLEAR_AREA_OF_CARS = 0xe4e9602c,
        NATIVE_TASK_START_SCENARIO_IN_PLACE = 0xe50d6dde,
        NATIVE_TRIGGER_VIGILANTE_CRIME = 0xe5263a3d,
        NATIVE_CLEAR_PLAYER_HAS_DAMAGED_AT_LEAST_ONE_VEHICLE = 0xe533b795,
        NATIVE_SET_OBJECT_EXISTS_ON_ALL_MACHINES = 0xe53691b8,
        NATIVE_HIGHLIGHT_MENU_ITEM = 0xe54b88f0,
        NATIVE_SET_TEXT_COLOUR = 0xe54dd2c8,
        NATIVE_TASK_CHAR_SLIDE_TO_COORD_AND_PLAY_ANIM = 0xe55f3e86,
        NATIVE_ARE_CREDITS_FINISHED = 0xe5b3f2f5,
        NATIVE_SET_TEXT_INPUT_ACTIVE = 0xe5c046aa,
        NATIVE_START_SCRIPT_CONVERSATION = 0xe5de7d9d,
        NATIVE_MAKE_ROOM_IN_PLAYER_GANG_FOR_MISSION_PEDS = 0xe60928c3,
        NATIVE_SET_TEXT_DROPSHADOW = 0xe6587517,
        NATIVE_DOES_THIS_MINIGAME_SCRIPT_ALLOW_NON_MINIGAME_HELP_MESSAGES = 0xe667a6d1,
        NATIVE_GET_CHAR_GRAVITY = 0xe67d2a53,
        NATIVE_NETWORK_GET_NUM_UNACCEPTED_INVITES = 0xe691321e,
        NATIVE_IS_CAR_IN_AIR_PROPER = 0xe6a991df,
        NATIVE_CLEAR_HELP = 0xe6d85741,
        NATIVE_SET_POLICE_IGNORE_PLAYER = 0xe6de71b7,
        NATIVE_BLOCK_PED_WEAPON_SWITCHING = 0xe6df7715,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_CAUTION = 0xe70d9266,
        NATIVE_TASK_FOLLOW_NAV_MESH_TO_COORD_NO_STOP = 0xe71a3585,
        NATIVE_IS_OBJECT_TOUCHING_OBJECT = 0xe71add6e,
        NATIVE_CREATE_RANDOM_CHAR = 0xe71ede84,
        NATIVE_REMOVE_USER_3D_MARKER = 0xe7352a20,
        NATIVE_START_SCRIPT_FIRE = 0xe7529357,
        NATIVE_GET_SCRIPT_RENDERTARGET_RENDER_ID = 0xe7617459,
        NATIVE_NETWORK_GET_NEXT_TEXT_CHAT = 0xe781880a,
        NATIVE_VMAG2 = 0xe796e629,
        NATIVE_SET_CHAR_FORCE_DIE_IN_CAR = 0xe7b79d67,
        NATIVE_SET_PLAYER_PAIN_ROOT_BANK_NAME = 0xe7b8a712,
        NATIVE_NETWORK_PLAYER_HAS_DIED_RECENTLY = 0xe7ba498e,
        NATIVE_IS_REPLAY_SAVING = 0xe7d91c91,
        NATIVE_NETWORK_GET_MAX_SLOTS = 0xe7da761c,
        NATIVE_OVERRIDE_NUMBER_OF_PARKED_CARS = 0xe7ed0056,
        NATIVE_PICK_RANDOM_WEATHER = 0xe84518ce,
        NATIVE_SET_PED_QUEUE_MEMBERSHIP_LIST = 0xe8580238,
        NATIVE_SET_CAMERA_CONTROLS_DISABLED_WITH_PLAYER_CONTROLS = 0xe858e54c,
        NATIVE_HAS_SOUND_FINISHED = 0xe85aec2e,
        NATIVE_GET_CELLPHONE_RANKED = 0xe8639cc8,
        NATIVE_END_CAM_COMMANDS = 0xe873369b,
        NATIVE_SET_PLAYER_CONTROL_ON_IN_MISSION_CLEANUP = 0xe886e2c5,
        NATIVE_SET_VEH_INDICATORLIGHTS = 0xe887fb73,
        NATIVE_SET_DOOR_STATE = 0xe891d407,
        NATIVE_GET_CURRENT_WEATHER = 0xe89f5b07,
        NATIVE_GET_TIME_SINCE_PLAYER_HIT_BUILDING = 0xe8c58d94,
        NATIVE_SET_OBJECT_PHYSICS_PARAMS = 0xe8d11c58,
        NATIVE_TASK_LOOK_AT_CHAR = 0xe903b45e,
        NATIVE_SET_PED_DIES_WHEN_INJURED = 0xe94e24d4,
        NATIVE_IS_PLAYER_SIGNED_IN_LOCALLY = 0xe95a4dca,
        NATIVE_ADD_POLICE_RESTART = 0xe96c29fe,
        NATIVE_SIMULATE_UPDATE_LOAD_SCENE = 0xe980cee1,
        NATIVE_ENABLE_SHADOWS = 0xe9a0ea2c,
        NATIVE_RELOAD_WEB_PAGE = 0xe9b1b93b,
        NATIVE_SET_PED_GENERATES_DEAD_BODY_EVENTS = 0xe9b97a2b,
        NATIVE_CREATE_CAM = 0xe9bf2a7d,
        NATIVE_CLEAR_THIS_PRINT_BIG_NOW = 0xe9bfbf43,
        NATIVE_SET_CAM_INTERP_DETAIL_ROT_STYLE_QUATS = 0xe9dab58d,
        NATIVE_SET_OVERRIDE_NO_SPRINTING_ON_PHONE_IN_MULTIPLAYER = 0xe9fdda54,
        NATIVE_IS_PED_ATTACHED_TO_OBJECT = 0xea085f14,
        NATIVE_SET_GLOBAL_INSTANCE_PRIORITY = 0xea330e59,
        NATIVE_SWITCH_OFF_WAYPOINT = 0xea373f19,
        NATIVE_STORE_WANTED_LEVEL = 0xea6a8b1c,
        NATIVE_SET_GAME_CAMERA_CONTROLS_ACTIVE = 0xea7c73f2,
        NATIVE_IS_CHAR_RESPONDING_TO_EVENT = 0xea839600,
        NATIVE_NETWORK_RESTORE_GAME_CONFIG = 0xea854794,
        NATIVE_GET_CHAR_EXTRACTED_VELOCITY = 0xea8d828c,
        NATIVE_DELETE_DUMMY_CHAR = 0xeaaded1b,
        NATIVE_GET_PLAYERSETTINGS_MODEL_CHOICE = 0xeaba1f08,
        NATIVE_IS_KEYBOARD_KEY_JUST_PRESSED = 0xeac23998,
        NATIVE_GET_STRING_WIDTH_WITH_NUMBER = 0xeaeb477d,
        NATIVE_GET_TEAM_RGB_COLOUR = 0xeaec3986,
        NATIVE_CREATE_RANDOM_CHAR_AS_PASSENGER = 0xeb333516,
        NATIVE_IS_OBJECT_IN_WATER = 0xeb448f66,
        NATIVE_IS_CHAR_STOPPED = 0xeb4be0f9,
        NATIVE_FIND_TIME_POSITION_IN_RECORDING = 0xeba01b48,
        NATIVE_PRINT_HELP_OVER_FRONTEND = 0xeba5a188,
        NATIVE_GET_IS_WIDESCREEN = 0xec717aef,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_MOVEMENT_STYLE = 0xec80232f,
        NATIVE_TASK_SPACE_SHIP_GO_TO_COORD = 0xec85ce1d,
        NATIVE_GET_DISPLAY_NAME_FROM_VEHICLE_MODEL = 0xec86df39,
        NATIVE_NETWORK_ADVERTISE_SESSION = 0xecdbc615,
        NATIVE_DISPLAY_TEXT_WITH_NUMBER = 0xece5a56d,
        NATIVE_PRINTSTRING = 0xecf8eb5f,
        NATIVE_SET_OBJECT_COORDINATES = 0xed16ed4b,
        NATIVE_IS_PLAYER_PRESSING_HORN = 0xed1d1662,
        NATIVE_IS_THIS_PRINT_BEING_DISPLAYED = 0xed8e2421,
        NATIVE_SET_USE_LEG_IK = 0xedb40066,
        NATIVE_INCREMENT_FLOAT_STAT = 0xedcfc80d,
        NATIVE_CHANGE_BLIP_SPRITE = 0xede22a59,
        NATIVE_GET_SPEECH_FOR_EMERGENCY_SERVICE_CALL = 0xede519d6,
        NATIVE_SET_NETWORK_ID_STOP_CLONING_FOR_ENEMIES = 0xede75bc8,
        NATIVE_ALLOW_MULTIPLE_DRIVEBY_PICKUPS = 0xede8974a,
        NATIVE_SET_OBJECT_COLLISION = 0xedea40e8,
        NATIVE_IS_CHAR_ON_FIRE = 0xee1ad133,
        NATIVE_DISPLAY_TEXT_SUBSTRING = 0xee1af688,
        NATIVE_GET_NUMBER_OF_PASSENGERS = 0xee1d0742,
        NATIVE_SET_OBJECT_SCALE = 0xee3213a4,
        NATIVE_SET_CAM_ROT = 0xee38b3c1,
        NATIVE_SET_CHAR_CAN_SMASH_GLASS = 0xeea0468f,
        NATIVE_GIVE_DELAYED_WEAPON_TO_CHAR = 0xeef7f721,
        NATIVE_IS_FOLLOW_VEHICLE_CAM_OFFSET_ACTIVE = 0xef102f32,
        NATIVE_GET_GAME_CAM = 0xef15c9c4,
        NATIVE_SET_OBJECT_INVINCIBLE = 0xef19eda6,
        NATIVE_ADD_WIDGET_FLOAT_READ_ONLY = 0xef2d8dea,
        NATIVE_TASK_PUT_CHAR_DIRECTLY_INTO_COVER = 0xef38b38d,
        NATIVE_TASK_PLAY_ANIM_SECONDARY_NO_INTERRUPT = 0xef55eae4,
        NATIVE_NETWORK_HAVE_ONLINE_PRIVILEGES = 0xef63bfdf,
        NATIVE_ENABLE_SCENE_STREAMING = 0xef6d0ca9,
        NATIVE_GET_BLIP_COORDS = 0xef6ff47b,
        NATIVE_SET_PED_PATH_MAY_USE_CLIMBOVERS = 0xef821257,
        NATIVE_CHANGE_BLIP_ALPHA = 0xef9c691e,
        NATIVE_CLEAR_THIS_BIG_PRINT = 0xefc037f4,
        NATIVE_BREAKPOINT = 0xefeafb91,
        NATIVE_PROSTITUTE_CAM_ACTIVATE = 0xf0057f38,
        NATIVE_CREATE_PICKUP_ROTATE = 0xf015bfe2,
        NATIVE_SET_WIDESCREEN_FORMAT = 0xf016e08f,
        NATIVE_SET_CHAR_DECISION_MAKER = 0xf01f2210,
        NATIVE_SET_MASK = 0xf03c5117,
        NATIVE_NETWORK_IS_DATA_MODDED = 0xf0451e6b,
        NATIVE_TASK_GOTO_CHAR_AIMING = 0xf05fcda2,
        NATIVE_ADD_OBJECT_TO_INTERIOR_ROOM_BY_KEY = 0xf062047c,
        NATIVE_SET_CHAR_WILL_USE_COVER = 0xf077736e,
        NATIVE_IS_STREAMING_ADDITIONAL_TEXT = 0xf079e4eb,
        NATIVE_SET_NM_ANIM_POSE = 0xf08ce199,
        NATIVE_GET_OBJECT_FRAGMENT_DAMAGE_HEALTH = 0xf0b330ad,
        NATIVE_SET_CHAR_CLIMB_ANIM_RATE = 0xf0bfde7f,
        NATIVE_SET_LOCAL_PLAYER_VOICE = 0xf0d28043,
        NATIVE_IS_IN_PLAYER_SETTINGS_MENU = 0xf0ddd6b5,
        NATIVE_SET_CHAR_DEFAULT_COMPONENT_VARIATION = 0xf0fbef4b,
        NATIVE_GET_OFFSET_FROM_CAR_IN_WORLD_COORDS = 0xf10283ad,
        NATIVE_GET_EPISODE_NAME = 0xf11c0c7b,
        NATIVE_SET_PLAYER_PLAYER_TARGETTING = 0xf12a7f7d,
        NATIVE_LOAD_ADDITIONAL_TEXT = 0xf133aed9,
        NATIVE_SELECT_WEAPONS_FOR_VEHICLE = 0xf1703b5b,
        NATIVE_REGISTER_CLIENT_BROADCAST_VARIABLES = 0xf1732769,
        NATIVE_SET_VIEWPORT = 0xf1b55809,
        NATIVE_GET_KEY_FOR_DUMMY_CHAR_IN_ROOM = 0xf1b5e707,
        NATIVE_DONT_REMOVE_OBJECT = 0xf1c269b2,
        NATIVE_ADD_NEW_CONVERSATION_SPEAKER = 0xf1c40bca,
        NATIVE_SWITCH_RANDOM_TRAINS = 0xf1c67552,
        NATIVE_SET_GROUP_COMBAT_DECISION_MAKER = 0xf1ccfbb1,
        NATIVE_GET_CHAR_ANIM_IS_EVENT = 0xf1eb1f61,
        NATIVE_GET_NEAREST_CABLE_CAR = 0xf2218830,
        NATIVE_SET_CAR_ALWAYS_CREATE_SKIDS = 0xf22c2166,
        NATIVE_IS_CAM_HAPPY = 0xf2432971,
        NATIVE_RESET_CAM_INTERP_CUSTOM_SPEED_GRAPH = 0xf25e9d0b,
        NATIVE_FLUSH_ALL_SPAWN_BLOCKING_AREAS = 0xf25eca71,
        NATIVE_SET_CAM_NEAR_DOF = 0xf28254df,
        NATIVE_SET_BLIP_AS_FRIENDLY = 0xf290cfd8,
        NATIVE_FREEZE_OBJECT_POSITION_AND_DONT_LOAD_COLLISION = 0xf29ff744,
        NATIVE_GET_CAR_SPEED = 0xf2a1769d,
        NATIVE_NEW_MOBILE_PHONE_CALL = 0xf2ff08c5,
        NATIVE_LOCAL_PLAYER_IS_READY_TO_START_PLAYING = 0xf3411db1,
        NATIVE_DONT_ABORT_CAR_CONVERSATIONS = 0xf34d8674,
        NATIVE_HIDE_HELP_TEXT_THIS_FRAME = 0xf3807bed,
        NATIVE_SET_CHAR_DIES_INSTANTLY_IN_WATER = 0xf3824c5d,
        NATIVE_IS_PLAYER_TARGETTING_CHAR = 0xf3cbb110,
        NATIVE_HINT_CAM = 0xf3cf24c1,
        NATIVE_SET_CHAR_USES_UPPERBODY_DAMAGE_ANIMS_ONLY = 0xf3fd6253,
        NATIVE_ACOS = 0xf4038776,
        NATIVE_IS_CHAR_TOUCHING_OBJECT_ON_FOOT = 0xf423c94d,
        NATIVE_GENERATE_RANDOM_FLOAT = 0xf458a37a,
        NATIVE_GET_CLOSEST_CAR_NODE_WITH_HEADING = 0xf467ec57,
        NATIVE_GET_CREATE_RANDOM_COPS = 0xf48028fb,
        NATIVE_DRAW_SPRITE_FRONT_BUFF = 0xf4963043,
        NATIVE_SET_TEXT_PROPORTIONAL = 0xf49d8a08,
        NATIVE_START_OBJECT_FIRE = 0xf4a12bfd,
        NATIVE_SET_PLAYER_CAN_DO_DRIVE_BY = 0xf4d99685,
        NATIVE_MAKE_OBJECT_TARGETTABLE = 0xf4da430f,
        NATIVE_FORCE_AIR_DRAG_MULT_FOR_PLAYERS_CAR = 0xf4da8f96,
        NATIVE_IS_HELI_PART_BROKEN = 0xf4e4c439,
        NATIVE_CREATE_CHECKPOINT = 0xf541b690,
        NATIVE_GET_ANIM_GROUP_FROM_CHAR = 0xf547f9b8,
        NATIVE_DELETE_ALL_HTML_SCRIPT_OBJECTS = 0xf54b51a1,
        NATIVE_RENDER_RADIOHUD_SPRITE_IN_LOBBY = 0xf55bdb0e,
        NATIVE_DRAW_MOVIE = 0xf563194b,
        NATIVE_NETWORK_IS_COMMON_EPISODE = 0xf599d235,
        NATIVE_RESET_HEALTH_PICKUP_NETWORK_REGEN_TIME = 0xf5bc8229,
        NATIVE_GET_CAR_FORWARD_VECTOR = 0xf5d836e3,
        NATIVE_CLEAR_ROOM_FOR_VIEWPORT = 0xf5e3490c,
        NATIVE_FINISH_STREAMING_REQUEST_LIST = 0xf5f30a8a,
        NATIVE_MAINTAIN_FLASHING_STAR_AFTER_OFFENCE = 0xf63c8929,
        NATIVE_GET_OBJECT_TURN_MASS = 0xf6649d27,
        NATIVE_NETWORK_GET_UNACCEPTED_INVITE_GAME_MODE = 0xf66bcd00,
        NATIVE_SET_TEAM_COLOUR = 0xf6839e86,
        NATIVE_WINCH_CAN_PICK_OBJECT_UP = 0xf694198a,
        NATIVE_FAIL_KILL_FRENZY = 0xf6cb6fdd,
        NATIVE_ENABLE_SAVE_HOUSE = 0xf6f77c6c,
        NATIVE_COPY_GROUP_COMBAT_DECISION_MAKER = 0xf6fb5886,
        NATIVE_SET_PED_DONT_DO_EVASIVE_DIVES = 0xf708995b,
        NATIVE_SET_UP_TRIP_SKIP_FOR_SPECIFIC_VEHICLE = 0xf70c4170,
        NATIVE_IS_CAR_WAITING_FOR_WORLD_COLLISION = 0xf718f943,
        NATIVE_CLEAR_ONSCREEN_TIMER = 0xf72ed471,
        NATIVE_GET_NETWORK_TIMER = 0xf733052c,
        NATIVE_BLEND_OUT_CHAR_MOVE_ANIMS = 0xf7764cec,
        NATIVE_IS_NON_FRAG_OBJECT_SMASHED = 0xf7ae77b6,
        NATIVE_CLEAR_CHAR_PROP = 0xf7b017d7,
        NATIVE_IS_CAR_IN_GARAGE_AREA = 0xf7c3f8c9,
        NATIVE_GET_GROUP_SIZE = 0xf7e1a691,
        NATIVE_CANCEL_OVERRIDE_RESTART = 0xf7eb1414,
        NATIVE_GET_LINE_HEIGHT = 0xf7fc5794,
        NATIVE_SET_PED_FORCE_FLY_THROUGH_WINDSCREEN = 0xf7fdd0f1,
        NATIVE_SET_ROTATION_FOR_ATTACHED_PED = 0xf85ce5fb,
        NATIVE_IS_CHAR_IN_ZONE = 0xf8671738,
        NATIVE_IS_THIS_MODEL_A_TRAIN = 0xf87dcffd,
        NATIVE_SET_EXTRA_POLICE_STATION_RESTART_POINT = 0xf8bcf4ac,
        NATIVE_SET_CAM_PROPAGATE = 0xf8d2e99a,
        NATIVE_IS_CHAR_SHOOTING_IN_AREA = 0xf8dc76d9,
        NATIVE_FLUSH_COVER_BLOCKING_AREAS = 0xf8e51a3f,
        NATIVE_OBFUSCATE_INT = 0xf9019ce0,
        NATIVE_TASK_SHOOT_AT_CHAR = 0xf90f36c4,
        NATIVE_TASK_GO_TO_COORD_ANY_MEANS = 0xf91df93b,
        NATIVE_ADD_BLIP_FOR_CAR = 0xf929bad5,
        NATIVE_PLAYSTATS_MISSION_PASSED = 0xf94144f2,
        NATIVE_SET_DECISION_MAKER_ATTRIBUTE_FIRE_RATE = 0xf95f3ec1,
        NATIVE_IS_GROUP_LEADER = 0xf95ff468,
        NATIVE_SET_OBJECT_CCD = 0xf993b6f0,
        NATIVE_HAS_CUTSCENE_LOADED = 0xf9998582,
        NATIVE_GET_OBJECT_HEALTH = 0xf9d59802,
        NATIVE_RESET_VISIBLE_PED_DAMAGE = 0xfa19568c,
        NATIVE_REMOVE_PTFX_FROM_PED = 0xfa481384,
        NATIVE_IS_MOUSE_USING_VERTICAL_INVERSION = 0xfa497d4a,
        NATIVE_ADD_FIRST_N_CHARACTERS_OF_STRING_TO_HTML_SCRIPT_OBJECT = 0xfa537bb7,
        NATIVE_TASK_PERFORM_SEQUENCE_FROM_PROGRESS = 0xfa60601b,
        NATIVE_DOES_SCENARIO_EXIST_IN_AREA = 0xfa7f5047,
        NATIVE_INCREMENT_INT_STAT = 0xface6b52,
        NATIVE_GET_NEXT_CLOSEST_CAR_NODE_WITH_HEADING = 0xfaf8ed9c,
        NATIVE_NETWORK_ACCEPT_INVITE = 0xfb31fa9c,
        NATIVE_ADD_CHAR_DECISION_MAKER_EVENT_RESPONSE = 0xfb371773,
        NATIVE_SET_CHAR_ROTATION = 0xfb3df112,
        NATIVE_IS_EXPLOSION_IN_AREA = 0xfb40075b,
        NATIVE_FLASH_BLIP_ALT = 0xfb49cbd8,
        NATIVE_GET_INTERIOR_HEADING = 0xfb56d1ac,
        NATIVE_NETWORK_CHANGE_GAME_MODE_SUCCEEDED = 0xfba800bc,
        NATIVE_TASK_ENTER_CAR_AS_PASSENGER = 0xfbc81da4,
        NATIVE_SET_PLAYER_CONTROL_FOR_AMBIENT_SCRIPT = 0xfbd342f5,
        NATIVE_SWAP_NEAREST_BUILDING_MODEL = 0xfbd8341b,
        NATIVE_SKIP_IN_PLAYBACK_RECORDED_CAR = 0xfbe6e975,
        NATIVE_TASK_AIM_GUN_AT_COORD = 0xfbf44ad3,
        NATIVE_SET_ZONE_POPULATION_TYPE = 0xfc30948b,
        NATIVE_GET_ROOM_KEY_FROM_OBJECT = 0xfc452887,
        NATIVE_DISPLAY_TEXT = 0xfc4541b5,
        NATIVE_TASK_DESTROY_CAR = 0xfc4a0595,
        NATIVE_GET_PED_AT_HEAD_OF_QUEUE = 0xfc6991ef,
        NATIVE_GET_DOOR_STATE = 0xfc7f163b,
        NATIVE_MAKE_PLAYER_SAFE_FOR_CUTSCENE = 0xfc90ac18,
        NATIVE_NETWORK_GET_HOST_MATCH_PROGRESS = 0xfcdc7c26,
        NATIVE_SET_CAR_CAN_BE_DAMAGED = 0xfcf9e81a,
        NATIVE_GET_VEHICLE_DIRT_LEVEL = 0xfd15c065,
        NATIVE_GET_SPAWN_COORDINATES_FOR_CAR_NODE = 0xfd7281bf,
        NATIVE_START_PTFX_ON_PED = 0xfd749e83,
        NATIVE_SET_CAR_ON_GROUND_PROPERLY = 0xfda951d9,
        NATIVE_SET_CHAR_PROVIDE_COVERING_FIRE = 0xfdd1b30b,
        NATIVE_ENABLE_ALL_PED_HELMETS = 0xfdead03b,
        NATIVE_IS_PED_IN_COMBAT = 0xfe027cb5,
        NATIVE_GET_CAR_ANIM_TOTAL_TIME = 0xfe080f08,
        NATIVE_ADD_TO_PREVIOUS_BRIEF = 0xfe33cf4a,
        NATIVE_TASK_FOLLOW_NAV_MESH_TO_COORD = 0xfe4a10d9,
        NATIVE_REGISTER_KILL_IN_MULTIPLAYER_GAME = 0xfe86190e,
        NATIVE_NETWORK_IS_FIND_RESULT_UPDATED = 0xfe8b2d06,
        NATIVE_HAS_CHAR_BEEN_DAMAGED_BY_CHAR = 0xfecba916,
        NATIVE_UNPOINT_CAM = 0xfecee341,
        NATIVE_TASK_GO_TO_COORD_WHILE_AIMING = 0xfee5e095,
        NATIVE_IS_CHAR_TOUCHING_OBJECT = 0xfefbd10a,
        NATIVE_GET_CHAR_EXTRACTED_DISPLACEMENT = 0xff1ca4e4,
        NATIVE_NETWORK_GET_MAX_PRIVATE_SLOTS = 0xff2121de,
        NATIVE_GET_CHAR_MONEY = 0xff316392,
        NATIVE_SET_CELLPHONE_RANKED = 0xff41eaad,
        NATIVE_DRAW_CORONA = 0xff44780e,
        NATIVE_TASK_CAR_MISSION_NOT_AGAINST_TRAFFIC = 0xff4bd0a2,
        NATIVE_CLEAR_ONSCREEN_COUNTER = 0xff50e239,
        NATIVE_TASK_SHIMMY_LET_GO = 0xff68ae92,
        NATIVE_STOP_PED_SPEAKING = 0xff92b49d,
        NATIVE_SET_PED_ALLOW_MISSION_ONLY_DRIVEBY_USE = 0xff94f468,
        NATIVE_SET_CHAR_DECISION_MAKER_TO_DEFAULT = 0xff9bc6c6,
        NATIVE_SET_CAM_POS = 0xffbd14c8,
        NATIVE_IS_CHAR_IN_WATER = 0xffd4d14e,
        NATIVE_ENABLE_END_CREDITS_FADE = 0xffd90047,
        NATIVE_GET_OFFSETS_FOR_ATTACH_CAR_TO_CAR = 0xffdfb89e,
        NATIVE_GET_CLOSEST_NETWORK_RESTART_NODE = 0xfff0e04a,
        NATIVE_REQUEST_MODEL = 0xfff1b500,
        NATIVE_HAS_CHAR_SPOTTED_CHAR = 0xfff5f5e3,
        NATIVE_TASK_SEEK_COVER_TO_COORDS = 0xfffe754e,
    };

    // The following natives really do nothing and are unsupported 
    // if used in GTAIV patch 5 or newer (will produce an error 
    // message or hang or crash)
    enum NativeHashesPreU5
    {
        NATIVE_SET_FREE_HEALTH_CARE = 0xad880e,
        NATIVE_TASK_HOLSTERING_WEAPON = 0x35b7828,
        NATIVE_START_SCRIPTED_CONVERSATION = 0x7e4cb1e,
        NATIVE_FAST_FORWARD_TO_NEXT_BUS_STOP = 0xa7d2e7f,
        NATIVE_IS_RUNNING_NETWORK_SCRIPT = 0xcdafc3e,
        NATIVE_CREATE_LOCKED_PROPERTY_PICKUP = 0xcf0f9eb,
        NATIVE_IS_CHAR_HEAD_MISSING = 0xd1e0327,
        NATIVE_START_RECORDING_CAR = 0xe458ed7,
        NATIVE_SET_ONLY_CREATE_RANDOM_GANG_MEMBERS = 0xfcce1d7,
        NATIVE_SET_CAR_CAN_GO_AGAINST_TRAFFIC = 0xff41401,
        NATIVE_TASK_WEAPON_ROLL = 0x123b2716,
        NATIVE_ARE_MEASUREMENTS_IN_METRES = 0x145d8f6d,
        NATIVE_IS_CHAR_HOLDING_OBJECT = 0x1c51aa94,
        NATIVE_SET_CAR_LIGHTS_ON = 0x22888c5a,
        NATIVE_STORE_CAR_CHAR_IS_IN = 0x25d4ba34,
        NATIVE_TASK_WALK_ALONGSIDE_CHAR = 0x2a70e5d1,
        NATIVE_ALLOW_ALL_CHAR_PROPS = 0x2b7b71b9,
        NATIVE_GIVE_CONTROL_OF_NETWORK_ID_TO_CLIENT = 0x2bdadf3f,
        NATIVE_GET_RANDOM_CAR_OF_TYPE_IN_AREA = 0x2e774002,
        NATIVE_START_CHAR_FACIAL_TALK = 0x306c1251,
        NATIVE_TASK_HAND_GESTURE = 0x326d19be,
        NATIVE_SET_LOCK_STATE_OF_CLOSEST_OBJECT_OF_TYPE = 0x34ff4544,
        NATIVE_CLEAR_WANTED_LEVEL_IN_GARAGE = 0x3549079c,
        NATIVE_GET_PLAYER_POINTS = 0x38111c8b,
        NATIVE_SET_CREATE_RANDOM_GANG_MEMBERS = 0x3adc6d2d,
        NATIVE_TASK_DIVE_FROM_ATTACHMENT_AND_GET_UP = 0x3cc1e74a,
        NATIVE_LOCK_DOOR = 0x4083e337,
        NATIVE_CLEAR_ALL_SCRIPT_FIRE_FLAGS = 0x40dbaa55,
        NATIVE_RESTRICT_CHAR_PROPS = 0x46e6a215,
        NATIVE_REMOVE_ALL_SCRIPT_FIRES = 0x488cbb60,
        NATIVE_FIND_TIME_POSITION_IN_RECORDED_RECORDING = 0x48e1bd60,
        NATIVE_TASK_FLEE_POINT = 0x49f75bd8,
        NATIVE_NETWORK_IS_SESSION_ADVERTISED = 0x4a0791a1,
        NATIVE_FINISH_SETTING_UP_CONVERSATION_NO_SUBTITLES = 0x4d1c3395,
        NATIVE_SET_CAR_HYDRAULICS = 0x4f0001f3,
        NATIVE_REGISTER_MISSION_GIVEN = 0x4f237f7b,
        NATIVE_IS_PLAYER_IN_POSITION_FOR_CONVERSATION = 0x523284a3,
        NATIVE_SET_GANG_WEAPONS = 0x53bfa346,
        NATIVE_LOAD_GROUP_DECISION_MAKER = 0x67b13af7,
        NATIVE_SET_VEHICLE_AREA_VISIBLE = 0x69ed5662,
        NATIVE_SET_SCRIPT_FIRE_AUDIO = 0x6dffbcd0,
        NATIVE_SET_GROUP_DEFAULT_TASK_ALLOCATOR = 0x759f531f,
        NATIVE_AWARD_NETWORK_POINTS = 0x7645e867,
        NATIVE_IS_CAR_VISIBLY_DAMAGED = 0x7a81b369,
        NATIVE_IS_CONVERSATION_AT_NODE = 0x7c6452dc,
        NATIVE_CAN_PED_DO_SHIMMY_HERE = 0x80a11e7d,
        NATIVE_RETURN_CONTROL_OF_NETWORK_ID_TO_SERVER = 0x83013662,
        NATIVE_SET_NETWORK_ID_STOP_SYNCING = 0x8d1404c1,
        NATIVE_SET_MELEE_ACTION_SENSE_RANGE_FOR_RIOT2 = 0x8e4a6b0d,
        NATIVE_SET_UP_CONVERSATION_NODE_WITH_SCRIPTED_SPEECH = 0x927ccc6e,
        NATIVE_CREATE_PROTECTION_PICKUP = 0x93599cb8,
        NATIVE_START_CAR_FIRE = 0x94bc3dce,
        NATIVE_HAS_TRAIN_DERAILED = 0x961212cb,
        NATIVE_IS_TRIP_SKIP_WAITING_FOR_SCRIPT_TO_FADE_IN = 0x9c65d24a,
        NATIVE_SET_UP_CONVERSATION_END_NODE_WITH_SCRIPTED_SPEECH = 0x9efee2ef,
        NATIVE_TASK_COMPLEX_PICKUP_OBJECT = 0xa1a22a1e,
        NATIVE_TELEPORT_PLAYER_NEAR_BUS = 0xa48f307e,
        NATIVE_GET_TOTAL_NUMBER_OF_PEDS_KILLED_BY_PLAYER = 0xb29af78f,
        NATIVE_IMPROVE_CAR_BY_CHEATING = 0xb63baf8d,
        NATIVE_SET_GROUP_DECISION_MAKER = 0xb7f9858f,
        NATIVE_FINISH_SETTING_UP_CONVERSATION = 0xbade4d05,
        NATIVE_TASK_FLEE_CHAR = 0xbb159b12,
        NATIVE_IS_IN_ATTRACT_MODE = 0xbc3e1f60,
        NATIVE_DOES_CAMERA_EXIST_WITH_NETWORK_ID = 0xbe9f9d50,
        NATIVE_GIVE_MELEE_ATTACK_TO_CHAR = 0xc38ae12c,
        NATIVE_STOP_PROPAGATING_CAM_TO_NET_PLAYER = 0xc902adf1,
        NATIVE_TASK_GREET_PARTNER = 0xcdc2f849,
        NATIVE_ENSURE_PLAYER_HAS_DRIVE_BY_WEAPON = 0xd2827a30,
        NATIVE_TASK_LOOK_ABOUT = 0xd2d39dee,
        NATIVE_CLEAR_CONVERSATION_FOR_CHAR = 0xd483bb11,
        NATIVE_SET_CAR_HEAVY = 0xd4da017d,
        NATIVE_SET_CHAR_HAS_BEEN_CREATED_IN_INTERIOR = 0xd58baa34,
        NATIVE_CREATE_FORSALE_PROPERTY_PICKUP = 0xd680ba44,
        NATIVE_IS_PLAYER_USING_JETPACK = 0xdb23a75a,
        NATIVE_ARE_ANY_CAR_CHEATS_ACTIVATED = 0xdc8f8d34,
        NATIVE_UPDATE_PICKUP_MONEY_PER_DAY = 0xe2a80711,
        NATIVE_SET_ALL_TAXIS_HAVE_NITRO = 0xe3ed03e6,
        NATIVE_TASK_DIVE_AND_GET_UP = 0xe620622d,
        NATIVE_STOP_RECORDING_CARS = 0xecdf8dbd,
        NATIVE_TASK_SCRATCH_HEAD = 0xed625c16,
        NATIVE_SET_UP_CONVERSATION_END_NODE_WITH_SPEECH = 0xf32973f4,
        NATIVE_STOP_CHAR_FACIAL_TALK = 0xf3760c11,
        NATIVE_PROPAGATE_CAM_TO_NET_PLAYER = 0xfa5ac4ab,
        NATIVE_ENABLE_CONVERSATION = 0xfc15d5f3,
        NATIVE_START_SETTING_UP_CONVERSATION = 0xfc2ee353,
        NATIVE_FORCE_AIR_DRAG_MULT = 0xfd24e0c2,
        NATIVE_TASK_HOLD_OBJECT = 0xfe8dfd1a,
    };

}